/*
 * SalomeTMF is a Test Management Framework
 * Copyright (C) 2005 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @author Fayçal SOUGRATI, Vincent Pautret, Marche Mikael
 *
 * Contact: mikael.marche@rd.francetelecom.com
 */


package salomeTMF_plug.cronExec;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.java.plugin.ExtensionPoint;
import org.java.plugin.Plugin;
import org.java.plugin.PluginDescriptor;
import org.java.plugin.PluginManager;
import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.ihm.main.SalomeTMFContext;
import org.objectweb.salome_tmf.plugins.UICompCst;
import org.objectweb.salome_tmf.plugins.core.Common;

import salomeTMF_plug.cronExec.languages.Language;


/**
 *
 * @author  marchemi
 */
public class CronExecPlugin extends Plugin implements  Common {

    
	boolean alreadyCron = false;
	
	CronTimer timer = null;
	
	JButton cronButton = null;
	
	/** Creates a new instance of cronExecPlugin */
    public CronExecPlugin(PluginManager manager, PluginDescriptor descr) {
        super(manager, descr);
    }

    /********************* extends Plugin**********************************/
    
    /**
     * @see org.java.plugin.Plugin()
     */
    protected void doStart() throws Exception {
         Util.log("[cronExecPlugin:doStart] chargement du plugin");
    }

    /**
     * @see org.java.plugin.Plugin()
     */
    protected void doStop() throws Exception {
        // no-op
    }
   
   //********************* interface common ********************//

   public void activatePluginInCampToolsMenu(javax.swing.JMenu jMenu) {
   }
   
   public void activatePluginInDataToolsMenu(javax.swing.JMenu jMenu) {
   }
   
   public void activatePluginInDynamicComponent(Integer integer) {
   }
   
   public void activatePluginInStaticComponent(Integer integer) {
   	
   	JPanel cronExecPanel = (JPanel)SalomeTMFContext.getInstance().getUIComponent(integer);
   	
   	cronButton = new JButton("");
   	cronButton.setToolTipText(Language.getInstance().getText("Cron_executions"));
   	cronButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/salomeTMF_plug/cronExec/resources/cron_off.gif")));
    
   	cronButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        	if (alreadyCron) {
        		Object[] options = {Language.getInstance().getText("Oui"), Language.getInstance().getText("Non")};
        		int choice = JOptionPane.showOptionDialog(SalomeTMFContext.getInstance().getSalomeFrame(),
        	            Language.getInstance().getText("Des_executions_sont_deja_programmees_pour_etre_lancees") +
        	            Language.getInstance().getText("Voulez_vous_annuler_ces_executions_et_recommencer"),
        	            Language.getInstance().getText("Attention_"),
        	            JOptionPane.YES_NO_OPTION,
        	            JOptionPane.WARNING_MESSAGE,
        	            null,
        	            options,
        	            options[1]);
        		if (choice == JOptionPane.YES_OPTION) {
        			if (timer != null) {
        				timer.cancel();
        				timer = new CronTimer(CronExecPlugin.this);
        			} else {
        				timer = new CronTimer(CronExecPlugin.this);
        			}
        			new ExecChooser(CronExecPlugin.this, timer);
        		}
        	} else {
        		if (timer != null) {
    				timer.cancel();
    				timer = new CronTimer(CronExecPlugin.this);
    			} else {
    				timer = new CronTimer(CronExecPlugin.this);
    			}
        		new ExecChooser(CronExecPlugin.this, timer);
        	}
        }
    });
    
    cronExecPanel.add(cronButton);
   }
   
   public void activatePluginInTestToolsMenu(javax.swing.JMenu jMenu) {
   }
   
   public void freeze() {
   }
   
   public java.util.Vector getUsedUIComponents() {
   	Vector uiComponentsUsed = new Vector();
    
    uiComponentsUsed.add(0,UICompCst.CAMP_FIRST_BUTTONS_PANEL);
    
    return uiComponentsUsed;
   }
   
   public void init(Object pIhm) {
   }
   
   public boolean isActivableInCampToolsMenu() {
       	return false;
   }
   
   public boolean isActivableInDataToolsMenu() {
        return false;
   }
   
   public boolean isActivableInTestToolsMenu() {
   		return false;
   }
   
   public boolean isFreezable() {
   		return false;
   }
   
   public boolean isFreezed() {
     return false;
   }
   
   public void unFreeze() {
   }
   
   public boolean usesOtherUIComponents() {
     return true;
   }
   
   public void allPluginActived(ExtensionPoint commonExtensions, ExtensionPoint testDriverExtensions, ExtensionPoint scriptEngineExtensions, ExtensionPoint bugTrackerExtensions) {
	   
   }
	/**
	 * @param alreadyCron The alreadyCron to set.
	 */
	public void setAlreadyCron(boolean alreadyCron) {
		this.alreadyCron = alreadyCron;
	}
	/**
	 * @return Returns the cronButton.
	 */
	public JButton getCronButton() {
		return cronButton;
	}
}

