/*
 * SalomeTMF is a Test Management Framework
 * Copyright (C) 2005 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @author Aurore PENAULT
 *
 * Contact: mikael.marche@rd.francetelecom.com
 */
package salomeTMF_plug.cronExec;

import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;

import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.api.data.ExecutionWrapper;
import org.objectweb.salome_tmf.data.Campaign;
import org.objectweb.salome_tmf.data.Execution;
import org.objectweb.salome_tmf.ihm.main.datawrapper.DataModel;
import org.objectweb.salome_tmf.ihm.main.datawrapper.TestMethods;

/**
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ExecTask extends TimerTask {
	
	Timer pTimer;
	
	int nbOcc;
	
	int tmpNbOcc;
	
	int nbLastExecResult = -1;
	
	int nbWarning = 0;
	
	ArrayList execWrapperList;
	
	ArrayList execList;
	
	boolean stopOnError;
	
	/**
	 * 
	 */
	public ExecTask(ArrayList execWrapList, Timer timer, int nbOccurences, boolean stopOnError) {
		super();
		
		pTimer = timer;
		nbOcc = nbOccurences;
		tmpNbOcc = 0; 
		execWrapperList = execWrapList;
		this.stopOnError = stopOnError;
		execList = null;
	}
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		ExecutionWrapper pExecutionWrapper;
		if (tmpNbOcc >= nbOcc) {
			pTimer.cancel();
			DataModel.reloadFromBase(true);
			return;
		}
		
		if (tmpNbOcc == 0) {
			DataModel.reloadFromBase(true);
			int size = execWrapperList.size();
			if (execList == null){
				execList = new ArrayList();
				for (int i = 0 ; i< size ; i++ ) {
					Execution pExecution;
					pExecutionWrapper = (ExecutionWrapper) execWrapperList.get(i); 
					Campaign pCamp = DataModel.getCurrentProject().getCampaignFromModel(pExecutionWrapper.getCampId());
					pExecution = pCamp.getExecutionFromModel(pExecutionWrapper.getName());
					execList.add(i, pExecution);
				}
				nbLastExecResult = ((Execution)execList.get(size-1)).getExecutionResultListFromModel().size();
			}
		} else {
			int size = execList.size();
			int tmp_nbLastExecResult = ((Execution)execList.get(size-1)).getExecutionResultListFromModel().size();
			if (tmp_nbLastExecResult < nbLastExecResult){
				nbWarning++;
				Util.log("[ExecTask:run] Warning last schedule seem to be not finished");
				if (nbWarning == 3){
					pTimer.cancel();
					DataModel.reloadFromBase(true);
				}
				return;
			} else {
				nbWarning = 0;
			}
			
		}
		
		/*
		int size = execWrapperList.size();
		if (execList == null){
			execList = new ArrayList();
			for (int i = 0 ; i< size ; i++ ) {
				Execution pExecution;
				pExecutionWrapper = (ExecutionWrapper) execWrapperList.get(i); 
				Campaign pCamp = TestData.getCampaign(pExecutionWrapper.getCampId());
				pExecution = pCamp.getExecution(pExecutionWrapper.getName());
				execList.add(i, pExecution);
			}
			nbLastExecResult = ((Execution)execList.get(size-1)).getExecutionResultList().size();
		}
		*/
		
		TestMethods.runExecution(execList, null, stopOnError, false);
		tmpNbOcc++;
		nbLastExecResult++;
		
		if (nbOcc == 1)
			pTimer.cancel();
	}

}
