/*
 * MainFrame.java - HelpGui main frame
 * Copyright (C) 2003 Alexandre THOMAS
 * alexthomas@free.fr
 * http://helpgui.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package salomeTMF_plug.helpgui.gui;

import javax.swing.JFrame;

import salomeTMF_plug.helpgui.util.Out;

import salomeTMF_plug.helpgui.HelpGui;

/**
 * Main frame of the help GUI
 * 
 * @author Alexandre THOMAS
 */
public class MainFrame extends JFrame {

	MainPanel mainPanel;

	/** Version of HelpGUI. */
	public String version = "1.0";

	/** Standard Constructor. */
	public MainFrame() {
		super("Help Gui");
		mainPanel = new MainPanel();
		initFrame();
	}

	/** Standard Constructor. */
	public MainFrame(String helpPath) {
		super("Help Gui");
		mainPanel = new MainPanel(helpPath);
		initFrame();
	}

	/** Standard Constructor. */
	public MainFrame(String helpPath, String iconsPath) {
		super("Help Gui");
		mainPanel = new MainPanel(helpPath, iconsPath, null);
		initFrame();
	}

	/** Standard Constructor. */
	public void initFrame() {
		//Default action on close
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				setVisible(false);
			}
		});

		getContentPane().add(mainPanel);
		//Pack the window
		pack();
		setLocation(100, 100);
		//Set a message
		Out.msg("Construction of the GUI", Out.OK);
	}

	/** Close the Frame */
	public void quit() {
		if (HelpGui.debug)
			System.exit(0);
		else
			setVisible(false);
	}

}
