/*
 * TocOpen.java - List of page for the help topic
 * Copyright (C) 2003 Alexandre THOMAS
 * alexthomas@free.fr
 * http://helpgui.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package salomeTMF_plug.helpgui.parser;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.objectweb.salome_tmf.api.Util;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import salomeTMF_plug.helpgui.gui.HelpView;
import salomeTMF_plug.helpgui.gui.MainPanel;


/**
 * Aible to to load a toc and construct the tree
 * 
 * @author Alexandre THOMAS
 */
public class TocOpen {

	//Temporary
	StringBuffer XMLFile = new StringBuffer();

	/** View of data */
	HelpView helpView;

	////////////////////////////////////////////////////////////////////

	/** Constructor */
	public TocOpen(HelpView helpView) {
		this.helpView = helpView;
	}

	public boolean load(String path, boolean plugin, String pluginName) throws IOException {
		// Use an instance of ourselves as the SAX event handler
		DefaultHandler handler = new XMLParser(helpView, plugin, pluginName);

		// Use the default (non-validating) parser
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			// Parse the input
			SAXParser saxParser;
			saxParser = factory.newSAXParser();
			Util.log("[helpgui:TocOpen] : try to load : "+path + "/toc.xml");
			saxParser.parse(path+ "/toc.xml", handler);
			
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
			return false;
		} catch (SAXException e) {
			e.printStackTrace();
			throw new IOException(e.getMessage());
		}

		return true;		
	}
	
	/** Load the toc.xml file and create the tree */
	public boolean load() throws IOException {
		return load(MainPanel.helpPath+ "/" + MainPanel.helpDir + "/" + MainPanel.lang, false, null);
	}

}
