package salomeTMF_plug.requirements;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.tree.DefaultMutableTreeNode;

import org.dom4j.Document;
import org.dom4j.Element;
import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.data.Test;
import org.objectweb.salome_tmf.ihm.tools.Tools;
import org.objectweb.salome_tmf.plugins.core.XMLLoaderPlugin;

import salomeTMF_plug.requirements.data.ReqFamily;
import salomeTMF_plug.requirements.data.ReqLeaf;
import salomeTMF_plug.requirements.data.Requirement;
import salomeTMF_plug.requirements.sqlWrapper.ReqWrapper;

public class ImportXMLReq {

	//	ReqPlugin pReqPlugin = null;
	ReqPlugin  pReqPlugin = null;

	Hashtable projectReqByName ;
	Hashtable projectReqById ;
	Hashtable docReqById;
	Hashtable docElementById;
	Hashtable docReqByName;
	//ReqFamily reqRoot;
	ReqFamily reqRoot;
	//boolean importReq;
	XMLLoaderPlugin pImport;

	ImportXMLReq(ReqPlugin _pReqPlugin, XMLLoaderPlugin pXMLLoader){
		//Requirements
		pReqPlugin = _pReqPlugin;
		//importReq = _importReq;
		pImport  = pXMLLoader;
		projectReqByName = new Hashtable();
		projectReqById = new Hashtable();
		docReqByName = new Hashtable();
		docReqById = new Hashtable();
		docElementById = new Hashtable();
	}


	void loadRequirementCacheFromModel(DefaultMutableTreeNode pTempNode, boolean first) throws Exception {
		Requirement pTempReq = (Requirement)pTempNode.getUserObject();
		if (!first){
			projectReqByName.put(pTempReq.getLongName(), pTempReq);
			projectReqById.put(new Integer(pTempReq.getIdBdd()), pTempReq);
		}else {
			first = false;
		}

		if (pTempReq instanceof ReqLeaf){
			return;
		} else {
			int nbChild =  pTempNode.getChildCount();

			for (int i = 0; i < nbChild ; i++){
				loadRequirementCacheFromModel((DefaultMutableTreeNode)pTempNode.getChildAt(i), first);
			}
		}
	}

	void loadRequirementCacheFromXML(Document doc) throws Exception {
		docElementById.clear();
		docReqById.clear();
		docReqByName.clear();
		reqRoot = new ReqFamily("Requirements_" +ReqPlugin.getProjectRef().getNameFromModel(), "");
		docReqById.put(new Integer(0), reqRoot);
		Iterator itReqFamilyfXML = doc.selectNodes("//RequirementFamily" ).iterator();
		while (itReqFamilyfXML.hasNext()){
			Element reqElem = (Element)itReqFamilyfXML.next();
			String nomReq = reqElem.elementText("Nom");
			String desc = (reqElem.elementText("Description") == null)?"":reqElem.elementText("Description");
			if (reqElem.element("Description")!= null && reqElem.element("Description").attribute("isHTML")!= null && reqElem.element("Description").attributeValue("isHTML").equals("true")) {
				desc = giveHTMLDescription(reqElem);
			} else {
				desc = desc.replaceAll("\\\\n", "<br>");
				desc = "<html><head></head><body>"+desc+"</body></html>";
			}
			String id_reqDoc = reqElem.attributeValue("id_req");
			id_reqDoc = id_reqDoc.substring(4, id_reqDoc.length()); //remove Req_
			String id_reqParentDoc = reqElem.attributeValue("id_req_parent");
			id_reqParentDoc = id_reqParentDoc.substring(4, id_reqParentDoc.length()); //remove Req_

			//docReqByName.put(nomReq, reqElem);
			docElementById.put(new Integer(id_reqDoc), reqElem);
			ReqWrapper pReqWrapper = new  ReqWrapper();
			pReqWrapper.setName(nomReq);
			pReqWrapper.setDescription(desc);
			pReqWrapper.setIdBDD(new Integer(id_reqDoc).intValue());
			//pReqWrapper.setType(0);
			ReqFamily pParent = (ReqFamily) docReqById.get(new Integer(id_reqParentDoc));
			ReqFamily pReqFamily = new ReqFamily(pReqWrapper, pParent) ;
			pParent.addRequirement(pReqFamily);
			docReqById.put(new Integer(id_reqDoc), pReqFamily);
		}
		Iterator itReqLeqfXML = doc.selectNodes("//Requirement" ).iterator();
		while (itReqLeqfXML.hasNext()){
			Element reqElem = (Element)itReqLeqfXML.next();
			String nomReq = reqElem.elementText("Nom");

			int priority = -1;
			String version = null;
			int cat = -1;
			int comp =  -1;
			int state = -1;
			String origine = null;
			String verifway = null;
			String reference = null;
			try {
				priority =  (new Integer(reqElem.attributeValue("priority"))).intValue();
				version = reqElem.attributeValue("version");
				cat =  (new Integer(reqElem.attributeValue("category"))).intValue();
				comp =  (new Integer(reqElem.attributeValue("complexity"))).intValue();
				state = (new Integer(reqElem.attributeValue("state"))).intValue();
				origine = reqElem.attributeValue("origine");
				verifway = reqElem.attributeValue("verifway");
				reference = reqElem.attributeValue("reference");
			} catch (Exception e){
				//XML from old plugin
			}
			String desc = (reqElem.elementText("Description") == null)?"":reqElem.elementText("Description");
			if (reqElem.element("Description")!= null && reqElem.element("Description").attribute("isHTML")!= null && reqElem.element("Description").attributeValue("isHTML").equals("true")) {
				desc = giveHTMLDescription(reqElem);
			} else {
				desc = desc.replaceAll("\\\\n", "<br>");
				desc = "<html><head></head><body>"+desc+"</body></html>";
			}
			String id_reqDoc = reqElem.attributeValue("id_req");
			id_reqDoc = id_reqDoc.substring(4, id_reqDoc.length()); //remove Req_
			String id_reqParentDoc = reqElem.attributeValue("id_req_parent");
			id_reqParentDoc = id_reqParentDoc.substring(4, id_reqParentDoc.length()); //remove Req_

			ReqWrapper pReqWrapper = new  ReqWrapper();
			pReqWrapper.setName(nomReq);
			pReqWrapper.setDescription(desc);
			pReqWrapper.setIdBDD(new Integer(id_reqDoc).intValue());
			if (priority != -1){
				pReqWrapper.setPriority(priority);
			}
			if (version != null){
				pReqWrapper.setVersion(version);
			}
			if (cat != -1){
				pReqWrapper.setCat(cat);
			}
			if (comp != -1){
				pReqWrapper.setComplexe(comp);
			}
			if (state != -1){
				pReqWrapper.setState(state);
			}
			if (origine != null){
				pReqWrapper.setOrigine(origine);
			}
			if (verifway != null){
				pReqWrapper.setVerif(verifway);
			}
			if (reference != null){
				pReqWrapper.setReference(reference);
			}
			ReqFamily pParent = (ReqFamily) docReqById.get(new Integer(id_reqParentDoc));
			ReqLeaf pReq = new ReqLeaf(pReqWrapper, pParent);
			pParent.addRequirement(pReq);
			docReqById.put(new Integer(id_reqDoc), pReq);
			docElementById.put(new Integer(id_reqDoc), reqElem);
		}
		Enumeration  enumReqs = docReqById.elements();
		while (enumReqs.hasMoreElements()){
			Requirement pReq = (Requirement) enumReqs.nextElement();
			docReqByName.put(pReq.getLongName(), pReq);
		}
	}

	/**
	 * Supprime les liens qui ne sont pas dans le XML
	 * @param testElem
	 * @param test
	 */
	public void removeReqLink(Element testElem, Test test) {
		try {
			Vector listReqWrapper = Requirement.getReqWrapperCoveredByTest(test.getIdBdd());
			int size = listReqWrapper.size();

			for (int i = 0; i < size; i++) {
				ReqWrapper pReqWrapper = (ReqWrapper) listReqWrapper.elementAt(i);
				Requirement pReq = (Requirement) projectReqById.get(new Integer(pReqWrapper.getIdBDD()));

				Iterator itReqLinkXML = testElem.selectNodes("LinkRequirement/RequirementRef").iterator();
				boolean appartient = false;
				while (itReqLinkXML.hasNext()  && !appartient) {
					Element linkElem = (Element)itReqLinkXML.next();
					String id = linkElem.attributeValue("ref");
					id = id.substring(4, id.length());
					Requirement pTmpReq = (Requirement) docReqById.get(new Integer(id));
					//String nomReq = linkElem.elementText("Nom");
					if (pReq!=null && pTmpReq != null && pTmpReq.getLongName().equals(pReq.getLongName())){
						appartient = true;
					}
				}
				if (!appartient){
					if (pReq != null){
						try {
							pReq.deleteCoverForTest(test.getIdBdd());
						}catch(Exception e1){
							Tools.ihmExceptionView(e1);
						}
					}
				}
			}
		}catch(Exception e){
			Tools.ihmExceptionView(e);
		}
	}

	/**
	 * Suprrime les exigences qui ne sont pas dans le XML
	 * @param doc
	 * @throws Exception
	 */
	public void gestionDesSuppressionsRequirements(Document doc) throws Exception {

		Enumeration itReqProjet = projectReqByName.elements();

		/* Analyse des requiements feuilles */
		while (itReqProjet.hasMoreElements()){
			Requirement pReq = (Requirement)itReqProjet.nextElement();
			if (pReq instanceof ReqLeaf){

				Iterator itReqLeqfXML = doc.selectNodes("//Requirement" ).iterator();
				boolean appartient = false;
				Element reqElem = null;
				while (itReqLeqfXML.hasNext() && !appartient){
					reqElem = (Element)itReqLeqfXML.next();
					String id = reqElem.attributeValue("id_req");
					id = id.substring(4, id.length());
					Requirement pTmpReq = (Requirement) docReqById.get(new Integer(id));
					if (pTmpReq.getLongName().equals(pReq.getLongName())){
						appartient = true;
					}
				}
				if (!appartient){
					try {
						pReq.deleteInDBAndModel();
						projectReqByName.remove(pReq.getLongName());
						projectReqById.remove(new Integer(pReq.getIdBdd()));
					} catch (Exception e) {
						Tools.ihmExceptionView(e);
					}
				}
			}else if (pReq.getIdBdd()>0){
				Iterator itReqFamXML = doc.selectNodes("//RequirementFamily" ).iterator();
				boolean appartient = false;
				Element reqElem = null;
				while (itReqFamXML.hasNext() && !appartient){
					reqElem = (Element)itReqFamXML.next();
					String id = reqElem.attributeValue("id_req");
					id = id.substring(4, id.length());
					Requirement pTmpReq = (Requirement) docReqById.get(new Integer(id));
					if (pTmpReq.getLongName().equals(pReq.getLongName())){
						appartient = true;
					}
				}
				if (!appartient){
					try {
						Vector reqLeafs = ((ReqFamily)pReq).getAllLeaf();
						if(reqLeafs.size() ==0 ){
							pReq.deleteInDBAndModel();
							projectReqByName.remove(pReq.getLongName());
							projectReqById.remove(new Integer(pReq.getIdBdd()));
						} else {
							for (int i = 0 ; i < reqLeafs.size(); i++){
								Requirement pTmpReq = (Requirement) reqLeafs.elementAt(i);
								projectReqByName.remove(pTmpReq.getLongName());
							}
						}
					} catch (Exception e) {
						Tools.ihmExceptionView(e);
					}
				}
			}
		}
	}


	/**
	 * Mise a jour des couverture d'exigence avec le doc XML
	 * Ajout des nouvelle couverture et suppression des couvertures qui ne sont pas dans le XML si supprElement = true
	 * @param testElem
	 * @param test
	 * @param supprElement
	 * @throws Exception
	 */
	public void updateReqLink(Element testElem, Test test, boolean supprElement) throws Exception {
		Iterator itReqLinkXML = testElem.selectNodes("LinkRequirement/RequirementRef").iterator();
		try {
			Vector listReqWrapper = Requirement.getReqWrapperCoveredByTest(test.getIdBdd());
			int size = listReqWrapper.size();
			while (itReqLinkXML.hasNext()) {
				Element linkElem = (Element)itReqLinkXML.next();
				String nomReq = linkElem.elementText("Nom");
				String id = linkElem.attributeValue("ref");
				id = id.substring(4, id.length());
				Requirement pTmpReq = (Requirement) docReqById.get(new Integer(id));
				/*Util.log ("[updateReqLink] id = " + id);
				Util.log ("[updateReqLink] pTmpReq = " + pTmpReq);
				Util.log ("[updateReqLink] nomReq = " + nomReq);
				Util.log ("[updateReqLink] test = " + test.getNameFromModel() + ", suite : " + test.getTestListFromModel().getNameFromModel()
						 + ", famille : " + test.getTestListFromModel().getFamilyFromModel().getNameFromModel());*/
				boolean doLink = true;
				if (pTmpReq == null){
					doLink = false;
					Util.log("[ImportXMLReq->updateReqLink] requirement linked not found in XML" );
				}
				Requirement pReq = null;
				if (doLink) {
					pReq = (Requirement) projectReqByName.get(pTmpReq.getLongName());
				}
				if (doLink && pReq == null){
					Tools.ihmExceptionView(new Exception("[updateReqLink] Requirment " + nomReq + " not found"));
					doLink = false;
				}
				if (doLink && pReq instanceof ReqFamily){
					Tools.ihmExceptionView(new Exception("[updateReqLink] Requirment " + nomReq + " is a family and can't be linked to the test " + test.getNameFromModel()));
					doLink = false;
				}
				if (doLink) {
					boolean couvre = false;
					int i = 0;
					while ( i < size && !couvre){
						ReqWrapper pReqWrapper = (ReqWrapper) listReqWrapper.elementAt(i);
						Requirement pTmpReq2 = (Requirement) projectReqById.get(new Integer(pReqWrapper.getIdBDD()));
						if (pTmpReq2.getLongName().equals(pTmpReq.getLongName())){
							couvre = true;
						}
						i++;
					}

					if (!couvre){
						try {
							pReq.addTestCoverInDB(test.getIdBdd(), true);
						}catch(Exception e1){
							Tools.ihmExceptionView(e1);
						}
					}
				}
			}
			if (supprElement){
				removeReqLink(testElem, test);
			}
		} catch(Exception e){
			Tools.ihmExceptionView(e);
		}
	}


	/**
	 * Ajout les Requirements du XML dans le projet
	 * (Ne fait pas de test pour savoir si requirement est deja present)
	 * @param reqElem
	 * @param ReqFamily la famille d'exigence ou ajouter le requirement
	 * Si null, recherche de la famille
	 * @throws Exception
	 */
	private void ajoutRequirement(Element reqElem, ReqFamily pReqParent) throws Exception {
		String nomReq = reqElem.elementText("Nom");
		int priority = -1;
		String version = null;
		int cat = -1;
		int comp =  -1;
		int state = -1;
		String origine = null;
		String verifway = null;
		String reference = null;

		try {
			priority =  (new Integer(reqElem.attributeValue("priority"))).intValue();
			version = reqElem.attributeValue("version");
			cat =  (new Integer(reqElem.attributeValue("category"))).intValue();
			comp =  (new Integer(reqElem.attributeValue("complexity"))).intValue();
			state = (new Integer(reqElem.attributeValue("state"))).intValue();
			origine = reqElem.attributeValue("origine");
			verifway = reqElem.attributeValue("verifway");
			reference = reqElem.attributeValue("reference");
		} catch (Exception e){
			//XML from old plugin
		}

		String desc = (reqElem.elementText("Description") == null)?"":reqElem.elementText("Description");
		if (reqElem.element("Description")!= null && reqElem.element("Description").attribute("isHTML")!= null && reqElem.element("Description").attributeValue("isHTML").equals("true")) {
			desc = giveHTMLDescription(reqElem);
		} else {
			desc = desc.replaceAll("\\\\n", "<br>");
			desc = "<html><head></head><body>"+desc+"</body></html>";
		}
		String strId_reqParent = reqElem.attributeValue("id_req_parent");
		strId_reqParent = strId_reqParent.substring(4, strId_reqParent.length()); //remove Req_
		Integer id_reqParent = new Integer(strId_reqParent);

		//ReqFamily pReqParent;
		if (pReqParent == null){
			if (id_reqParent.equals(new Integer(0))){
				pReqParent = (ReqFamily)reqRoot;
			} else {
				pReqParent = (ReqFamily)docReqById.get(id_reqParent);
				Requirement pTempReq =(Requirement) projectReqByName.get(pReqParent.getLongName());

				if (pTempReq != null && pTempReq instanceof ReqFamily){
					pReqParent =  (ReqFamily)pTempReq;
				} else {
					pReqParent = (ReqFamily)reqRoot;
				}
			}
		}

		ReqLeaf pNewReq = new ReqLeaf(nomReq, desc, pReqParent, priority);
		try {
			pNewReq.addInDB();
			if (cat != -1){
				pNewReq.updateCatInDBAndModel(cat);
			}
			if (comp != -1){
				pNewReq.updateComplexeInDBAndModel(comp);
			}
			if (state != -1){
				pNewReq.updateStateInDBAndModel(state);
			}
			if (version != null && origine != null && verifway != null && reference != null){
				pNewReq.updateInfoInDB(version, origine, verifway, reference);
			} else {
				if (version != null){
					pNewReq.updateVersionInDBAndModel(version);
				}
				if (origine != null) {
					pNewReq.updateOrigineInDBAndModel(origine);
				}
				if (verifway != null){
					pNewReq.updateVerifInDBAndModel(verifway);
				}
				if (reference != null) {
					pNewReq.updateReferenceInDBAndModel(reference);
				}
			}
			pReqParent.addRequirement(pNewReq);
			projectReqByName.put(pNewReq.getLongName(), pNewReq);
			projectReqById.put(new  Integer(pNewReq.getIdBdd()), pNewReq);
			pImport.updateElementAttachement(reqElem, pNewReq, true);
		} catch (Exception e){
			Tools.ihmExceptionView(e);
		}
	}

	/**
	 * Ajoute l'exigence famille au repository (pas de test si deja presente)
	 * @param reqElem
	 * @return
	 * @throws Exception
	 */
	private ReqFamily ajoutReqFamily(Element reqElem) throws Exception {
		if (reqElem == null){
			return (ReqFamily)reqRoot;
		}
		String nomReq = reqElem.elementText("Nom");
		String id = reqElem.attributeValue("id_req");
		id = id.substring(4, id.length());
		Requirement pTmpReq = (Requirement) docReqById.get(new Integer(id));
		pTmpReq =(Requirement) projectReqByName.get(pTmpReq.getLongName());
		if (pTmpReq != null && pTmpReq instanceof ReqFamily){
			return (ReqFamily)pTmpReq;
		}

		String strId_reqParent = reqElem.attributeValue("id_req_parent");
		strId_reqParent = strId_reqParent.substring(4, strId_reqParent.length()); //remove Req_
		Integer id_reqParent = new Integer(strId_reqParent);
		Element reqParentElement = (Element)docElementById.get(id_reqParent);
		ReqFamily pParent = ajoutReqFamily(reqParentElement);

		String desc = (reqElem.elementText("Description") == null)?"":reqElem.elementText("Description");
		if (reqElem.element("Description")!= null && reqElem.element("Description").attribute("isHTML")!= null && reqElem.element("Description").attributeValue("isHTML").equals("true")) {
			desc = giveHTMLDescription(reqElem);
		} else {
			desc = desc.replaceAll("\\\\n", "<br>");
			desc = "<html><head></head><body>"+desc+"</body></html>";
		}
		ReqFamily pNewReqFamily = new ReqFamily(nomReq, desc, pParent);

		try {
			pNewReqFamily.addInDB();
			pParent.addRequirement(pNewReqFamily);
			projectReqByName.put(pNewReqFamily.getLongName(), pNewReqFamily);
			projectReqById.put(new  Integer(pNewReqFamily.getIdBdd()), pNewReqFamily);
			pImport.updateElementAttachement(reqElem, pNewReqFamily, true);
		} catch (Exception e){
			Tools.ihmExceptionView(e);
		}
		return pNewReqFamily;
	}
	
	private String giveHTMLDescription(Element elem) {
		Element descElem = elem.element("Description");
    	String description = "";
    	if (descElem.hasContent()) {
    		description = elem.element("Description").asXML();    	
    		description = description.substring(27, description.indexOf("</Description>"));
    		description = description.replaceAll("<br/>", "<br>");
    		description = "<html><head></head><body>"+description+"</body></html>";
    	}
		return description;
	}


	/**
	 * Mise a jour des Requirements existants et ajout des nouveaux
	 * (Si gestion des suppression deja effectue, ne fait rien)
	 * @param doc
	 * @throws Exception
	 */
	public void updateProjectRequirement(Document doc) throws Exception {
			Vector reqElementToAdd = new Vector();
			Vector reqFamilyToAdd = new Vector();

			Iterator itReqLeqfXML = doc.selectNodes("//Requirement" ).iterator();
			while (itReqLeqfXML.hasNext()){
				Element reqElem = (Element)itReqLeqfXML.next();
				//String nomReq = reqElem.elementText("Nom");

				int priority = -1;
				String version = null;
				int cat = -1;
				int comp =  -1;
				int state = -1;
				String origine = null;
				String verifway = null;
				String reference = null;
				try {
					priority =  (new Integer(reqElem.attributeValue("priority"))).intValue();
					version = reqElem.attributeValue("version");
					cat =  (new Integer(reqElem.attributeValue("category"))).intValue();
					comp =  (new Integer(reqElem.attributeValue("complexity"))).intValue();
					state = (new Integer(reqElem.attributeValue("state"))).intValue();
					origine = reqElem.attributeValue("origine");
					verifway = reqElem.attributeValue("verifway");
					reference = reqElem.attributeValue("reference");
				} catch (Exception e){
					//XML from old plugin
				}
				String desc = (reqElem.elementText("Description") == null)?"":reqElem.elementText("Description");
				if (reqElem.element("Description")!= null && reqElem.element("Description").attribute("isHTML")!= null && reqElem.element("Description").attributeValue("isHTML").equals("true")) {
					desc = giveHTMLDescription(reqElem);
				} else {
					desc = desc.replaceAll("\\\\n", "<br>");
					desc = "<html><head></head><body>"+desc+"</body></html>";
				}
				String id_reqDoc = reqElem.attributeValue("id_req");
				id_reqDoc = id_reqDoc.substring(4, id_reqDoc.length()); //remove Req_

				Requirement docXMLReq = (Requirement)docReqById.get(new Integer(id_reqDoc));
				Requirement pReq = null;
				if (docXMLReq != null){
					 pReq = (Requirement) projectReqByName.get(docXMLReq.getLongName());
				}

				if (pReq!= null){
					//Existe --> Update
					if (reqElem != null ){
						pImport.updateElementAttachement(reqElem, pReq, false);
						if (desc != null){
							pReq.updateDescriptionInDBAndModel(desc);
						}
						if (pReq instanceof ReqLeaf){
							if (version != null && origine != null && verifway != null && reference != null){
								((ReqLeaf)pReq).updateInfoInDB(version, origine, verifway, reference);
							} else {
								if (version != null){
									((ReqLeaf)pReq).updateVersionInDBAndModel(version);
								}
								if (origine != null){
									((ReqLeaf)pReq).updateOrigineInDBAndModel(origine);
								}
								if (verifway != null){
									((ReqLeaf)pReq).updateVerifInDBAndModel(verifway);
								}
								if (reference != null){
									((ReqLeaf)pReq).updateReferenceInDBAndModel(reference);
								}
							}
							if (priority != -1){
								((ReqLeaf)pReq).updatePriorityInDBAndModel(priority);
							}
							if (cat != -1){
								((ReqLeaf)pReq).updateCatInDBAndModel(cat);
							}
							if (comp != -1){
								((ReqLeaf)pReq).updateComplexeInDBAndModel(comp);
							}
							if (state != -1){
								((ReqLeaf)pReq).updateStateInDBAndModel(state);
							}
						}
					}
				} else {
					//Not Existe --> Ajout
					reqElementToAdd.add(reqElem);

				}
			}

			Iterator itReqFamilyfXML = doc.selectNodes("//RequirementFamily" ).iterator();
			while (itReqFamilyfXML.hasNext()){
				Element reqElem = (Element)itReqFamilyfXML.next();
				//String nomReq = reqElem.elementText("Nom");
				String desc = (reqElem.elementText("Description") == null)?"":reqElem.elementText("Description");
				if (reqElem.element("Description")!= null && reqElem.element("Description").attribute("isHTML")!= null && reqElem.element("Description").attributeValue("isHTML").equals("true")) {
					desc = giveHTMLDescription(reqElem);
				} else {
					desc = desc.replaceAll("\\\\n", "<br>");
					desc = "<html><head></head><body>"+desc+"</body></html>";
				}
				String id_reqDoc = reqElem.attributeValue("id_req");
				id_reqDoc = id_reqDoc.substring(4, id_reqDoc.length()); //remove Req_
				Requirement docXMLReq = (Requirement)docReqById.get(new Integer(id_reqDoc));
				Requirement pReq = null;
				if (docXMLReq != null){
					 pReq = (Requirement) projectReqByName.get(docXMLReq.getLongName());
				}

				if (pReq!= null){
					//Existe --> Update
					if (reqElem != null){
						pImport.updateElementAttachement(reqElem, pReq, false);
						if (desc != null){
							pReq.updateDescriptionInDBAndModel(desc);
						}
					}
				} else {
					//Not Existe --> Ajout
					reqFamilyToAdd.add(reqElem);
					//updateElementAttachement(reqElem, pReq, true);
				}
			}
			// Ajput des nouveau requirements
			for (int i = 0; i< reqFamilyToAdd.size(); i++){
				Element reqElem = (Element)reqFamilyToAdd.elementAt(i);
				ajoutReqFamily(reqElem);
			}
			for (int i = 0; i< reqElementToAdd.size(); i++){
				Element reqElem = (Element)reqElementToAdd.elementAt(i);
				ajoutRequirement(reqElem, null);
			}
	}

}