package salomeTMF_plug.requirements.ihm;

import java.awt.Color;
import java.awt.Component;
import java.util.Vector;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;

import salomeTMF_plug.requirements.data.ReqFilter;
import salomeTMF_plug.requirements.data.ReqLeaf;
import salomeTMF_plug.requirements.sqlWrapper.ReqWrapper;

public class PriorityTableCellRenderer  extends DefaultTableCellRenderer {
	Vector reqCovered; 
	public PriorityTableCellRenderer(Vector _reqCovered) {
		reqCovered = _reqCovered;
	}
	public Component getTableCellRendererComponent 
	(JTable table, Object value, boolean isSelected,
			boolean hasFocus, int row, int column) {
		
		super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
		
		try {
			
			Object objReq = reqCovered.elementAt(row);
			int priority = 0;
			if (objReq instanceof ReqLeaf){
				priority = ((ReqLeaf)objReq).getPriorityFromModel();
			} else if (objReq instanceof ReqWrapper){
				priority = ((ReqWrapper)objReq).getPriority();
			}
			
			if (priority == ReqFilter.P_HIGHT){
				setForeground(Color.red);
			} else if (priority == ReqFilter.P_MEDIUM){
				setForeground(Color.blue);
			} else if (priority == ReqFilter.P_LOW){
				setForeground(Color.black);
			} else if (priority == ReqFilter.P_NONE){
				setForeground(Color.gray);
			}
			/*
			TableColumn pcolumn = null;
	    	pcolumn = table.getColumnModel().getColumn(0);
	    	pcolumn.setPreferredWidth(2);
	    	pcolumn = table.getColumnModel().getColumn(1);
	    	pcolumn.setPreferredWidth(2);
	    	pcolumn = table.getColumnModel().getColumn(2);
	    	pcolumn.setPreferredWidth(5);
	    	pcolumn = table.getColumnModel().getColumn(3);
	    	pcolumn.setPreferredWidth(5);
	    	pcolumn = table.getColumnModel().getColumn(4);
	    	pcolumn.setPreferredWidth(5);
	    	*/
	    	

		} catch (Exception e){
			
		}
		return this;
	}
}