package salomeTMF_plug.simpleJunit;

import java.io.File;
import java.lang.reflect.Constructor;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;

import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.api.data.SalomeFileWrapper;
import org.objectweb.salome_tmf.data.Attachment;
import org.objectweb.salome_tmf.data.AutomaticTest;
import org.objectweb.salome_tmf.data.FileAttachment;
import org.objectweb.salome_tmf.ihm.main.SalomeTMFContext;
import org.objectweb.salome_tmf.ihm.main.datawrapper.DataModel;

public class JarUtil {
	
	
	SimpleJunitPlugin pSimpleJunitPlugin;
	
	JarUtil(SimpleJunitPlugin pSimpleJunitPlugin){
		this.pSimpleJunitPlugin = pSimpleJunitPlugin;
	}
	
	/**
	 * Load the referenced in the attachement in the class loader
	 * @param pJarAttach
	 * @return
	 * @throws Exception
	 */
	ClassLoader loadJar(Attachment pJarAttach) throws Exception  {
	       URL UrlLib = null;
	       if (pJarAttach instanceof FileAttachment){
	           Util.log("[SimpleJunitPlugin:loadJar] Chargement du fichier dans tmp"); 
	           File pFile = ((FileAttachment)pJarAttach).getFileFromDB();
	           if (pFile == null){
	               Util.log("[SimpleJunitPlugin:loadJar] File attachment no found in DB" + pJarAttach.getNameFromModel());
	               throw new Exception("File attachment no found in DB");
	           }
	           //UrlLib = new URL(pFile.getProtocol(), pFile.getHost(), pFile.getPort(), pFile.getFileName());
	           UrlLib = pFile.toURL();
	       } else {
	           UrlLib = new URL(pJarAttach.getNameFromModel());
	       }
	       Util.log("[SimpleJunitPlugin:loadJar] URL TO LOAD = " + UrlLib);
	       SalomeTMFContext.getInstance().getSalomeClassLoader().AddJar(UrlLib);
	       return SalomeTMFContext.getInstance().getSalomeClassLoader();
	   }
	   
	
	ClassLoader loadJar(String strID, String strAttachment, String testScript, AutomaticTest pTest) throws Exception  {
		   
		   Hashtable tabAttach = new Hashtable(DataModel.getCurrentProject().getAttachmentMapFromModel());
	       Enumeration e = tabAttach.elements();
	       Attachment pJarAttach = null;
	       boolean c = true;
	       while (e.hasMoreElements() && c){
	           Attachment pAttach = (Attachment) e.nextElement();
	           String id = ""+ pAttach.getIdBdd();
	           if (id.trim().equals(strID.trim())){
	               pJarAttach = pAttach;
	               c = false;
	           }
	       }
	       if (pJarAttach == null){
	            Util.log("[SimpleJunitPlugin:loadJar] File attachment no found in DB" + strAttachment);
	            strID = pSimpleJunitPlugin.updateTestScript(testScript, pTest);
	            tabAttach = new Hashtable(DataModel.getCurrentProject().getAttachmentMapFromModel());
	            e = tabAttach.elements();
	            pJarAttach = null;
	            c = true;
	            while (e.hasMoreElements() && c){
	                Attachment pAttach = (Attachment) e.nextElement();
	                String id = ""+ pAttach.getIdBdd();
	                if (id.trim().equals(strID.trim())){
	                    pJarAttach = pAttach;
	                    c = false;
	                }
	            }
	            if (pJarAttach == null){
	            	throw new Exception("File attachment no found in DB");
	            }
	       }
	       URL UrlLib = null;
	       
	       if (pJarAttach instanceof FileAttachment){
	          Util.log("[SimpleJunitPlugin:loadJar] Chargement du fichier dans tmp");          
	          File pFile = ((FileAttachment)pJarAttach).getFileFromDB();
	           if (pFile == null){
	               Util.log("[SimpleJunitPlugin:loadJar] File attachment no found in DB" + strAttachment);
	               throw new Exception("File attachment no found in DB");
	           }
	           //UrlLib = new URL(pFile.getProtocol(), pFile.getHost(), pFile.getPort(), pFile.getFileName());
	           UrlLib = pFile.toURL();
	       } else {
	           UrlLib = new URL(pJarAttach.getNameFromModel());
	       }
	       Util.log("[SimpleJunitPlugin:loadJar] URL TO LOAD = " + UrlLib);
	       
	       SalomeTMFContext.getInstance().getSalomeClassLoader().AddJar(UrlLib);
	       return SalomeTMFContext.getInstance().getSalomeClassLoader();
	   }
	   
	
	   Constructor loadClass(String strClass) throws Exception{
	       Constructor pConstructor = null;
	        Class pTestClass = Class.forName(strClass);
	        Class[] parameterTypes = new Class[1];
	        parameterTypes[0] = Hashtable.class;
	        pConstructor = pTestClass.getConstructor(parameterTypes);
	       return pConstructor;
	   }
	   
}
