package salomeTMF_plug.simpleJunit;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.Hashtable;
import java.util.Properties;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestResult;
import junit.textui.ResultPrinter;
import junit.textui.TestRunner;

import org.objectweb.salome_tmf.api.Api;
import org.objectweb.salome_tmf.api.ApiConstants;
import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.data.Attachment;
import org.objectweb.salome_tmf.data.AutomaticTest;
import org.objectweb.salome_tmf.data.ExecutionResult;
import org.objectweb.salome_tmf.data.FileAttachment;
import org.objectweb.salome_tmf.data.Script;
import org.objectweb.salome_tmf.data.TestList;
import org.objectweb.salome_tmf.ihm.main.datawrapper.DataModel;
import org.objectweb.salome_tmf.ihm.tools.Tools;

public class Junit3ClassAnalyser extends JunitAnalyser implements IJunitAnalyser{

	TestResult pTestResult = null;
	SimpleJunitPlugin pSimpleJunitPlugin;
	JarUtil pJarUtil;
	ResultPrinter pResultPrinter = null;
	StringPrintStream pResultStrem = null;
	//JUnitCore pJUnitCore;
	Junit3ClassAnalyser(SimpleJunitPlugin pSimpleJunitPlugin){
		super();
		this.pSimpleJunitPlugin = pSimpleJunitPlugin;
		pJarUtil = new JarUtil(pSimpleJunitPlugin);

		//pJUnitCore = new JUnitCore();
	}



	public void createJunitTest(Attachment pSelectedattach, String strClass,  TestList pSuite, String toWrite){
		try { 
			ClassLoader pClassLoader = pJarUtil.loadJar(pSelectedattach);
			Util.log("[SimpleJunitPlugin:createJunitTest] try to load class : "+ strClass);

			Class pTestClass =  pClassLoader.loadClass(strClass);
			Method[] pMethods = pTestClass.getDeclaredMethods(); 
			for (int i = 0; i < pMethods.length; i++){
				Method pMethod = pMethods[i];

				String methName = pMethod.getName();
				Util.log("[SimpleJunitPlugin:createJunitTest] evalue la methode : "+ methName);

				if (methName.startsWith("test")){
					if (pMethod.getReturnType().equals(void.class) ){
						Util.log("[SimpleJunitPlugin:createJunitTest] Taille des arguments "+ pMethod.getParameterTypes().length);
						Util.log("[SimpleJunitPlugin:createJunitTest] add test for " + methName);
						TestInfo testInfo = pMethod.getAnnotation(TestInfo.class);
						if (testInfo == null) {
							pSimpleJunitPlugin.addTest(methName, pSuite, toWrite +"test_meth = " + methName +"\n");
						} else {
							String description = testInfo.description();
							String [] idReqs = testInfo.requirementsId();
							pSimpleJunitPlugin.addTest(methName, description, idReqs, pSuite, toWrite +"test_meth = " + methName +"\n");
						}						
					}
				}
			}
		}catch (Exception e){
			Tools.ihmExceptionView(e);
			e.printStackTrace();
		}
		try {
			if (pSuite.getFamilyFromModel() != null){
				DataModel.reloadData(pSuite);
			} else {
				DataModel.reloadFromBase(true);
			}
		} catch (Exception e) {
			Tools.ihmExceptionView(e);
			e.printStackTrace();
		}
	}




	public int runTest(String strID, String strAttachment, String strClass, String meth, String testScript, org.objectweb.salome_tmf.data.AutomaticTest pTest, Hashtable argTest, String plugArg)  throws Exception{

		setExceutionResult(((ExecutionResult)argTest.get("salome_ExecResultObject")));

		// Add strAttachment in classloader if not
		Util.log("[SimpleJunitPlugin:runTest] chargement du jar " + strAttachment);
		//ClassLoader pClassLoader = loadJar(strID, strAttachment, pTest.getTestListFromModel(), testScript, pTest);
		ClassLoader pClassLoader = pJarUtil.loadJar(strID, strAttachment, testScript, pTest);

		Util.log("[SimpleJunitPlugin:runTest] chargement de la classe " + strClass);
		//Create instance of strClass
		Class pTestClass;
		try {
			pTestClass = (Class) cacheClass.get(strClass);
			if (pTestClass == null){
				pTestClass = pClassLoader.loadClass(strClass);
				cacheClass.put(strClass, pTestClass);
			}
		} catch (Exception e){
			e.printStackTrace();
			throw e;
		}

		Util.log("[SimpleJunitPlugin:runTest] classe charge " + pTestClass);

		Constructor pConstructor = null;
		boolean isStringConstructor = false;
		try {
			//pConstructor = pTestClass.getConstructor(parameterTypes);
			pConstructor = pTestClass.getConstructor(Hashtable.class);
			Util.log("[SimpleJunitPlugin:runTest] Use constructor with Hashtable");
		} catch (Exception ex){
			// ex.printStackTrace();
			Util.log("[SimpleJunitPlugin:runTest] No constructor with Hashtable");
			try {
				pConstructor = pTestClass.getConstructor(String.class);
				Util.log("[SimpleJunitPlugin:runTest] Use constructor with String");
				isStringConstructor = true;
			} catch (Exception ex2){
				pConstructor = null;
			}
		}


		Util.log("[SimpleJunitPlugin:runTest] creation de l'instance de l'objet tester");

		Object pTester = null;
		try {
			if (pConstructor != null){
				if (isStringConstructor) {
					pTester = pConstructor.newInstance(meth);
				} else {
					pTester = pConstructor.newInstance(argTest);
				}
				Util.log("[SimpleJunitPlugin:runTest] (constructor with arg) pTester = " + pTester); 

			} else {
				pTester = pTestClass.newInstance();
				Util.log("[SimpleJunitPlugin:runTest] (constructor without arg) pTester = " + pTester);

			}
		} catch (Exception ex2){
			ex2.printStackTrace();
		}
		if ( pTester == null)
			Util.log("[SimpleJunitPlugin:runTest] !! ptester == null");


		Util.log("[SimpleJunitPlugin:runTest] !! ptester before cast" + pTester.getClass().toString() + " in junit.framework.TestCase");
		((TestCase) pTester).setName(meth); 
		Util.log("[SimpleJunitPlugin:runTest] Creation du test result");

		//Ajout du printer//
		pResultStrem = new StringPrintStream();
		pResultPrinter = new ResultPrinter(new PrintStream(pResultStrem));

		Util.log("[SimpleJunitPlugin:runTest] execution du test");
		junit.textui.TestRunner pTestRunner = new TestRunner() ;
		pTestRunner.setPrinter(pResultPrinter);

		strLog = (String) argTest.get("testLog");
		if (strLog == null){
			strLog = "";
		}
		pTestResult =  pTestRunner.doRun((Test)pTester);
		strLog = (String) argTest.get("testLog");
		Util.log("[SimpleJunitPlugin:runTest] log de test testLog: " + argTest.get("testLog"));
		Util.log("[SimpleJunitPlugin:runTest] log de test" + pResultStrem.getLog());       
		if (pTestResult.wasSuccessful())
			return 0;
		else 
			return 1;
	}

	public String getTestLog(){
		String res = "";   
		if (pResultStrem != null){
			res = pResultStrem.getLog();
			if (strLog != null && !strLog.equals("")){
				res +="\nLOG FROM SALOME :\n" + strLog;
			}
		} else {
			if (strLog != null && !strLog.equals("")){
				res +="\nLOG FROM SALOME :\n" + strLog;
			}
		}
		return res;
	}

	public void stopTest()  throws Exception{
		if (pTestResult != null) {
			Util.log("[SimpleJunitPlugin:stopTest] Stop the test");
			pTestResult.stop();
		}
	}

	/******************************** Beanshell *****************************************/

	public void createBeanShellJunitTest(Attachment pSelectedattach, String strClass,  TestList pSuite){
		try { 
			ClassLoader pClassLoader = pJarUtil.loadJar(pSelectedattach);
			Util.log("[SimpleJunitPlugin:createBeanShellJunitTest] try to load class : "+ strClass);

			Class pTestClass =  pClassLoader.loadClass(strClass);


			Method[] pMethods = pTestClass.getDeclaredMethods(); 
			for (int i = 0; i < pMethods.length; i++){
				Method pMethod = pMethods[i];
				String methName = pMethod.getName();
				Util.log("[SimpleJunitPlugin:createBeanShellJunitTest] evalue la methode : "+ methName);

				if (methName.startsWith("test")){
					if (pMethod.getReturnType().equals(void.class) ){
						Util.log("[SimpleJunitPlugin:createBeanShellJunitTest] Taille des arguments "+ pMethod.getParameterTypes().length);
						Util.log("[SimpleJunitPlugin:createBeanShellJunitTest] add test for " + methName);
						AddBeanshellTest(methName, pSuite, pSelectedattach, strClass );
					}
				}
			}
			if (pSuite.getFamilyFromModel() != null){
				DataModel.reloadData(pSuite);
			} else {
				DataModel.reloadFromBase(true);
			}
		}catch (Exception e){
			Tools.ihmExceptionView(e);
			e.printStackTrace();
		}
	}

	void AddBeanshellTest(String methName, TestList pSuite, Attachment pSelectedattach, String strClass ){
		String name = pSimpleJunitPlugin.getTestName(methName, pSuite, 0);
		AutomaticTest pTest = new AutomaticTest(name.trim(), "Junit TestCase", "beanshell.TestDriver");
		//pTest.setName(name.trim());
		pTest.setConceptorLoginInModel(DataModel.getCurrentUser().getLoginFromModel());
		//pTest.setDescription("Junit TestCase");
		if (Api.isConnected()) {
			try {
				pSuite.addTestInDBAndModel(pTest);
				Util.log("[SimpleJunitPlugin:AddBeanshellTest] add test " + name + "in DB & Model");

			} catch (Exception e1) {
				Tools.ihmExceptionView(e1);
				return;
			}
		}

		File file = null;
		try {
			Util.log("[SimpleJunitPlugin:AddBeanshellTest] Create test Script file");
			file = writeBenshellJunitFile(pTest, methName, pSelectedattach, strClass );
		}catch  (Exception e2) {
			Tools.ihmExceptionView(e2);
			return;
		}
		Script pScript = new Script(file.getName(),"Junit test script");
		//pScript.setName(file.getName());
		pScript.setLocalisation(file.getAbsolutePath());
		pScript.setTypeInModel(ApiConstants.TEST_SCRIPT);
		pScript.setScriptExtensionInModel(pTest.getExtensionFromModel());
		//pScript.setPlugArg("");

		if (Api.isConnected()) {
			try {
				Util.log("[SimpleJunitPlugin:AddBeanshellTest] Add  : " +  pScript.getNameFromModel() + " to DB & Model") ;
				pTest.addScriptInDBAndModel(pScript, file);
			} catch (Exception e3) {
				Tools.ihmExceptionView(e3);
			}
		}
	}

	File writeBenshellJunitFile(AutomaticTest pTest, String methName, Attachment pSelectedattach, String strClass ) throws Exception {
		String fileName;
		File pFile;
		Properties sys = System.getProperties();
		String tmpDir = sys.getProperty("java.io.tmpdir");
		String fs = sys.getProperty("file.separator");      
		fileName = tmpDir + fs + pTest.getNameFromModel() + ".bsh";
		Util.log("[SimpleJunitPlugin:writeBenshellJunitFile] write file  : " +  fileName) ;

		pFile = new File(fileName);
		if (pFile.exists()){
			pFile.delete();
			pFile = new File(fileName);
		}
		//Util.log("[SimpleJunitPlugin:writeJunitFile] write " + toWtrite + ", in " + fileName);
		FileOutputStream fos = new FileOutputStream(pFile);
		BufferedOutputStream bos = new BufferedOutputStream(fos);
		String toWrite = "import java.lang.Class;\n";
		toWrite += "import java.util.Hashtable;\n";
		toWrite += "import java.lang.reflect.Method;\n";
		toWrite += "import java.lang.Class;\n";
		toWrite += "import junit.framework.*;\n\n";

		if (pSelectedattach instanceof FileAttachment) {
			//toWrite += "fileJar = (salome_SuiteTestObject.getAttachmentFromModel(\""+ pSelectedattach.getNameFromModel()+"\")).getFileFromDB(); \n";
			toWrite += "fileJar = (salome_ProjectObject.getAttachmentFromModel(\""+ pSelectedattach.getNameFromModel()+"\")).getFileFromDB(); \n";
			toWrite += "addJar(fileJar.getAbsolutePath());\n";

		} else {
			toWrite += "addJar(\""+ pSelectedattach.getNameFromModel()+"\");\n";
		}

		toWrite += "testClass = Class.forName(\"" + strClass + "\", false,  salome_classloder);\n";
		toWrite += "testCase = testClass.newInstance();\n";
		toWrite += "testCase.setName(\""+ methName +"\");\n";

		toWrite += "try {\n";
		toWrite += "\tClass[] parameterTypes = new Class[1];\n";
		toWrite += "\tparameterTypes[0] = Hashtable.class;\n";
		toWrite += "\tpMethod = testClass.getDeclaredMethod(\"setParam\", parameterTypes);\n";
		toWrite += "\tObject[] args = new Object[1];\n";
		toWrite += "\targs[1] =testargs;\n";
		toWrite += "\tpMethod.invoke(testCase, args);\n";
		toWrite += "} catch (Exception e){\n";
		toWrite += "\t}\n";

		//if testCase have method setParam

		toWrite += "result = junit.textui.TestRunner.run(testCase);\n";
		toWrite += "if (result.wasSuccessful()){\n";
		toWrite += "\tVerdict = \"pass\";\n";
		toWrite += "} else {\n";
		toWrite += "\tVerdict = \"fail\";\n";
		toWrite += "}";

		Util.log("[SimpleJunitPlugin:writeBenshellJunitFile] write  : " +  toWrite) ;

		byte[] b = toWrite.getBytes();
		bos.write(b, 0, b.length);
		bos.flush();
		bos.close();
		return pFile;
	}
}
