package salomeTMF_plug.simpleJunit;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
import java.util.Hashtable;
import java.util.List;
import java.util.Properties;

import junit.textui.ResultPrinter;

import org.junit.runner.JUnitCore;
import org.junit.runner.Request;
import org.junit.runner.Result;
import org.junit.runner.notification.Failure;
import org.junit.runner.notification.RunNotifier;
import org.objectweb.salome_tmf.api.Api;
import org.objectweb.salome_tmf.api.ApiConstants;
import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.data.Attachment;
import org.objectweb.salome_tmf.data.AutomaticTest;
import org.objectweb.salome_tmf.data.ExecutionResult;
import org.objectweb.salome_tmf.data.FileAttachment;
import org.objectweb.salome_tmf.data.Script;
import org.objectweb.salome_tmf.data.TestList;
import org.objectweb.salome_tmf.ihm.main.datawrapper.DataModel;
import org.objectweb.salome_tmf.ihm.tools.Tools;

public class Junit4ClassAnalyser  extends JunitAnalyser implements IJunitAnalyser{
	//TestResult pTestResult = null;
	RunNotifier pRunNotifier = null;
	Result pResult;
	SimpleJunitPlugin pSimpleJunitPlugin;
	JarUtil pJarUtil;
	ResultPrinter pResultPrinter = null;
	StringPrintStream pResultStrem = null;
	JUnitCore pJUnitCore;
	//org.junit.runner.JUnitCore 
	
	
	Junit4ClassAnalyser(SimpleJunitPlugin pSimpleJunitPlugin){
		super();
		this.pSimpleJunitPlugin = pSimpleJunitPlugin;
		pJarUtil = new JarUtil(pSimpleJunitPlugin);
		pJUnitCore = new JUnitCore();
	}
	
	
	
	public void createJunitTest(Attachment pSelectedattach, String strClass,  TestList pSuite, String toWrite){
		try { 
			ClassLoader pClassLoader = pJarUtil.loadJar(pSelectedattach);
			Util.log("[SimpleJunitPlugin:createJunitTest] try to load class : "+ strClass);
			
			Class pTestClass =  pClassLoader.loadClass(strClass);
			Method[] pMethods = pTestClass.getDeclaredMethods(); 
			for (int i = 0; i < pMethods.length; i++){
				Method pMethod = pMethods[i];
				
				Annotation[] pAnnotations = pMethod.getDeclaredAnnotations();
				for (int j = 0; j < pAnnotations.length; j++){
					Annotation pAnnotation =  pAnnotations[j];
					Util.log("[SimpleJunitPlugin:createJunitTest] Find Association : "+ pAnnotation);
					Util.log("[SimpleJunitPlugin:createJunitTest] Find Association Type: "+ pAnnotation.annotationType());
					if (pAnnotation.annotationType().equals(org.junit.Test.class)){
						String methName = pMethod.getName();
						Util.log("[SimpleJunitPlugin:createJunitTest] Taille des arguments "+ pMethod.getParameterTypes().length);
						Util.log("[SimpleJunitPlugin:createJunitTest] add test for " + methName);
						TestInfo testInfo = pMethod.getAnnotation(TestInfo.class);
						if (testInfo == null) {
							pSimpleJunitPlugin.addTest(methName, pSuite, toWrite +"test_meth = " + methName +"\n");
						} else {
							String description = testInfo.description();
							String [] idReqs = testInfo.requirementsId();
							pSimpleJunitPlugin.addTest(methName, description, idReqs, pSuite, toWrite +"test_meth = " + methName +"\n");
						}
						j = pAnnotations.length;
					}
					
				}
				
			}
		}catch (Exception e){
			Tools.ihmExceptionView(e);
			e.printStackTrace();
		}
		try {
			if (pSuite.getFamilyFromModel() != null){
				DataModel.reloadData(pSuite);
			} else {
				DataModel.reloadFromBase(true);
			}			
		} catch (Exception e){
			Tools.ihmExceptionView(e);
			e.printStackTrace();
		}
	}
	
	
	
	
	public int runTest(String strID, String strAttachment, String strClass, String meth, String testScript, org.objectweb.salome_tmf.data.AutomaticTest pTest, Hashtable argTest, String plugArg)  throws Exception{
		
		setExceutionResult(((ExecutionResult)argTest.get("salome_ExecResultObject")));
		
		// Add strAttachment in classloader if not
		Util.log("[SimpleJunitPlugin:runTest] chargement du jar " + strAttachment);
		//ClassLoader pClassLoader = loadJar(strID, strAttachment, pTest.getTestListFromModel(), testScript, pTest);
		ClassLoader pClassLoader = pJarUtil.loadJar(strID, strAttachment, testScript, pTest);
		
		Util.log("[SimpleJunitPlugin:runTest] chargement de la classe " + strClass);
		//Create instance of strClass
		Class pTestClass;
		try {
			pTestClass = (Class) cacheClass.get(strClass);
			if (pTestClass == null){
				pTestClass = pClassLoader.loadClass(strClass);
				cacheClass.put(strClass, pTestClass);
			}
		} catch (Exception e){
			e.printStackTrace();
			throw e;
		}
		
		try {
			Method pParamMethod = findStrMedtode("setSalomeParameters", pTestClass);
			if (pParamMethod != null){
				Util.log("[SimpleJunitPlugin:runTest] Find setSalomeParameters method");
				pParamMethod.invoke(null, argTest);
			}
		} catch (Exception e){
			e.printStackTrace();
		}
		strLog = (String) argTest.get("testLog");
		if (strLog == null){
			strLog = "";
		}
		pRunNotifier = new RunNotifier();
		Request pRequest =  Request.method(pTestClass, meth);
		pResult = pJUnitCore.run(pRequest);
		strLog = (String) argTest.get("testLog");

		Util.log("[SimpleJunitPlugin:runTest] Nb Result : " + pResult.getRunCount());
		
		if (pResult.getRunCount() < 1){
			return 1;
		}
		if (pResult.wasSuccessful())
			return 0;
		else 
			return 1;
		
		
	}
	
	public String getTestLog(){
		String res = "";   
		if (pResult != null){
			if (! pResult.wasSuccessful() || pResult.getRunCount() < 1){
				List<Failure> listFail = pResult.getFailures();
				int size = listFail.size();
				long time = pResult.getRunTime();
				res += "Time: " + time;
				res += "\nThere was 1 failure:";	
				if ( pResult.getRunCount() < 1){
					res = "\nNO TEST EXECUTED";
				}
				for (int i = 0 ; i < size ; i++) {
					Failure f = listFail.get(i);
					
					res += "\nTest :" + f.getTestHeader();
					res += "\n Description :" + f.getDescription().toString();
					res += "\n Message :" + f.getMessage();
					res += "\n Trace :" + f.getTrace();
				}
				if (strLog != null && !strLog.equals("")){
					res +="\nLOG FROM SALOME :\n" + strLog;
				}
			} else {
				long time = pResult.getRunTime();
				res += "Time: " + time;
				res += "\nOK (1 test)";
				if (strLog != null && !strLog.equals("")){
					res +="\nLOG FROM SALOME :\n" + strLog;
				}
			}
		}
		return res;
		
	}
	
	public void stopTest()  throws Exception{
		if (pRunNotifier != null) {
			Util.log("[SimpleJunitPlugin:stopTest] Stop the test");
			pRunNotifier.pleaseStop();
		}
	}
	
	Method findTestMedtode(String meth, Class pTestClass){
		Method pMethod = null; 
		Method[] pMethods = pTestClass.getDeclaredMethods(); 
		for (int i = 0; i < pMethods.length; i++){
			pMethod = pMethods[i];
			Annotation[] pAnnotations = pMethod.getDeclaredAnnotations();
			for (int j = 0; j < pAnnotations.length; j++){
				Annotation pAnnotation =  pAnnotations[j];
				if (pAnnotation.annotationType().equals(org.junit.Test.class)){
					String methName = pMethod.getName();
					if (meth.equals(methName)){
						return pMethod;
					}
				}
			}
		}
		return null;
	}
	
	/********************************** Beanshell *********************************************/
	public void createBeanShellJunitTest(Attachment pSelectedattach, String strClass,  TestList pSuite){
	       try {
	       ClassLoader pClassLoader = pJarUtil.loadJar(pSelectedattach);
			Util.log("[SimpleJunitPlugin:createJunitTest] try to load class : "+ strClass);
			
			Class pTestClass =  pClassLoader.loadClass(strClass);
			Method[] pMethods = pTestClass.getDeclaredMethods(); 
			for (int i = 0; i < pMethods.length; i++){
				Method pMethod = pMethods[i];
				
				Annotation[] pAnnotations = pMethod.getDeclaredAnnotations();
				for (int j = 0; j < pAnnotations.length; j++){
					Annotation pAnnotation =  pAnnotations[j];
					Util.log("[SimpleJunitPlugin:createJunitTest] Find Association : "+ pAnnotation);
					Util.log("[SimpleJunitPlugin:createJunitTest] Find Association Type: "+ pAnnotation.annotationType());
					if (pAnnotation.annotationType().equals(org.junit.Test.class)){
						String methName = pMethod.getName();
						Util.log("[SimpleJunitPlugin:createJunitTest] Taille des arguments "+ pMethod.getParameterTypes().length);
						Util.log("[SimpleJunitPlugin:createJunitTest] add test for " + methName);
						AddBeanshellTest(methName, pSuite, pSelectedattach, strClass );
					}
					
				}
				
			}
			 if (pSuite.getFamilyFromModel() != null){
					DataModel.reloadData(pSuite);
				} else {
					 DataModel.reloadFromBase(true);
				}
	       }catch (Exception e){
	           Tools.ihmExceptionView(e);
	           e.printStackTrace();
	       }
	       
	   }
	    
	    void AddBeanshellTest(String methName, TestList pSuite, Attachment pSelectedattach, String strClass ){
	    	String name = pSimpleJunitPlugin.getTestName(methName, pSuite, 0);
	    	AutomaticTest pTest = new AutomaticTest(name.trim(), "Junit TestCase", "beanshell.TestDriver");
	        pTest.setConceptorLoginInModel(DataModel.getCurrentUser().getLoginFromModel());
	       if (Api.isConnected()) {
	           try {
	        	   pSuite.addTestInDBAndModel(pTest);
	        	   Util.log("[SimpleJunitPlugin:AddBeanshellTest] add test " + name + "in DB & Model");
	               
	           } catch (Exception e1) {
	               Tools.ihmExceptionView(e1);
	               return;
	           }
	       }
	      
	       File file = null;
	       try {
	            Util.log("[SimpleJunitPlugin:AddBeanshellTest] Create test Script file");
	           file = writeBenshellJunitFile(pTest, methName, pSelectedattach, strClass );
	       }catch  (Exception e2) {
	           Tools.ihmExceptionView(e2);
	           return;
	       }
	       Script pScript = new Script(file.getName(),"Junit test script");
	       //pScript.setName(file.getName());
	       pScript.setLocalisation(file.getAbsolutePath());
	       pScript.setTypeInModel(ApiConstants.TEST_SCRIPT);
	       pScript.setScriptExtensionInModel(pTest.getExtensionFromModel());
	       //pScript.setPlugArg("");
	       
	       if (Api.isConnected()) {
	           try {
	               Util.log("[SimpleJunitPlugin:AddBeanshellTest] Add  : " +  pScript.getNameFromModel() + " to DB & Model") ;
	               pTest.addScriptInDBAndModel(pScript, file);
	           } catch (Exception e3) {
	               Tools.ihmExceptionView(e3);
	           }
	       }
	    }
	    
	    File writeBenshellJunitFile(AutomaticTest pTest, String methName, Attachment pSelectedattach, String strClass ) throws Exception {
	        String fileName;
	        File pFile;
	        Properties sys = System.getProperties();
	        String tmpDir = sys.getProperty("java.io.tmpdir");
	        String fs = sys.getProperty("file.separator");      
	        fileName = tmpDir + fs + pTest.getNameFromModel() + ".bsh";
	        Util.log("[SimpleJunitPlugin:writeBenshellJunitFile] write file  : " +  fileName) ;
	      
	        pFile = new File(fileName);
	        if (pFile.exists()){
	            pFile.delete();
	            pFile = new File(fileName);
	        }
	        FileOutputStream fos = new FileOutputStream(pFile);
	        BufferedOutputStream bos = new BufferedOutputStream(fos);
	        String toWrite = "import java.lang.Class;\n";
	        toWrite += "import java.util.Hashtable;\n";
	        toWrite += "import java.lang.reflect.Method;\n";
	        toWrite += "import org.junit.runner.JUnitCore;\n";
	        toWrite += "import org.junit.runner.Request;\n";
	        toWrite += "import org.junit.runner.Result;\n";
	        toWrite += "import java.lang.Class;\n";
	        toWrite += "import java.lang.annotation.Annotation;\n";
	        toWrite += "import java.lang.reflect.Method;\n\n";
	        
	        
	        toWrite += "Method findStrMedtode(String meth, Class pTestClass){\n";
	        toWrite += "	Method pMethod = null;\n"; 
	        toWrite += "	Method[] pMethods = pTestClass.getDeclaredMethods();\n"; 
	        toWrite += "	for (int i = 0; i < pMethods.length; i++){\n";
	        toWrite += "		pMethod = pMethods[i];\n";
	        toWrite += "		String methName = pMethod.getName();\n";
	        toWrite += "		if (meth.equals(methName)){\n";
	        toWrite += "			return pMethod;\n";
	        toWrite += "		}\n";
	        toWrite += "	}\n";
	        toWrite += "	return null;\n";
	        toWrite += "}\n";
	        
	        
	        toWrite +="/********** LOAD THE JAR ************/\n";
	        if (pSelectedattach instanceof FileAttachment) {
	        	toWrite += "fileJar = (salome_ProjectObject.getAttachmentFromModel(\""+ pSelectedattach.getNameFromModel()+"\")).getFileFromDB(); \n";
	        	toWrite += "addJar(fileJar.getAbsolutePath());\n";
	            
	        } else {
	            toWrite += "addJar(\""+ pSelectedattach.getNameFromModel()+"\");\n";
	        }
	        
	        toWrite += "testClass = Class.forName(\"" + strClass + "\", false,  salome_classloder);\n";
	       
	        toWrite +="/********** CALL setSalomeParameters if exist ************/\n";
	        toWrite += "try {\n";
	        toWrite += "	Method pParamMethod = findStrMedtode(\"setSalomeParameters\", testClass);\n";
	        toWrite += "	if (pParamMethod != null){\n";
	        toWrite += "		pParamMethod.invoke(null, new Object[] {testargs});\n";
	        toWrite += "	}\n";
	        toWrite += "} catch (Exception e){\n";
	        toWrite += "	//e.printStackTrace();\n";
	        toWrite += "}\n";
	        
	       
	        toWrite +="/********** CALL the test methode ************/\n";
	        
	        toWrite += "Request pRequest =  Request.method(testClass, \""+ methName +"\");\n";
	        toWrite += "pJUnitCore = new JUnitCore();\n";
	        toWrite += "pResult = pJUnitCore.run(pRequest);\n";
			
	        toWrite += "if (pResult.getRunCount() < 1){\n";
	        toWrite += "	Verdict = \"fail\";\n";
	        toWrite += "}\n";
	        toWrite += "if (pResult.wasSuccessful())\n";
	        toWrite += "	Verdict = \"pass\";\n";
	        toWrite += "else\n";
	        toWrite += "	Verdict = \"fail\";\n";
			
	        
	        Util.log("[SimpleJunitPlugin:writeBenshellJunitFile] write  : " +  toWrite) ;
	      
	        byte[] b = toWrite.getBytes();
	        bos.write(b, 0, b.length);
	        bos.flush();
	        bos.close();
	        return pFile;
	    }
}
