package org.objectweb.salome_tmf.ihm.admin;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Locale;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.LookAndFeel;
import javax.swing.UIManager;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.java.plugin.Extension;
import org.java.plugin.ExtensionPoint;
import org.java.plugin.PluginManager;
import org.objectweb.salome_tmf.api.Api;
import org.objectweb.salome_tmf.api.ApiConstants;
import org.objectweb.salome_tmf.api.JavaScriptUtils;
import org.objectweb.salome_tmf.api.MD5paswd;
import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.data.AdminVTData;
import org.objectweb.salome_tmf.data.Project;
import org.objectweb.salome_tmf.data.User;
import org.objectweb.salome_tmf.ihm.IHMConstants;
import org.objectweb.salome_tmf.ihm.languages.Language;
import org.objectweb.salome_tmf.ihm.main.AdminLogin;
import org.objectweb.salome_tmf.ihm.models.MyTableModel;
import org.objectweb.salome_tmf.ihm.tools.Tools;
import org.objectweb.salome_tmf.plugins.IPlugObject;
import org.objectweb.salome_tmf.plugins.JPFManager;
import org.objectweb.salome_tmf.plugins.UICompCst;
import org.objectweb.salome_tmf.plugins.core.Admin;
import org.objectweb.salome_tmf.plugins.core.Common;



public class Administration extends JApplet implements IPlugObject, ApiConstants, IHMConstants, ActionListener , WindowListener{
	
	boolean problemURL = false;
	
	JPasswordField oldPassword;
	JPasswordField newPasswordFirst;
	JPasswordField newPasswordSecond;
	
	/**
	 * Les onglets d'administration
	 */
	JTabbedPane tabs;
	
	/**
	 * Le panel de la fenetre dans son ensemble
	 */
	JPanel adminVoiceTesting;
	
	/**
	 * Vue pour changer les mots de passe
	 */
	JPanel changePwdView;
	
	/**
	 * Vue pour la gestion des projets
	 */
	JPanel projectView;
	
	/**
	 * Vue pour la gestion des utilisateurs
	 */
	JPanel usersView;
	
	/**
	 * Vue de droite de la fenetre
	 */
	JPanel adminView;
	
	/**
	 * Vue de droite de la fenetre pour le controle des sessions
	 */
	AdminSessionPanel sessionView;
	/**
	 * Modele de donnees de la table des projets
	 */
	MyTableModel projectTableModel;
	
	/**
	 * Table des projets
	 */
	JTable projectTable;
	
	/**
	 * Modele de donnees de la table des utilisateurs
	 */
	MyTableModel usersTableModel;
	
	/**
	 * Table des utilisateurs
	 */
	JTable userTable;
	
	/**
	 * Bouton pour supprimer un projet
	 */
	JButton deleteProjectButton;
	
	/**
	 * Bouton pour la suppression d'un utilisateur
	 */
	JButton deleteUserButton;
	
	/**
	 * Bouton pour le changement de mot de passe d'un utilisateur
	 */
	
	
	Color normalColor;
	
	Color freezeColor;
	
	Color localColor;
	
	JButton modifyProjectButton;
	JButton createProjectButton;
	JButton freezeButton;
	JButton createUserButton;
	JButton changeUserPwdButton;
	JButton modifyUserButton;
	JButton validateButton;
	JButton cancelButton;
	/**
	 * Mapping between UI components and constants defined in org.objectweb.salome_tmf.ihm.UICompCst
	 */
	static Map UIComponentsMap;
	
	public static Frame ptrFrame;
	
	public static Hashtable associatedTestDriver;
	public static Hashtable associatedScriptEngine;
	public static Hashtable associatedExtension;
	public static Vector bugTrackers;
	public static Vector reqManagers;
	public Vector xmlPrinters = new Vector();
	public static JPFManager jpf;
	
	public static URL urlAdmin = null;
	
	URL recup;
	
	/* dbClosed = true if connection to database is close normaly (no reload or back from browser) */
	boolean closeDB =  true;
	/* reload = true if applet is start again from same JVM (reload or back from browser) */
	//static boolean reload = false;
	
	String adminSalome = null;
	int idConn = -1;
	
	static public AdminVTData pAdminVTData;
	boolean standAlone = false;
	static boolean exit = false;
	/******************************************************************************/
	/** 							METHODES PUBLIQUES							***/
	/******************************************************************************/
	JavaScriptUtils pJSUtils;
	
	void onInit(){
		standAlone = false;
		if (connectToAPI()){
			closeDB = true;
			initComponent();
			loadModel();
		}
		exit = false;
	}
	
	void onStart(){
		
	}
	
	void initComponent(){
		System.runFinalization();
		System.gc();
		
		javax.swing.JOptionPane.getFrameForComponent(Administration.this).addWindowListener(this);
		
		Api.setUrlBase(getDocumentBase());
		urlAdmin = getDocumentBase(); 
		
		Language.getInstance().setLocale(new Locale(Api.getUsedLocale()));
		ptrFrame = javax.swing.JOptionPane.getFrameForComponent(Administration.this);
		try {
			Class lnfClass = Class.forName(UIManager.getSystemLookAndFeelClassName());
			LookAndFeel newLAF = (LookAndFeel)(lnfClass.newInstance());
			UIManager.setLookAndFeel(newLAF);
			Util.adaptFont();
		} catch (Exception exc) {
			System.err.println("Error loading L&F: " + exc);
		}
		
		oldPassword = new JPasswordField(20);
		
		newPasswordFirst = new JPasswordField(20);
		
		newPasswordSecond = new JPasswordField(20);
		
		tabs = new JTabbedPane();
		
		adminVoiceTesting = new JPanel(new BorderLayout());
		
		changePwdView = new JPanel(new BorderLayout());
		
		projectView  = new JPanel(new BorderLayout());
		
		usersView  = new JPanel(new BorderLayout());
		
		sessionView = new AdminSessionPanel();
		
		adminView = new JPanel(new BorderLayout());
		
		projectTableModel = new MyTableModel();
		
		usersTableModel = new MyTableModel();
		
		userTable = new JTable();
		
		associatedTestDriver = new Hashtable();
		associatedScriptEngine =  new Hashtable();
		associatedExtension =  new Hashtable();
		bugTrackers = new Vector();
		reqManagers = new Vector();
		
		deleteProjectButton = new JButton(Language.getInstance().getText("Supprimer"));
		
		deleteUserButton = new JButton(Language.getInstance().getText("Supprimer"));
		
		changeUserPwdButton = new JButton(Language.getInstance().getText("Changer_le_mot_de_passe"));
		
		normalColor = new Color(204,255,204);
		freezeColor = new Color(204,204,255);
		localColor = Color.RED;
		
		// Mapping between UI components and constants
		UIComponentsMap = new HashMap();
		
		// Onglets
		tabs.addTab(Language.getInstance().getText("Administration_SalomeTMF"),	adminVoiceTesting);
		tabs.setPreferredSize(new Dimension(500,500));
		
		//Create the radio buttons.
		JRadioButton changePwdButton = new JRadioButton(Language.getInstance().getText("Changer_le_mot_de_passe"));
		changePwdButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				adminView.removeAll();
				adminView.add(changePwdView, BorderLayout.CENTER);
				adminView.validate();
				adminView.repaint();
			}
		});
		
		JRadioButton projectButton = new JRadioButton(Language.getInstance().getText("Gerer_les_projets"));
		projectButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				adminView.removeAll();
				adminView.add(projectView, BorderLayout.CENTER);
				adminView.validate();
				adminView.repaint();
			}
		});
		
		JRadioButton usersButton = new JRadioButton(Language.getInstance().getText("Gerer_les_utilisateurs"));
		usersButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				adminView.removeAll();
				adminView.add(usersView, BorderLayout.CENTER);
				adminView.validate();
				adminView.repaint();
			}
		});
		//***************** Panel de controle des sessions *********************//
		JRadioButton sessionButton = new JRadioButton(Language.getInstance().getText("Gerer_les_sessions"));
		sessionButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				adminView.removeAll();
				adminView.add(sessionView , BorderLayout.CENTER);
				adminView.validate();
				adminView.repaint();
			}
		});
		
		//////////////////////////////////////////////////////////////////////////
		//On groupe les radiobuttons
		ButtonGroup adminButtonGroup = new ButtonGroup();
		adminButtonGroup.add(changePwdButton);
		adminButtonGroup.add(projectButton);
		adminButtonGroup.add(usersButton);
		adminButtonGroup.add(sessionButton);
		
		JPanel radioPanel = new JPanel(new GridLayout(0, 1));
		radioPanel.add(Box.createRigidArea(new Dimension(1,40)));
		radioPanel.add(changePwdButton);
		radioPanel.add(Box.createRigidArea(new Dimension(1,40)));
		radioPanel.add(projectButton);
		radioPanel.add(Box.createRigidArea(new Dimension(1,40)));
		radioPanel.add(usersButton);
		radioPanel.add(Box.createRigidArea(new Dimension(1,40)));
		radioPanel.add(sessionButton);
		
		JPanel testPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		testPanel.add(radioPanel);
		
		
		JButton backButton = new JButton(Language.getInstance().getText("Quitter"));
		backButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				quit(true, true);
			}
		});
		
		JPanel radioPanelAll = new JPanel(new BorderLayout());
		radioPanelAll.add(testPanel);
		radioPanelAll.add(backButton, BorderLayout.SOUTH);
		radioPanelAll.setBorder(BorderFactory.createRaisedBevelBorder());
		
		
		//AdminProjectData.initData();
		//AdminVTData.initData();
		createChangePwdView();
		createUsersView();
		createProjectView();
		adminView.removeAll();
		
		// On remplit le panel adminVoiceTesting
		adminVoiceTesting.add(BorderLayout.WEST,radioPanelAll);
		adminVoiceTesting.add(BorderLayout.CENTER,adminView);
		
		Container cp = this.getContentPane();
		cp.add(tabs);
	}
	
	 boolean connectToAPI(){
		 Util.log("[Administration->connectToAPI] open connection");
		 pJSUtils = new JavaScriptUtils(this);
		 if (Api.getNbConnect()>0) {
			 JOptionPane.showMessageDialog(Administration.this,
					 Language.getInstance().getText("Vous_avez_deja_une_session_Salome_ouverte_avec_ce_navigateur") +
					 Language.getInstance().getText("Une_seule_session_est_autorisee_par_navigateur_afin_d_eviter_les_conflits_"),
					 Language.getInstance().getText("Erreur_"),
					 JOptionPane.ERROR_MESSAGE);
			 quit(false, false);
			 closeDB = false;
			 return false;
		 } else {
			 Api.openConnection(getDocumentBase());
			 
			 if (!Api.isConnected()){
				 JOptionPane.showMessageDialog(Administration.this,
						 "Can't connect to the database",
						 Language.getInstance().getText("Erreur_"),
						 JOptionPane.ERROR_MESSAGE);
				 closeDB = false;
				 quit(true, false);
				 return false;
			 }
			 
			 String[] params = new String[2];;
			/* if (!Api.isIDE_DEV()) {
				 params = Tools.chooseProjectAndUser(getDocumentBase());
				 Util.log("[Administration.start()] conn. with project = " + params[0]);
				 Util.log("[Administration.start()] conn. with user = " + params[1]);
			 } else {
				params = new String[2];
				 params[0] = "ALL";
				 params[1] = ADMIN_SALOME_NAME;
				 
			 }*/
			 params[1]= pJSUtils.getLoginCookies();
			 params[0] = pJSUtils.getProjectCookies();
			 if ((params[0] == null)||(params[0].equals(""))) {
				 AdminLogin dialog = new AdminLogin();
					dialog.setVisible(true);
					if(dialog.isLoged()){
						 params[0] = "ALL";
						 params[1] = ADMIN_SALOME_NAME;
						 standAlone = true;
						 
	            		// Recuperation du login et du mot de passe pour l'authentification
						try {
							Api.setStrUsername(ADMIN_SALOME_NAME);
							Api.setStrMD5Password(MD5paswd.getEncodedPassword(dialog.getSelectedPassword()));
						} catch (Exception e) {
							e.printStackTrace();
						}
					}
			 }
			adminSalome = params[1];
			Api.initConnectionUser(params[0], params[1]);
			 /*try {
				 String[] tab = getDocumentBase().toString().split("[?=]");
				 idConn = Integer.parseInt(tab[2]);
			 } catch(Exception e){
				 Util.log("[Administration->connectToAPI] WARNING idConn can't be found");
			 }
			 if ((params[0] == null)||(params[0].equals("")) || (!params[0].equals("ALL"))) {
				 JOptionPane.showMessageDialog(Administration.this,
						 Language.getInstance().getText("Probleme_dans_l_URL_saisie_"),
						 Language.getInstance().getText("Erreur_"),
						 JOptionPane.ERROR_MESSAGE);
				
				 problemURL = true;	 
				 closeDB = true;
				 quit(true, true);
				 return false;
			 }*/
			 return true;
		 }
	 }
	 
	 void loadModel(){
		loadSalomeData();
		if (Api.isALLOW_PLUGINS()) {
			jpf = new JPFManager();
			jpf.startJPFInAdmin(this.getDocumentBase(), UIComponentsMap, this);
		}	
		
	 }
	 
	/**
	 * Methode d'initialisation de l'applet
	 */
	 public void init() {
		 onInit();
	 }
	
	/**
	 * Methode appelee a chaque chargement de la page
	 */
	 
	 public void start() {
		 onStart();
	 } 
	
	
	/**
	 * Methode qui creer l'ecran permettant de changer le mot de passe.
	 */
	public void createChangePwdView() {
		adminView.removeAll();
		
		validateButton = new JButton(Language.getInstance().getText("Valider"));
		validateButton.setToolTipText(Language.getInstance().getText("Valider"));
		validateButton.addActionListener(this);
		
		cancelButton = new JButton(Language.getInstance().getText("Annuler"));
		cancelButton.setToolTipText(Language.getInstance().getText("Annuler"));
		cancelButton.addActionListener(this);
		
		JLabel oldQuestion = new JLabel(Language.getInstance().getText("Entrez_votre_ancien_mot_de_passe_"));
		JLabel question = new JLabel(Language.getInstance().getText("Entrez_votre_nouveau_mot_de_passe_"));	
		JLabel confirmation = new JLabel(Language.getInstance().getText("Confirmer_le_nouveau_mot_de_passe_"));
		
		
		JPanel textFieldPane = new JPanel();
		textFieldPane.setLayout(new BoxLayout(textFieldPane,BoxLayout.Y_AXIS));
		textFieldPane.add(oldPassword);
		textFieldPane.add(Box.createRigidArea(new Dimension(1,50)));
		textFieldPane.add(newPasswordFirst);
		textFieldPane.add(Box.createRigidArea(new Dimension(1,50)));
		textFieldPane.add(newPasswordSecond);
		
		JPanel textPane = new JPanel();
		textPane.setLayout(new BoxLayout(textPane,BoxLayout.Y_AXIS));
		textPane.add(oldQuestion);
		textPane.add(Box.createRigidArea(new Dimension(1,50)));
		textPane.add(question);
		textPane.add(Box.createRigidArea(new Dimension(1,50)));
		textPane.add(confirmation);
		
		JPanel textPaneAll = new JPanel(new FlowLayout(FlowLayout.CENTER));
		textPaneAll.add(textPane);
		textPaneAll.add(textFieldPane);
		
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		buttonPanel.add(validateButton);
		buttonPanel.add(cancelButton);
		
		JPanel labelSet = new JPanel();
		labelSet.add(textPaneAll);
		labelSet.setBorder(BorderFactory.createEmptyBorder(100, 10, 10, 100));
		
		changePwdView.setLayout(new BoxLayout(changePwdView, BoxLayout.Y_AXIS));
		changePwdView.add(labelSet);
		changePwdView.add(buttonPanel);
		changePwdView.setBorder(BorderFactory.createRaisedBevelBorder());
		changePwdView.validate();
	} 
	
	/**
	 * Methode qui permet de creer l'ecran permettant de gerer les projets.
	 *
	 */
	public void createProjectView() {
		
		adminView.removeAll();
		
		// Les boutons
		createProjectButton = new JButton(Language.getInstance().getText("Creer"));
		createProjectButton.setToolTipText(Language.getInstance().getText("Creer_un_nouveau_projet"));
		createProjectButton.addActionListener(this);
		
		modifyProjectButton = new JButton(Language.getInstance().getText("Modifier"));
		modifyProjectButton.setEnabled(false);
		modifyProjectButton.setToolTipText(Language.getInstance().getText("Modifier_un_projet"));
		modifyProjectButton.addActionListener(this);
		
		freezeButton = new JButton(Language.getInstance().getText("Geler"));
		freezeButton.setEnabled(false);
		freezeButton.setToolTipText(Language.getInstance().getText("Geler_un_projet"));
		freezeButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int selectedRow = projectTable.getSelectedRow();
				if (selectedRow != -1) {
					/*Project project = pAdminVTData.getProjectFromModel((String)projectTableModel.getValueAt(selectedRow,1));
					 if (project.getLock() == null) {
					 ProjectTableCellRenderer.setColor(selectedRow, freezeColor);
					 projectTableModel.setValueAt(Tools.createAppletImageIcon(PATH_TO_FREEZED_PROJECT_ICON,""), selectedRow, 0);
					 project.setLock(new Lock());
					 } else {
					 ProjectTableCellRenderer.setColor(selectedRow, normalColor);
					 projectTableModel.setValueAt(Tools.createAppletImageIcon(PATH_TO_PROJECT_ICON,""), selectedRow, 0);
					 project.setLock(null);
					 }*/
					 
				}
			}
		});
		
		
		deleteProjectButton.setToolTipText(Language.getInstance().getText("Supprimer_un_projet"));
		deleteProjectButton.setEnabled(false);
		deleteProjectButton.addActionListener(this);
		
		
		JPanel buttonSet = new JPanel(new FlowLayout());
		buttonSet.setAlignmentY(FlowLayout.LEFT);
		buttonSet.add(createProjectButton);
		buttonSet.add(modifyProjectButton);
		buttonSet.add(freezeButton);
		buttonSet.add(deleteProjectButton);
		buttonSet.setBorder(BorderFactory.createRaisedBevelBorder());
		// Mapping entre composants graphiques et constantes
		UIComponentsMap.put(UICompCst.ADMIN_PROJECT_MANAGEMENT_BUTTONS_PANEL,buttonSet);
		
		// La table des projets
		JLabel projectsTableLabel = new JLabel(Language.getInstance().getText("Liste_des_projets_existants__"));
		projectsTableLabel.setFont(new Font(null,Font.BOLD,20));
		projectsTableLabel.setSize(300,60);
		
		projectTableModel.addColumnNameAndColumn("");
		projectTableModel.addColumnNameAndColumn(Language.getInstance().getText("Nom_du_projet"));
		projectTableModel.addColumnNameAndColumn(Language.getInstance().getText("Administrateur"));
		projectTableModel.addColumnNameAndColumn(Language.getInstance().getText("Date_de_creation"));
		projectTableModel.addColumnNameAndColumn(Language.getInstance().getText("Description"));
		
		projectTable = new JTable();
		//projectTable.setDefaultRenderer(String.class, new ProjectTableCellRenderer());
		projectTable.setModel(projectTableModel);
		projectTable.setPreferredScrollableViewportSize(new Dimension(600, 200));
		projectTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		// Mapping between UI components and constants
		UIComponentsMap.put(UICompCst.ADMIN_PROJECT_MANAGEMENT_TABLE,projectTable);
		
		projectTable.setModel(projectTableModel);
		
		JScrollPane tablePane = new JScrollPane(projectTable);
		
		ListSelectionModel rowSMForUserTable = projectTable.getSelectionModel();
		rowSMForUserTable.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				int[] selectedRows= projectTable.getSelectedRows();
				if (selectedRows.length > 0) {
					if (selectedRows.length == 1) {
						modifyProjectButton.setEnabled(true);
					} else {
						modifyProjectButton.setEnabled(false);
					}
					deleteProjectButton.setEnabled(true);
					freezeButton.setEnabled(true);
				} else {
					deleteProjectButton.setEnabled(false);
					modifyProjectButton.setEnabled(false);
					freezeButton.setEnabled(false);
				}
			}
		});
		
		
		
		JPanel center = new JPanel(new BorderLayout());
		center.add(BorderLayout.NORTH, projectsTableLabel);
		center.add(BorderLayout.CENTER, tablePane);
		center.setBorder(BorderFactory.createEmptyBorder(20,10,10,10));
		
		projectView.add(BorderLayout.NORTH,buttonSet);
		projectView.add(BorderLayout.CENTER,center);
		
		
		
	} // Fin de la classe createProjectView/0
	
	/**
	 * Methode qui permet de creer l'ecran permettant de gerer les utilisateurs.
	 *
	 */
	public void createUsersView() {
		
		
		// Les boutons
		createUserButton = new JButton(Language.getInstance().getText("Creer"));
		createUserButton.setToolTipText(Language.getInstance().getText("Creer_un_nouvel_utilisateur"));
		createUserButton.addActionListener(this);
		
		modifyUserButton = new JButton(Language.getInstance().getText("Modifier"));
		modifyUserButton.setToolTipText(Language.getInstance().getText("Modifier_un_utilisateur"));
		modifyUserButton.setEnabled(false);
		modifyUserButton.addActionListener(this);
		
		
		deleteUserButton.setToolTipText(Language.getInstance().getText("Supprimer_un_utilisateur"));
		deleteUserButton.setEnabled(false);
		deleteUserButton.addActionListener(this);
		
		
		changeUserPwdButton.setToolTipText(Language.getInstance().getText("Changer_le_mot_de_passe"));
		changeUserPwdButton.setEnabled(false);
		changeUserPwdButton.addActionListener(this);
		
		
		JPanel buttonSet = new JPanel(new FlowLayout());
		buttonSet.setAlignmentY(FlowLayout.LEFT);
		buttonSet.add(createUserButton);
		buttonSet.add(modifyUserButton);
		buttonSet.add(deleteUserButton);
		buttonSet.add(changeUserPwdButton);
		buttonSet.setBorder(BorderFactory.createRaisedBevelBorder());
		
		// La table des projets
		JLabel projectsTableLabel = new JLabel(Language.getInstance().getText("Liste_des_utilisateurs__"));
		projectsTableLabel.setFont(new Font(null,Font.BOLD,20));
		projectsTableLabel.setSize(300,60);
		
		
		
		usersTableModel.addColumnNameAndColumn(Language.getInstance().getText("Login"));
		usersTableModel.addColumnNameAndColumn(Language.getInstance().getText("Nom"));
		usersTableModel.addColumnNameAndColumn(Language.getInstance().getText("Prenom"));
		usersTableModel.addColumnNameAndColumn(Language.getInstance().getText("Email"));
		usersTableModel.addColumnNameAndColumn(Language.getInstance().getText("Telephone"));
		
		userTable.setModel(usersTableModel);
		
		
		userTable.setPreferredScrollableViewportSize(new Dimension(500, 200));
		JScrollPane tablePane = new JScrollPane(userTable);
		userTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		ListSelectionModel rowSMForUserTable = userTable.getSelectionModel();
		rowSMForUserTable.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				int[] selectedRows= userTable.getSelectedRows();
				if (selectedRows.length > 0) {
					if (selectedRows.length == 1) {
						changeUserPwdButton.setEnabled(true);
						modifyUserButton.setEnabled(true);
					} else {
						changeUserPwdButton.setEnabled(false);
						modifyUserButton.setEnabled(false);
					}
					deleteUserButton.setEnabled(true);
				} else {
					deleteUserButton.setEnabled(false);
					changeUserPwdButton.setEnabled(false);
					modifyUserButton.setEnabled(false);
				}
			}
		});
		
		JPanel center = new JPanel(new BorderLayout());
		center.add(BorderLayout.NORTH, projectsTableLabel);
		center.add(BorderLayout.CENTER, tablePane);
		center.setBorder(BorderFactory.createEmptyBorder(20,10,10,10));
		
		usersView.add(BorderLayout.NORTH,buttonSet);
		usersView.add(BorderLayout.CENTER,center);
	} // Fin de la methode createUsersView/0
	
	/**
	 * Methode d'initialisation des donnees a la connection sur la base de
	 * donnees.
	 */
	private void loadSalomeData(){
		try {
			//DB
			pAdminVTData = new AdminVTData();
			
			pAdminVTData.loadData();
			//pAdminVTData.setUserAdminVTData(ADMIN_SALOME_NAME);
			pAdminVTData.setUserAdminVTData(adminSalome);
			//IHM
			usersTableModel.clearTable();
			ArrayList allUser = pAdminVTData.getAllUsersFromModel();
			Vector logins = new Vector();
			Vector names = new Vector();
			Vector firstNames = new Vector();
			Vector phones = new Vector();
			Vector emails = new Vector();
			
			//Vector descriptions = new Vector();
			
			for (int i=0; i < allUser.size(); i++){
				User pUser = (User) allUser.get(i);
				logins.add(pUser.getLoginFromModel());
				names.add(pUser.getLastNameFromModel());
				firstNames.add(pUser.getFirstNameFromModel());
				phones.add(pUser.getPhoneNumberFromModel());
				emails.add(pUser.getEmailFromModel());
			}
			usersTableModel.addDataColumn(logins, 0);
			usersTableModel.addDataColumn(names, 1);
			usersTableModel.addDataColumn(firstNames, 2);
			usersTableModel.addDataColumn(emails, 3);
			usersTableModel.addDataColumn(phones, 4);
			
			projectTableModel.clearTable();
			ArrayList allProjects = pAdminVTData.getProjectListFromModel();
			
			Vector projectNames = new Vector();
			Vector projectDescs  = new Vector();
			Vector projectDate  = new Vector();
			Vector projectAdminLogins  = new Vector();
			int nbProj = allProjects.size();
			for (int i=0; i < nbProj; i++){
				Project pProject = (Project) allProjects.get(i);
				projectNames.add(pProject.getNameFromModel());
				projectDescs.add(pProject.getDescriptionFromModel());
				projectDate.add(pProject.getCreationDateFromModel());
				projectAdminLogins.add(pProject.getAdministratorFromModel().getLoginFromModel());
				
			}
			
			
			projectTableModel.addDataColumn(projectNames, 1);
			projectTableModel.addDataColumn(projectAdminLogins, 2);
			projectTableModel.addDataColumn(projectDate, 3);
			projectTableModel.addDataColumn(projectDescs, 4);
			
			for (int i=0; i < nbProj; i++){
				projectTableModel.addValueAt(Tools.createAppletImageIcon(PATH_TO_PROJECT_ICON,""), i, 0);		
			}
			
			projectTable.getColumnModel().getColumn(0).setMaxWidth(18);
			sessionView.loadDataFromDB();
		} catch (Exception e){
			e.printStackTrace();
			//ConnectionData.setConnected(false);
			JOptionPane.showMessageDialog(Administration.this,
					Language.getInstance().getText("Impossible_de_se_connecter_a_la_base__on_travaille_en_local_"),
					Language.getInstance().getText("Erreur_"),
					JOptionPane.ERROR_MESSAGE);
		}
		
	} // Fin de la methode initDataVoiceTesting/0
	
	/**
	 *
	 * @param project
	 * @return
	 */
	public int getIndexOfProject(Project project) {
		for (int i = 0; i < projectTableModel.getRowCount(); i++) {
			if (projectTableModel.getValueAt(i,1).equals(project.getNameFromModel())) {
				return i;
			}
		}
		return -1;
	}
	
	/*public void update(Observable observable, Object obj) {
		if (obj instanceof Vector) {
			if (((Vector)obj).size() > 0) DataModel.apiExceptionView((Vector)obj);
		}
	}*/
	
	
	
	public void destroy() {
		Util.log("[Administration] Destroy");
		//Api.isAlreadyConnected=false;
		if (closeDB) {
			Api.closeConnection();
		}
		Util.log("[Administration] End Destroy");
	}
	
	public void quit(boolean do_recup,  boolean doclose) {
		Util.log("[Administration] Quit");
		if (Api.isConnected() && doclose) {
			if (!problemURL && !Api.isIDE_DEV() && idConn!=-1) {
				Api.deleteConnection(idConn);
			}
			closeDB = false;
			Api.closeConnection();
		}
		Frame ptrFrame = javax.swing.JOptionPane.getFrameForComponent(Administration.this); 
		ptrFrame.dispose();
        ptrFrame = null;
        System.gc();
        System.runFinalization(); 
        
        try {
        	if (!standAlone) {
        		if (do_recup){
        			/* recupere l'URL a partir du document courant et "page.html" */
        			recup = new URL(getDocumentBase(), "index.html");
        			/* Affiche le document apres avoir recuperer le contexte courant */
        			getAppletContext().showDocument(recup);
        			repaint();
        		} else {
        			getAppletContext().showDocument(new URL("http://wiki.objectweb.org/salome-tmf"));
        		}
        	} else {
        		 if (pJSUtils != null){
        	        	pJSUtils.closeWindow();
        	        }
        	}   
        } catch (MalformedURLException me) {
        	recup = null;
        	me.printStackTrace();
        }
        exit = true;
	}
	
	/*void closeWindow(){
		try {
			//Class classJSObject = Class.forName("sun.plugin.javascript.JSObject");	
			Class classJSObject = Class.forName("netscape.javascript.JSObject");
			Method meth_getWindow = classJSObject.getMethod("getWindow", new Class[] {Applet.class});
			Object pJSObject = meth_getWindow.invoke(null ,new Object[] {this});
			System.out.println("pJSObject = " + pJSObject);
			Method meth_call  = classJSObject.getMethod("call", new Class[] {String.class, Object[].class});
			meth_call.invoke(pJSObject, new Object[] {"close", null});
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}*/
	
	/**
	 * Methode qui renvoie l'objet graphique associ? ? une constante
	 * @return
	 * @param uiConst
	 */
	public static Object getUIComponent(Integer uiConst) {
		Object comp = null;
		if (UIComponentsMap != null)
			comp = UIComponentsMap.get(uiConst); 
		return comp;
	}
	
	/******************************** IPlugObject Implementation ********************/
	public Object associatedExtension(Object key, Object value) {
		//implementation by Hastable
		return associatedExtension.put(key, value);
	}
	
	public Object associatedScriptEngine(Object key, Object value) {
		//implementation by Hastable
		return associatedScriptEngine.put(key, value);
	}
	
	public Object associatedTestDriver(Object key, Object value) {
		//implementation by Hastable
		return associatedTestDriver.put(key,value);
	}
	
	public Object getAssociatedExtension(Object key){
		return associatedExtension.get(key);
	}
	
	public Object getAssociatedScriptEngine(Object key){
		return associatedScriptEngine.get(key);
	}
	
	public Object get1ssociatedTestDriver(Object key) {
		return associatedTestDriver.get(key);
	}
	
	
	public void initExtsionTestDriver(ExtensionPoint ext) {
		if (!ext.getConnectedExtensions().isEmpty()) {
			for (Iterator it = ext.getConnectedExtensions()
					.iterator(); it.hasNext();) {
				try {
					Extension testDriverExt = (Extension) it.next();
					String extList = testDriverExt.getParameter("extensions")
					.valueAsString();
					associatedTestDriver(testDriverExt, extList);
					associatedExtension(testDriverExt.getId(),
							testDriverExt);
					Util.log("Add testDriverExt : "
							+ testDriverExt.getId());
				} catch (Exception e) {
					// TODO
					e.printStackTrace();
				}
			}
		}
	}
	public void initExtsionScriptEngine(ExtensionPoint pExtsionScriptEngine) {
		if (!pExtsionScriptEngine.getConnectedExtensions().isEmpty()) {
			for (Iterator it = pExtsionScriptEngine.getConnectedExtensions()
					.iterator(); it.hasNext();) {
				try {
					Extension scriptEngineExt = (Extension) it.next();
					String extList = scriptEngineExt.getParameter("extensions")
					.valueAsString();
					associatedScriptEngine(scriptEngineExt,
							extList);
					associatedExtension(scriptEngineExt.getId(),
							scriptEngineExt);
					Util.log("Add ExtsionScriptEngine : "
							+ scriptEngineExt.getId());
				} catch (Exception e) {
					// TODO
					e.printStackTrace();
				}
			}
		}
	}
	
	public void showMessage(String msg) {
		//initExtsionScriptEngine
	}
	
	public void  init_Component(PluginManager pluginManager, ExtensionPoint commonE, ExtensionPoint testE, ExtensionPoint scriptE, ExtensionPoint bugTrackE, ExtensionPoint reqMgr){
		
	}
	
	public void addPlgToUICompList(Integer id, Common plugin) {
		
	}
	
	public URL getUrlBase() {
		return urlAdmin;
	}
	
	public JPFManager getPluginManager() {
		return jpf;
	}
	
	public void addXMLPrinterExtension(Object xmlPrinter){
		if (!xmlPrinters.contains(xmlPrinter)){
			xmlPrinters.add(xmlPrinter);
		}
	}
	
	public Vector getXMLPrintersExtension() {
		return xmlPrinters;
	}
	
	/******************************** ActionListener Implemntation ******************/
	
	public void actionPerformed(ActionEvent e){
		if (e.getSource().equals(deleteProjectButton)){
			deleteProjectPerformed();
		} else if (e.getSource().equals(modifyProjectButton)){
			modifyProjectPerformed();
		} else if (e.getSource().equals(validateButton)){
			validatePerformed();
		} else if (e.getSource().equals(cancelButton)){
			cancelPerformed();
		} else if (e.getSource().equals(createProjectButton)){
			createProjectPerformed();
		} else if (e.getSource().equals(createUserButton)){
			createUserPerformed();
		} else if (e.getSource().equals(modifyUserButton)){
			modifyUserPerformed();
		} else if (e.getSource().equals(deleteUserButton)){
			deleteUserPerformed();
		}else if (e.getSource().equals(changeUserPwdButton)){
			changeUserPwdPerformed();
		}
	}
	
	void changeUserPwdPerformed() {
		AskName askName = new AskName(Language.getInstance().getText("Nouveau_mot_de_passe__"), Language.getInstance().getText("Changer_le_mot_de_passe"), Language.getInstance().getText("passe"), null,javax.swing.JOptionPane.getFrameForComponent(Administration.this));
		if (askName.getResult() != null) {
			if (Api.isConnected()) {
				int selectedIndex = userTable.getSelectedRow();
				if (selectedIndex != -1) {
					try {
						String userLogin = (String)usersTableModel.getValueAt(selectedIndex,0);
						User pUser = pAdminVTData.getUserFromModel(userLogin);
						pUser.updatePasswordInDB(askName.getResult());
					} catch (Exception exception) {
						Tools.ihmExceptionView(exception);
					}
				}
			}
		}
	}
	
	void deleteUserPerformed() {
		int[] selectedRowsTab = userTable.getSelectedRows();
		String message = "";
		for (int i = selectedRowsTab.length-1; i >= 0; i--) {
			message = message + " * " + usersTableModel.getValueAt(selectedRowsTab[i],0);
			if (i == 0) {
				message  = message + "?";
			} else {
				message = message + "\n";
			}
		}
		Object[] options = {Language.getInstance().getText("Oui"), Language.getInstance().getText("Non")};
		int choice = JOptionPane.showOptionDialog(Administration.this,
				Language.getInstance().getText("Etes_vous_sur_de_vouloir_supprimer_les_utilisateurs__") + message ,
				Language.getInstance().getText("Attention_"),
				JOptionPane.YES_NO_OPTION,
				JOptionPane.QUESTION_MESSAGE,
				null,
				options,
				options[1]);
		if (choice == JOptionPane.YES_OPTION) {
			for (int i = selectedRowsTab.length-1; i >= 0; i--) {
				ArrayList projectsList = pAdminVTData.getProjectsWithThisUserAdminFromModel((String)usersTableModel.getValueAt(selectedRowsTab[i],0));
				ArrayList prjsWithUsrAsUniqueAdmin = new ArrayList();
				if (projectsList.size() > 0) {
					message = "";
					boolean prjWithUniqueAdmin = false;
					for (int k = projectsList.size()-1; k >= 0 ; k--) {
						if (pAdminVTData.getAdminCountFromModel((Project)projectsList.get(k)) == 1) {
							message = message + " * " + ((Project)projectsList.get(k)).getNameFromModel() + "\n";
							prjsWithUsrAsUniqueAdmin.add(projectsList.get(k));
							prjWithUniqueAdmin = true;
						}
					}
					if (prjWithUniqueAdmin) {
						choice = JOptionPane.showOptionDialog(Administration.this,
								Language.getInstance().getText("L_utilisateur_") + (String)usersTableModel.getValueAt(selectedRowsTab[i],0) + Language.getInstance().getText("_est_le_seul_administrateur_des_projets_") + message +
								Language.getInstance().getText("Sa_suppression_entrainera_la_suppression_des_projets_dans_leur_ensemble_Etes_vous_sur_de_vouloir_supprimer_cet_utilisateur_") ,
								Language.getInstance().getText("Attention_"),
								JOptionPane.YES_NO_OPTION,
								JOptionPane.QUESTION_MESSAGE,
								null,
								options,
								options[1]);
						if (choice == JOptionPane.YES_OPTION) {
							removeUserAtIndex(i, selectedRowsTab);
							for (int k = prjsWithUsrAsUniqueAdmin.size()-1; k >= 0 ; k--) {
								Project pProject = (Project) prjsWithUsrAsUniqueAdmin.get(k);
								projectTableModel.removeData(getIndexOfProject(pProject));	
							}
							removeUserAtIndex(i, selectedRowsTab);
						}
					}
					else {
						removeUserAtIndex(i, selectedRowsTab);
					}
				} else {
					removeUserAtIndex(i, selectedRowsTab);
				}
			}
		}	
	}
	
	void removeUserAtIndex(int i, int[] selectedRowsTab) {
		try {
			String userLogin = (String)usersTableModel.getValueAt(selectedRowsTab[i],0);
			User pUser = pAdminVTData.getUserFromModel(userLogin);
			pAdminVTData.delteUserInDBAndModel(pUser);
			if (usersTableModel.getRowCount() == 0) {
				deleteUserButton.setEnabled(false);
			}	
			usersTableModel.removeData(selectedRowsTab[i]);
		} 
		catch (Exception exception) {
			Tools.ihmExceptionView(exception);
		}
	}
	
	void modifyUserPerformed(){
		int selectedRow = userTable.getSelectedRow();
		if (selectedRow != -1) {
			User user = pAdminVTData.getUserFromModel((String)usersTableModel.getValueAt(selectedRow,0));
			AskNewUser askNewUser = new AskNewUser(user, javax.swing.JOptionPane.getFrameForComponent(Administration.this), pAdminVTData);
			if (askNewUser.getUser() != null) {
				if (Api.isConnected()) {
					try  {
						User usr = askNewUser.getUser();
						user.updateInDBModel(usr.getLoginFromModel(),usr.getLastNameFromModel(),usr.getFirstNameFromModel(),usr.getDescriptionFromModel(),usr.getEmailFromModel(),usr.getPhoneNumberFromModel());
						
						ArrayList data = new ArrayList();
						data.add(usr.getLoginFromModel());
						data.add(usr.getLastNameFromModel());
						data.add(usr.getFirstNameFromModel());
						data.add(usr.getEmailFromModel());
						data.add(usr.getPhoneNumberFromModel());
						usersTableModel.modifyData(data,selectedRow);
						
					} catch(Exception e){
						Tools.ihmExceptionView(e);
					}	
				}	
			}
		}
	}
	
	void createUserPerformed() {
		AskNewUser askNewUser = new AskNewUser(null, javax.swing.JOptionPane.getFrameForComponent(Administration.this), pAdminVTData);
		if (askNewUser.getUser() != null) {
			if (pAdminVTData.containsLoginInModel(askNewUser.getUser().getLoginFromModel())) {
				JOptionPane.showMessageDialog(Administration.this,
						Language.getInstance().getText("Ce_login_existe_deja_"),
						Language.getInstance().getText("Erreur_"),
						JOptionPane.ERROR_MESSAGE);
			} else {
				try {
					User pUser = askNewUser.getUser();
					pUser.addInDB(new String(askNewUser.getPassword()));
					
					pAdminVTData.addUserInModel(pUser);
					ArrayList data = new ArrayList();
					data.add(pUser.getLoginFromModel());
					data.add(pUser.getLastNameFromModel());
					data.add(pUser.getFirstNameFromModel());
					data.add(pUser.getEmailFromModel());
					data.add(pUser.getPhoneNumberFromModel());
					usersTableModel.addRow(data);
					
				} catch (Exception exception) {
					Tools.ihmExceptionView(exception);
				}
			}
		}
		
	}
	
	
	void createProjectPerformed(){
		AskNewProject askProject = new AskNewProject(pAdminVTData, null,javax.swing.JOptionPane.getFrameForComponent(Administration.this));
		ArrayList data = new ArrayList();
		Project pProject = askProject.getProject();
		if (pProject != null) {
			
			try {
				if (!askProject.isFromProjet()) {
					pAdminVTData.addProjectInDBAndModel(pProject);
				} else {
					String fromProjectName = askProject.getFromProjectName();
					pAdminVTData.addProjectInDBAndModelByCopy(pProject, pAdminVTData.getProjectFromModel(fromProjectName), askProject.isFromProjectSuites(),askProject.isFromProjectCampaigns(), askProject.isFromProjectUsers(), askProject.isFromProjetGroups());
				}
				data.add(Tools.createAppletImageIcon(PATH_TO_PROJECT_ICON,""));
				data.add(pProject.getNameFromModel().trim());
				data.add(pProject.getAdministratorFromModel().getLoginFromModel());
				data.add(pProject.getCreationDateFromModel().toString());
				data.add(pProject.getDescriptionFromModel());
				projectTableModel.addRow(data);
				//ProjectTableCellRenderer.setColor(normalColor);
				projectTable.getColumnModel().getColumn(0).setMaxWidth(18);
				deleteProjectButton.setEnabled(true);
			} catch (Exception exception) {
				Tools.ihmExceptionView(exception);
			}
		}
	}
	
	
	void cancelPerformed(){
		oldPassword.setText(null);
		newPasswordFirst.setText(null);
		newPasswordSecond.setText(null);
	}
	
	void deleteProjectPerformed() {
		int selectedRow = projectTable.getSelectedRow();
		if (selectedRow != -1) {
			Object[] options = {Language.getInstance().getText("Oui"), Language.getInstance().getText("Non")};
			
			int choice = JOptionPane.showOptionDialog(Administration.this,
					Language.getInstance().getText("Etes_vous_sur_de_vouloir_supprimer_le_projet__") + projectTableModel.getData(selectedRow).get(1),
					Language.getInstance().getText("Attention_"),
					JOptionPane.YES_NO_OPTION,
					JOptionPane.QUESTION_MESSAGE,
					null,
					options,
					options[1]);
			if (choice == JOptionPane.YES_OPTION) {
				if (Api.isConnected()) {
					try {
						Project pProject = pAdminVTData.getProjectFromModel((String)projectTableModel.getValueAt(selectedRow, 1));
						pAdminVTData.deleteProjectInDBAndModel(pProject);
						
						//Call delete project on plugin
						try {
						Enumeration adminPlugins = associatedExtension.elements();
						while (adminPlugins.hasMoreElements()){
							Extension pluginExt = (Extension) adminPlugins.nextElement();
							if (pluginExt.getExtendedPointId().equals("Admin")){
								Admin plugin = (Admin) jpf.activateExtension(pluginExt);
								plugin.onDeleteProject(pProject);
							}
						}
						} catch (Exception exception) {
							
						}
						projectTableModel.removeData(selectedRow);
						projectTable.getColumnModel().getColumn(0).setMaxWidth(18);
						if (projectTableModel.getRowCount() == 0) {
							deleteProjectButton.setEnabled(false);
						}
					} catch (Exception exception) {
						Tools.ihmExceptionView(exception);
					}
				}
			}
		}
	}
	
	void modifyProjectPerformed(){
		int selectedRow = projectTable.getSelectedRow();
		if (selectedRow != -1) {
			Project project = pAdminVTData.getProjectFromModel((String)projectTableModel.getValueAt(selectedRow,1));
			AskNewProject askProject = new AskNewProject(pAdminVTData, project, javax.swing.JOptionPane.getFrameForComponent(Administration.this));
			if (askProject.getProject() != null) {
					try {
						project.updateInDBAndModel(askProject.getProject().getNameFromModel(), askProject.getProject().getDescriptionFromModel());
						
						ArrayList data = new ArrayList();
						data.add(Tools.createAppletImageIcon(PATH_TO_PROJECT_ICON,""));
						data.add(project.getNameFromModel().trim());
						data.add(project.getAdministratorFromModel().getLoginFromModel());
						data.add(project.getCreationDateFromModel().toString());
						data.add(project.getDescriptionFromModel());
						projectTableModel.modifyData(data,selectedRow);
						projectTable.getColumnModel().getColumn(0).setMaxWidth(18);
					} catch (Exception exception) {	
						Tools.ihmExceptionView(exception);
					}
			}
		}
	}
	
	void validatePerformed(){
		if (Api.isConnected()) {
			User admin = pAdminVTData.getUserAdminVTData();
			boolean _valid = false;
			try {
				String pass = admin.getPasswordFromDB();
				_valid = org.objectweb.salome_tmf.api.MD5paswd.testPassword(new String(oldPassword.getPassword()).trim(),pass);
			}catch(Exception ex){}
			if (_valid) {
				if (new String(newPasswordFirst.getPassword()).trim().equals(new String(newPasswordSecond.getPassword()).trim())) {
					try {
						admin.updatePasswordInDB(new String(newPasswordSecond.getPassword()).trim());
						oldPassword.setText("");
						newPasswordFirst.setText("");
						newPasswordSecond.setText("");
						JOptionPane.showMessageDialog(Administration.this,
								Language.getInstance().getText("Votre_mot_de_passe_a_ete_modifie"),
								Language.getInstance().getText("Succes_"),
								JOptionPane.INFORMATION_MESSAGE);
					} catch (Exception exception) {
						Tools.ihmExceptionView(exception);
					}
					
				} else {
					newPasswordFirst.setText("");
					newPasswordSecond.setText("");
					JOptionPane.showMessageDialog(Administration.this,
							Language.getInstance().getText("Impossible_de_changer_le_mot_de_passe_Vous_n_avez_pas_entrer_deux_fois_le_meme_mot_de_passe"),
							Language.getInstance().getText("Erreur_"),
							JOptionPane.ERROR_MESSAGE);
				}
			} else {
				oldPassword.setText("");
				JOptionPane.showMessageDialog(Administration.this,
						Language.getInstance().getText("Impossible_de_changer_le_mot_de_passe_L_ancien_mot_de_passe_est_incorrect"),
						Language.getInstance().getText("Erreur_"),
						JOptionPane.ERROR_MESSAGE);
			}
		} else {
			JOptionPane.showMessageDialog(Administration.this,
					Language.getInstance().getText("Impossible_de_changer_le_mot_de_passe_Vous_n_etes_pas_connecter_a_la_base"),
					Language.getInstance().getText("Erreur_"),
					JOptionPane.ERROR_MESSAGE);
		}
	}

	public void addBugTrackers(Object bugTracker) {
		bugTrackers.add(bugTracker);
	}

	public Vector getBugTracker() {
		return bugTrackers;
	}
	
	/*public void addJarToClassLoader(URL jar){
		Class pclC = null;
		try {
			pclC = (this.getClass().getClassLoader()).getClass();
			pclC.getMethod("addLocalJar", new Class[] { URL.class })
			.invoke(this.getClass().getClassLoader(),
					new Object[] { jar});
			} catch (Exception e){
				//pPluginClassLoader.AddJar(UrlLib);
			}
	}*/
	   /***************** Windows Listener ***************/
  
	public void windowClosing(WindowEvent e) {
        if (!exit)
        	quit(true, true);
     }   
    
    public void windowActivated(WindowEvent e) { }

    public void windowClosed(WindowEvent e) { }


    public void windowDeactivated(WindowEvent e) { }

    public void windowDeiconified(WindowEvent e) { }

    public void windowIconified(WindowEvent e) { }

    public void windowOpened(WindowEvent e) { }

	public void addReqManager(Object reqManager) {
		reqManagers.add(reqManager);
	}

	public Vector getReqManagers() {
		return reqManagers;
	}
}
