package org.objectweb.salome_tmf.ihm.filtre;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.objectweb.salome_tmf.data.DataConstants;
import org.objectweb.salome_tmf.ihm.languages.Language;
import org.objectweb.salome_tmf.ihm.models.TestTreeModel;

public class CampagneTreeFiltrePanel extends JPanel implements ActionListener{
	JRadioButton bCampagne ;
	JTextField filtreStr ;
	
	int filtre = -1;
	StringSimpleDataFiltre m_dataFilter;
	TestTreeModel m_FilterTreeModel;
	
	public CampagneTreeFiltrePanel(TestTreeModel pFilterTreeModel){
		super();
		m_FilterTreeModel = pFilterTreeModel;
		m_dataFilter = new StringSimpleDataFiltre ();
		m_FilterTreeModel.setFilter(m_dataFilter);
		initComponent();
	}
	
	
	void initComponent(){
		setLayout(new GridLayout(1, 4));
		setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.BLACK),"Filtre"));
		filtreStr = new JTextField();
		bCampagne = new JRadioButton(Language.getInstance().getText("Campagne"), true);
		
		bCampagne.setSelected(false);
		
		bCampagne.addActionListener(this);
	
		filtreStr.addKeyListener(new KeyListener() {
            public void keyTyped(KeyEvent keyEvent)  {
                
            }
            public void keyPressed(KeyEvent keyEvent) {}
            public void keyReleased(KeyEvent keyEvent) {reloadFilter();}

		});

		add(filtreStr);
		add(bCampagne);
		
	}
	
	
	public void actionPerformed(ActionEvent evt){
		if (evt.getSource().equals(bCampagne)){
			bCampagnePerformed();
		}
	}
	
	
	void bCampagnePerformed(){
		filtre = -1;
		if (bCampagne.isSelected()){
			filtre = DataConstants.CAMPAIGN;
		}
		applyFilter();
	}
	
	
	
	void reloadFilter() {
		if (filtre != -1){
			/*try {
				Thread.sleep(100);
			} catch (Exception e){
				e.printStackTrace();
			}*/
			applyFilter();
		}
	}
	void applyFilter(){
		//System.out.println("Filtre : " + filtreStr.getText() + ", type = " + filtre);
		if (m_dataFilter != null){
			m_dataFilter.setFilterType(filtre);
			m_dataFilter.setFilterStr(filtreStr.getText());
		}
		m_FilterTreeModel.setFiltered(true);	
	}
	
	public void reInit(boolean filter){
		bCampagne.setSelected(false);
		filtre = -1;
		if (filter){
			m_dataFilter.reInit();
		}
		m_FilterTreeModel.setFiltered(false);
	}
	
	public boolean isActived (){
		return (filtre != -1);
	}
}
