package org.objectweb.salome_tmf.ihm.filtre;

import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.objectweb.salome_tmf.api.ApiConstants;
import org.objectweb.salome_tmf.data.Campaign;
import org.objectweb.salome_tmf.data.DataConstants;
import org.objectweb.salome_tmf.data.Family;
import org.objectweb.salome_tmf.data.SimpleData;
import org.objectweb.salome_tmf.data.Test;
import org.objectweb.salome_tmf.data.TestList;
import org.objectweb.salome_tmf.ihm.IHMConstants;

public class StringSimpleDataFiltre implements ISimpleDataFilter{
	boolean actived = true;
	
	String strFiltre = "toto";
	int filtreType = -1;
	
	public boolean pass(Object obj){
		if (!actived) return true;
		if (obj instanceof DefaultMutableTreeNode) { 
			Object data = ((DefaultMutableTreeNode)obj).getUserObject();
			if (data instanceof SimpleData){
				return isFiltred((SimpleData)data);
			}
		}
		return false;
	}
	
	public void setActived(boolean actived) {
		this.actived = actived;
	}
	
	public boolean isActived() {
		return actived;
	}
	public void setFilterType(int filtre){
		filtreType = filtre;
	}
	
	public int getFilterType() {
		return filtreType;
	}

	public void setFilterStr(String str) {
		strFiltre = str;
	}

	public String getFilterStr(){
		return strFiltre;
	}
	
	public boolean isFiltred (SimpleData data){
		/*  Filtre sur les campagnes */	
		if (filtreType == DataConstants.CAMPAIGN){
			if (data instanceof Campaign){
				String name = ((SimpleData)data).getNameFromModel();
				if (name.startsWith(strFiltre)){
					return true;
				} else {
					return false;
				}
			}
			return true;
		}
		/* Filtre sur le plan de test */
		if (data instanceof Family){
			String name = ((SimpleData)data).getNameFromModel();
			if (filtreType == DataConstants.FAMILY){
				if (name.startsWith(strFiltre)){
					return true;
				} else {
					return false;
				}
			} else if (filtreType == DataConstants.TESTLIST || filtreType == DataConstants.TEST ){
				ArrayList listOfSuite =  ((Family)data).getSuiteListFromModel();
				int size = listOfSuite.size();
				boolean trouve = false;
				int cpt = 0;
				while (cpt < size && !trouve){
					TestList pTestList =  (TestList) listOfSuite.get(cpt);
					if (isFiltred(pTestList)){
						trouve = true; //Au moins une suite est filtree
					}
					cpt ++;
				}
				return trouve;
			} 
			return true; //FILTRE SUITE,TEST
		}
		if (data instanceof TestList){
			String name = null;
			if (filtreType == DataConstants.TESTLIST){
				name = ((SimpleData)data).getNameFromModel();
				if (name != null){
					if ( name.startsWith(strFiltre)){
						return true;
					}  else  {
						return false;
					}
				}
			} else  if (filtreType == DataConstants.FAMILY) {
				name = ((TestList)data).getFamilyFromModel().getNameFromModel();
				if (name != null){
					if ( name.startsWith(strFiltre)){
						return true;
					}  else  {
						return false;
					}
				}
			} else if (filtreType == DataConstants.TEST){
				ArrayList listOfTest =  ((TestList)data).getTestListFromModel();
				int size = listOfTest.size();
				boolean trouve = false;
				int cpt = 0;
				while (cpt < size && !trouve){
					Test pTest =  (Test) listOfTest.get(cpt);
					if (isFiltred(pTest)){
						trouve = true; //Au moins un Test est filtree
					}
					cpt ++;
				}
				return trouve;
			} 
			
			return true; //FILTRE TEST
			
		}
		if (data instanceof Test){
			String name = null;
			if (filtreType == DataConstants.TEST){
				name = ((SimpleData)data).getNameFromModel();
			} else  if (filtreType == DataConstants.TESTLIST) {
				name = ((Test)data).getTestListFromModel().getNameFromModel();
			} else  if (filtreType == DataConstants.TESTLIST) {
				name = ((Test)data).getTestListFromModel().getFamilyFromModel().getNameFromModel();
			}
			if (name != null) {
				if (name.startsWith(strFiltre)){
					return true;
				}  else  {
					return false;
				}
			}
			return true; // ??
		}
		return true; //campagne ....
	}
	
	public void reInit(){
		filtreType = -1;
		actived = false;
	}
	
}
