package org.objectweb.salome_tmf.ihm.main;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;

import org.objectweb.salome_tmf.api.Api;
import org.objectweb.salome_tmf.api.Permission;
import org.objectweb.salome_tmf.data.DataConstants;
import org.objectweb.salome_tmf.data.Test;
import org.objectweb.salome_tmf.ihm.filtre.TestTreeFiltrePanel;
import org.objectweb.salome_tmf.ihm.languages.Language;
import org.objectweb.salome_tmf.ihm.main.datawrapper.DataModel;
import org.objectweb.salome_tmf.ihm.main.htmleditor.EkitCore;
import org.objectweb.salome_tmf.ihm.models.DynamicTree;
import org.objectweb.salome_tmf.ihm.tools.Tools;
import org.objectweb.salome_tmf.plugins.UICompCst;


public class TestPanel extends JPanel implements ActionListener{
	JPanel workSpaceTest ;
	JPanel testTopPanel;
	
	JLabel projetName;	
	JLabel automaticTestNameLabel;
	JLabel automaticTestDateLabel;
	JLabel automaticTestConceptorLabel;
	JLabel automaticTestExecutedLabel;
	JLabel manualTestConceptorLabel;
	JLabel manualTestNameLabel;
	JLabel manualTestDateLabel;
	JLabel manualTestExecutedLabel;
	
	JTabbedPane listWorkSpace;
	JTabbedPane familyWorkSpace;
	JTabbedPane automaticTest;
	JTabbedPane manualTest;
	
	DynamicTree testDynamicTree;
	TestTreeFiltrePanel  pTestTreeFiltrePanel;
	
	//changeListenerPanel testMultiUserChangeListenerPanel;
	ParameterView automaticTestParameterView;
	ParameterView testParameterView;
	
	JButton addList;
	JButton addTest;
	JButton addFamily;
	JButton orderTest;
	JButton delTestOrTestList;	
	JButton renameTestButton;
	JButton automaticButtonCampaignDetails;	
	JButton manualButtonCampaignDetails;

	JMenu testToolsMenu;
	
	//JTextPane familyDescription;
	EkitCore pfamilyDescription;
	EkitCore pTestListDescription;
	EkitCore pAutomaticDetailsDescription;
	EkitCore pManualDetailsDescription;
	//JTextPane testListDescription;
	//JTextPane automaticDetailsDescription;
	//JTextPane manualDetailsDescription;
	
	
	AttachmentView automaticTestAttachmentView;
    AttachmentView manualTestAttachmentView;
    AttachmentView testListAttachmentView;
    AttachmentView familyAttachmentView;
    

	BaseIHM pBaseIHM;
	
	SalomeTMFContext pSalomeTMFContext;
	int t_x = 1024;
	int t_y = 768;
	JTabbedPane tabs;
	
	public TestPanel(SalomeTMFContext m_SalomeTMFContext, BaseIHM m_BaseIHM, JTabbedPane m_tabs,  int x, int y){
		super(new BorderLayout());
		pSalomeTMFContext = m_SalomeTMFContext;
		pBaseIHM = m_BaseIHM;
		tabs = m_tabs;
		t_x = x;
		t_y = y; 
	}
	
	public void initCoponent(){  
		familyWorkSpace = new JTabbedPane(); 
		listWorkSpace = new JTabbedPane();
		workSpaceTest = new JPanel();
		
		projetName = new JLabel();   
		projetName.setFont(new Font(null,Font.BOLD,18));
		JPanel namePanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		namePanel.add(projetName);
		
		/*
		 * testMultiUserChangeListenerPanel = new changeListenerPanel();
		testMultiUserChangeListenerPanel.setPreferredSize(new Dimension(70,25));
		JPanel testMultiUserPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		testMultiUserPanel.add(testMultiUserChangeListenerPanel);
		*/
		testTopPanel = new JPanel(new BorderLayout());
		testTopPanel.add(namePanel, BorderLayout.WEST);
		//testTopPanel.add(testMultiUserPanel, BorderLayout.EAST);
		
		
		testToolsMenu = new JMenu(Language.getInstance().getText("Outils"));
		pSalomeTMFContext.UIComponentsMap.put(UICompCst.TEST_TOOLS_MENU,testToolsMenu);
		 
		add(testTopPanel, BorderLayout.NORTH);
		createTestsPlane();
	}
	
	/************************************************************************************************************/
	
	
	/**
     * Methode qui cree la vue sur les tests
     */
	private void createTestsPlane() {
		
		addList =  new JButton(Language.getInstance().getText("Ajouter_une_suite"));
		addList.setToolTipText(Language.getInstance().getText("Ajouter_une_suite_de_tests"));
		
		addList.addActionListener(this);
		
		
		addFamily = new JButton(Language.getInstance().getText("Ajouter_une_famille"));
		addFamily.setToolTipText(Language.getInstance().getText("Ajouter_une_famille"));
		
		addFamily.addActionListener(this);
		
		addTest = new JButton(Language.getInstance().getText("Ajouter_un_test"));
		addTest.setToolTipText(Language.getInstance().getText("Ajouter_un_test"));
		
		addTest.addActionListener(this);
		
		
		JPanel listPanel = new JPanel(new GridLayout(1,3));
		listPanel.add(addFamily);
		listPanel.add(addList);
		listPanel.add(addTest);
		listPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		
		orderTest = new JButton(Language.getInstance().getText("Ordonner"));
		orderTest.setToolTipText(Language.getInstance().getText("Ordonner_l_arbre_des_suites_de_tests"));
		orderTest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				new TestOrdering(testDynamicTree, false);
			}
		});
		
		delTestOrTestList = new JButton(Language.getInstance().getText("Supprimer"));
		delTestOrTestList.setToolTipText(Language.getInstance().getText("Supprimer"));
		delTestOrTestList.setEnabled(false);
		delTestOrTestList.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					DataModel.deleteInTestTree();
				}catch (Exception ex){
					ex.printStackTrace();
					Tools.ihmExceptionView(ex);
				}
			}
		});
		
		
		//JMenuItem refreshItem = new JMenuItem(Language.getInstance().getText("Rafraichir"));
		JMenu refreshItem = new JMenu(Language.getInstance().getText("Rafraichir"));
		
		/*refreshItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//TestMethods.refreshTestTree();
				tabs.setCursor(new Cursor(Cursor.WAIT_CURSOR));
				workSpaceTest.removeAll();
				DataModel.reloadFromBase(true);
				tabs.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			}
		});*/
		
		JMenuItem refreshItemAll = new JMenuItem(Language.getInstance().getText("Tout"));
		refreshItemAll.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//TestMethods.refreshTestTree();
				tabs.setCursor(new Cursor(Cursor.WAIT_CURSOR));
				workSpaceTest.removeAll();
				DataModel.reloadFromBase(true);
				tabs.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			}
		});
		
		JMenuItem refreshItemTest = new JMenuItem(Language.getInstance().getText("Plan_de_tests"));
		refreshItemTest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//TestMethods.refreshTestTree();
				tabs.setCursor(new Cursor(Cursor.WAIT_CURSOR));
				workSpaceTest.removeAll();
				try {
					DataModel.reloadTestPlan();
				} catch (Exception ex){
					ex.printStackTrace();
					DataModel.reloadFromBase(true);
				}
				tabs.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			}
		});
		
		refreshItem.add(refreshItemAll);
		refreshItem.add(refreshItemTest);
		
		testToolsMenu.add(refreshItem);
		
		JMenuItem changePwdItem = new JMenuItem(Language.getInstance().getText("Changer_le_mot_de_passe"));
		changePwdItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				new ChangePwdWindow(pSalomeTMFContext.ptrFrame).show();
			}
		});
		
		testToolsMenu.add(changePwdItem);
		
		JMenuBar refreshMenuBar = new JMenuBar();
		refreshMenuBar.add(testToolsMenu);
		
		renameTestButton = new JButton(Language.getInstance().getText("Renommer"));
		renameTestButton.setEnabled(false);
		renameTestButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DataModel.renameTest();
			}
		});
		
		
		
		
		
		JPanel testPanel = new JPanel(new GridLayout(1,3));
		testPanel.add(orderTest);
		testPanel.add(renameTestButton);
		testPanel.add(delTestOrTestList);
		testPanel.add(refreshMenuBar);
		testPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		testDynamicTree = new DynamicTree(Language.getInstance().getText("Plan_de_tests"), DataConstants.TESTLIST);
		
		createFamily();
		createTestList();
		createAutomaticTest();
		createManualTest();
		workSpaceTest.removeAll();
		
		// Construction finale
		JPanel allButtons = new JPanel();
		allButtons.setLayout(new BoxLayout(allButtons,BoxLayout.Y_AXIS));
		allButtons.add(listPanel);
		allButtons.add(testPanel);
		
		
		// Mapping entre composants graphiques et constantes
		pSalomeTMFContext.addToUIComponentsMap(UICompCst.TEST_DYNAMIC_TREE,testDynamicTree);
		// Add this component as static component
		UICompCst.staticUIComps.add(UICompCst.TEST_DYNAMIC_TREE);
		
		JPanel southPanel = new JPanel();
		southPanel.setLayout(new GridLayout(2,1));
		pTestTreeFiltrePanel = new TestTreeFiltrePanel(testDynamicTree.getModel());
		JPanel buttonPanel = new JPanel (new FlowLayout(FlowLayout.CENTER));
		JButton quitTestButton = new JButton(Language.getInstance().getText("Quitter"));
		quitTestButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				pBaseIHM.quit(true, true);
			}
		});
		buttonPanel.add(quitTestButton);
		southPanel.add(pTestTreeFiltrePanel);
		southPanel.add(buttonPanel);
		
		JPanel buttonsAndTree = new JPanel(new BorderLayout());
		buttonsAndTree.add(allButtons, BorderLayout.NORTH);
		buttonsAndTree.add(testDynamicTree, BorderLayout.CENTER);
		//buttonsAndTree.add(quitTestButton, BorderLayout.SOUTH);
		buttonsAndTree.add(southPanel, BorderLayout.SOUTH);
		buttonsAndTree.setPreferredSize(new Dimension(t_x/3,t_y)); 
		buttonsAndTree.setMinimumSize(new Dimension(t_x/4,t_y));
		
		workSpaceTest.setPreferredSize(new Dimension(t_x/3*2,t_y));
		workSpaceTest.setMinimumSize(new Dimension(t_x/3,t_y));
		
		JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
				buttonsAndTree, workSpaceTest);
		if (Api.isIDE_DEV()){
			splitPane.setDividerLocation(3);
		} else {
			splitPane.setDividerLocation(380);
		}
		add(splitPane);
		
		// Mapping entre comosants graphiques et constantes
		pSalomeTMFContext.addToUIComponentsMap(UICompCst.TEST_SECOND_BUTTONS_PANEL,testPanel);
		// Add this component as static component
		UICompCst.staticUIComps.add(UICompCst.TEST_SECOND_BUTTONS_PANEL);
		
	} // Fin de la m?thode createTestsPlane/0
	
	
	 /**
     * Methode qui cree la vue sur les familles
     */
	private void createFamily() {
		
		workSpaceTest.removeAll();
		//pfamilyDescription = new PanelDescription();
		pfamilyDescription = new EkitCore(testDynamicTree.getTree(), true);
		/*familyDescription = new JTextPane();
		familyDescription.addCaretListener(new TestTreeDescriptionListener());
		familyDescription.addFocusListener(new TestDescriptionFocusListener());
		
		JScrollPane familyDescrScrollPane = new JScrollPane(familyDescription);
		*/
		
		// Onglets
		familyAttachmentView  = new AttachmentView(pBaseIHM, DataConstants.FAMILY , DataConstants.FAMILY, null, DataConstants.NORMAL_SIZE_FOR_ATTACH, null);
		//familyWorkSpace.addTab(Language.getInstance().getText("Description"),	familyDescrScrollPane);
		familyWorkSpace.addTab(Language.getInstance().getText("Description"),	pfamilyDescription);
		
		familyWorkSpace.addTab(Language.getInstance().getText("Attachements"),	familyAttachmentView);
		
		// Mapping entre objets graphiques et constantes
		pSalomeTMFContext.addToUIComponentsMap(UICompCst.FAMILY_WORKSPACE_PANEL_FOR_TABS,familyWorkSpace);
		// Add this component as static component
		UICompCst.staticUIComps.add(UICompCst.FAMILY_WORKSPACE_PANEL_FOR_TABS);
		
		workSpaceTest.setLayout(new BorderLayout());
		workSpaceTest.add(familyWorkSpace, BorderLayout.CENTER);
	} // Fin de la m?thode createAttachments/0
	
	
	/**
     * Methode qui cree la vue sur la description et les attachements 
     * (utilisee pour le suites de test)
     *
     */
	 private void createTestList() {
	        
	        workSpaceTest.removeAll();
	        
	        // Onglets
	        /*testListDescription = new JTextPane();
	        testListDescription.addCaretListener(new TestTreeDescriptionListener());
	        testListDescription.addFocusListener(new TestDescriptionFocusListener());*/
	        pTestListDescription = new EkitCore(testDynamicTree.getTree(), true);
	        testListAttachmentView = new AttachmentView(pBaseIHM, DataConstants.TESTLIST , DataConstants.TESTLIST, null, DataConstants.NORMAL_SIZE_FOR_ATTACH, null);
	       
	        //JScrollPane testListDescrSrollPane = new JScrollPane(testListDescription);
	        JScrollPane testListDescrSrollPane = new JScrollPane(pTestListDescription);
	        listWorkSpace.addTab(Language.getInstance().getText("Description"),	testListDescrSrollPane);
	        listWorkSpace.addTab(Language.getInstance().getText("Attachements"), testListAttachmentView);
	        
	        // Mapping entre objets graphiques et constantes
	        pSalomeTMFContext.addToUIComponentsMap(UICompCst.TESTLIST_WORKSPACE_PANEL_FOR_TABS,listWorkSpace);
	        // Add this component as static component
	        UICompCst.staticUIComps.add(UICompCst.TESTLIST_WORKSPACE_PANEL_FOR_TABS);
	        
	        workSpaceTest.setLayout(new BorderLayout());
	        workSpaceTest.add(listWorkSpace, BorderLayout.CENTER);
	        
	    } // Fin de la m?thode createTestList/0
	 
	 
	 
	 /**
	     * Methode qui cree la vue pour les tests automatiques
	     */
	    private void createAutomaticTest() {
	        workSpaceTest.removeAll();
	        
	        JPanel detailsPanel = new JPanel(new BorderLayout());
	        JPanel scriptPanel = new AutomaticTestScriptView();
	        JPanel parametersPanel = new JPanel();
	        
	        automaticTestAttachmentView = new AttachmentView(pBaseIHM, DataConstants.AUTOMATIC_TEST , DataConstants.TEST, null, DataConstants.NORMAL_SIZE_FOR_ATTACH, null);
	        automaticTestParameterView = new ParameterView(true, DataConstants.AUTOMATIC_TEST);
	        automaticTestParameterView.setName(Language.getInstance().getText("Vue_automatique"));
	        
	        automaticTest = new JTabbedPane();
	        automaticTest.addTab(Language.getInstance().getText("Details"), detailsPanel);
	        automaticTest.addTab(Language.getInstance().getText("Script"), scriptPanel);
	        //automaticTest.addTab(Language.getInstance().getText("Attachements"), attachmentPanel);
	        automaticTest.addTab(Language.getInstance().getText("Attachements"), automaticTestAttachmentView);
	        automaticTest.addTab(Language.getInstance().getText("Parametres"), automaticTestParameterView);
	        
	        createAutomaticTestDetails(detailsPanel);
	      
	        
	        // Mapping entre objets graphiques et constantes
	        pSalomeTMFContext.addToUIComponentsMap(UICompCst.AUTOMATED_TEST_WORKSPACE_PANEL_FOR_TABS,automaticTest);
	        // Add this component as static component
	        UICompCst.staticUIComps.add(UICompCst.AUTOMATED_TEST_WORKSPACE_PANEL_FOR_TABS);
	        
	        workSpaceTest.setLayout(new BorderLayout());
	        workSpaceTest.add(automaticTest, BorderLayout.CENTER);
	        
	        // Mapping entre composants graphiques et constantes
	        pSalomeTMFContext.addToUIComponentsMap(UICompCst.AUTOMATED_TEST_SCRIPT_PANEL,scriptPanel);
	        // Add this component as static component
	        UICompCst.staticUIComps.add(UICompCst.AUTOMATED_TEST_SCRIPT_PANEL);
	        
	    } // Fin de la methode createAutomaticTest/0
	    
	    
	    /**
	     * M?thode qui cr?e l'?cran des d?tails sur un test
	     * @param panel le panel qui contient la vue
	     */
	    private void createAutomaticTestDetails(JPanel panel) {
	        
	        automaticTestNameLabel = new JLabel(Language.getInstance().getText("Nom_du_test") + " : ");
	        automaticTestDateLabel = new JLabel(Language.getInstance().getText("Date_de_creation") + " : ");
	        automaticTestConceptorLabel = new JLabel(Language.getInstance().getText("Concepteur") + " : ");
	        automaticTestExecutedLabel = new JLabel(Language.getInstance().getText("Execute") + " : ");
	        automaticButtonCampaignDetails = new JButton(Language.getInstance().getText("Campagne"));
	        automaticButtonCampaignDetails.addActionListener(this);
	        JPanel firstLine = new JPanel(new FlowLayout(FlowLayout.LEFT));
	        firstLine.add(automaticTestNameLabel);
	        firstLine.add(Box.createRigidArea(new Dimension(20,20)));
	        firstLine.add(automaticTestDateLabel);
	        firstLine.add(Box.createRigidArea(new Dimension(20,20)));
	        firstLine.add(automaticTestExecutedLabel);
	        firstLine.add(Box.createRigidArea(new Dimension(10,20)));
	        firstLine.add(automaticButtonCampaignDetails);
	        
	        JPanel secondLine = new JPanel(new FlowLayout(FlowLayout.LEFT));
	        secondLine.add(automaticTestConceptorLabel);
	        
	        
	        JPanel allButtons = new JPanel();
	        allButtons.setLayout(new BoxLayout(allButtons,BoxLayout.Y_AXIS));
	        allButtons.add(firstLine);
	        allButtons.add(secondLine);
	        
	        //allButtons.add()
	        allButtons.setBorder(BorderFactory.createEmptyBorder(10,0,30,0));
	        /*
	        automaticDetailsDescription = new JTextPane();
	        automaticDetailsDescription.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.BLACK),Language.getInstance().getText("Description")));
	        automaticDetailsDescription.addCaretListener(new TestTreeDescriptionListener());
	        automaticDetailsDescription.addFocusListener(new TestDescriptionFocusListener());
	        */
	        pAutomaticDetailsDescription = new EkitCore(testDynamicTree.getTree(), true);
	        panel.add(allButtons,BorderLayout.NORTH);
	        //JScrollPane automaticDetailsDescrSrollPane = new JScrollPane(automaticDetailsDescription);
	        JScrollPane automaticDetailsDescrSrollPane = new JScrollPane(pAutomaticDetailsDescription);
	        
	        panel.add(automaticDetailsDescrSrollPane,BorderLayout.CENTER);
	    } // Fin de la m?thode createAutomaticTestDetails/1
	    
	  
	    /**
	     * Methode qui cree la vue pour les tests manuels
	     */
	    private void createManualTest() {
	        workSpaceTest.removeAll();
	        // Onglets
	        
	        
	        JPanel detailsPanel = new JPanel(new BorderLayout());
	        //JPanel actionsPanel = new JPanel();
	        //JPanel attachmentPanel = new JPanel();
	        //JPanel manualParameter = new JPanel();
	        
	      
	        testParameterView = new ParameterView(true, DataConstants.PARAMETER);
	        testParameterView.setName(Language.getInstance().getText("Vue_des_donnees"));
            
	        manualTestAttachmentView  = new AttachmentView(pBaseIHM, DataConstants.MANUAL_TEST , DataConstants.TEST, null, DataConstants.NORMAL_SIZE_FOR_ATTACH, null);
	        
	        manualTest = new JTabbedPane();
	        manualTest.addTab(Language.getInstance().getText("Details"), detailsPanel);
	        manualTest.addTab(Language.getInstance().getText("Actions"), new ManualActionView());
	        manualTest.addTab(Language.getInstance().getText("Attachements"), manualTestAttachmentView);
	       /* manualTest.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					if (((JTabbedPane)e.getSource()).getSelectedIndex() == 1){
						ManualActionView pManualActionView = (ManualActionView) ((JTabbedPane)e.getSource()).getSelectedComponent();
						pManualActionView.setColumnSize();
					}
				}
			});*/
	        manualTest.addTab(Language.getInstance().getText("Parametres"), testParameterView);
	        
	        createManualTestDetails(detailsPanel);
	        
	        // Mapping entre objets graphiques et constantes
	        pSalomeTMFContext.addToUIComponentsMap(UICompCst.MANUAL_TEST_WORKSPACE_PANEL_FOR_TABS,manualTest);
	        // Add this component as static component
	        UICompCst.staticUIComps.add(UICompCst.MANUAL_TEST_WORKSPACE_PANEL_FOR_TABS);
	        
	        workSpaceTest.setLayout(new BorderLayout());
	        workSpaceTest.add(manualTest, BorderLayout.CENTER);
	        
	    } // Fin de la m?thode createManualTest/0
	    
	    /**
	     * M?thode qui cr?e l'?cran des d?tails sur un test
	     * @param panel le panel qui contient la vue
	     */
	    private void createManualTestDetails(JPanel panel) {
	        
	        manualTestConceptorLabel = new JLabel(Language.getInstance().getText("Concepteur") + " : ");
	        manualTestNameLabel  = new JLabel(Language.getInstance().getText("Nom_du_test") + " : ");
	        manualTestDateLabel = new JLabel(Language.getInstance().getText("Date_de_creation") +" : ");
	        manualTestExecutedLabel = new JLabel(Language.getInstance().getText("Execute") +" : ");
	       
	        manualButtonCampaignDetails = new JButton(Language.getInstance().getText("Campagne"));
	        manualButtonCampaignDetails.addActionListener(this);
	        
	        JPanel firstLine = new JPanel(new FlowLayout(FlowLayout.LEFT));
	        firstLine.add(manualTestNameLabel);
	        firstLine.add(Box.createRigidArea(new Dimension(20,20)));
	        firstLine.add(manualTestDateLabel); 
	        firstLine.add(Box.createRigidArea(new Dimension(20,20)));
	        firstLine.add(manualTestExecutedLabel);
	        firstLine.add(Box.createRigidArea(new Dimension(10,20)));
	        firstLine.add(manualButtonCampaignDetails);
	        
	        JPanel secondLine = new JPanel(new FlowLayout(FlowLayout.LEFT));
	        secondLine.add(manualTestConceptorLabel);
	        
	        
	        JPanel allButtons = new JPanel();
	        allButtons.setLayout(new BoxLayout(allButtons,BoxLayout.Y_AXIS));
	        allButtons.add(firstLine);
	        allButtons.add(secondLine);
	        
	        //allButtons.add()
	        allButtons.setBorder(BorderFactory.createEmptyBorder(10,0,30,0));
	        /*
	        manualDetailsDescription = new JTextPane();
	        manualDetailsDescription.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.BLACK),Language.getInstance().getText("Description")));
	        manualDetailsDescription.addCaretListener(new TestTreeDescriptionListener());
	        manualDetailsDescription.addFocusListener(new TestDescriptionFocusListener()); */
	        pManualDetailsDescription = new EkitCore(testDynamicTree.getTree(), true);
	        panel.add(allButtons,BorderLayout.NORTH);
	        //JScrollPane manualDetailsDescrSrollPane = new JScrollPane(manualDetailsDescription);
	        JScrollPane manualDetailsDescrSrollPane = new JScrollPane(pManualDetailsDescription);
	        
	        panel.add(manualDetailsDescrSrollPane,BorderLayout.CENTER);
	    } // Fin de la m?thode createManualTestDetails/1  
	    
	    public void actionPerformed(ActionEvent e){
			if (e.getSource().equals(automaticButtonCampaignDetails)){
				Test pTest = DataModel.getCurrentTest();
				if (pTest != null){
					new ViewCampaignOfTest(pTest);
				}
			} else if (e.getSource().equals(manualButtonCampaignDetails)){
				Test pTest = DataModel.getCurrentTest();
				if (pTest != null){
					new ViewCampaignOfTest(pTest);
				}
			}
			if (e.getSource().equals(addFamily)){
				addFamilyPerformed(e);
			} else if (e.getSource().equals(addList)){
				addListPerformed(e);
			} else if (e.getSource().equals(addTest)){
				addTestPerformed(e);
			}
		}
	    
	    void addFamilyPerformed(ActionEvent e){
	    	if (pTestTreeFiltrePanel.getFiltreType() !=  -1){
	    		pTestTreeFiltrePanel.reInit(true);
	    	}
	    	DataModel.addNewFamily();
	    }
	    
	    void addListPerformed(ActionEvent e){
	    	if (pTestTreeFiltrePanel.getFiltreType() ==  DataConstants.TESTLIST || pTestTreeFiltrePanel.getFiltreType() ==  DataConstants.TEST){
	    		pTestTreeFiltrePanel.reInit(true);
	    	}
	    	DataModel.addNewTestList();
	    }
	    
	    void addTestPerformed(ActionEvent e){
	    	if (pTestTreeFiltrePanel.getFiltreType() ==  DataConstants.TEST){
	    		pTestTreeFiltrePanel.reInit(true);
	    	}
	    	DataModel.addNewTest();
	    }
	    
	    void loadModel(String strProject, String strLogin){
	    	//testMultiUserChangeListenerPanel.reset();
	    	testListAttachmentView.giveAccessToIhmScriptView();
	        familyAttachmentView.giveAccessToIhmScriptView();
	    	testParameterView.giveAccessToIhmParameterView();
	    	manualTestAttachmentView.giveAccessToIhmScriptView();
	    	automaticTestParameterView.giveAccessToIhmParameterView();
	    	automaticTestAttachmentView.giveAccessToIhmScriptView();
	    	projetName.setText(Language.getInstance().getText("Projet__") + DataModel.getCurrentProject().getNameFromModel() + ", " + Language.getInstance().getText("Utilisateurs")  +" : " + DataModel.getCurrentUser().getLoginFromModel() + " (V " + Api.getVersion() +")");
	    	testDynamicTree.givePopupMenuToTree();
	    }
	    
	    void reloadModel(){
	    	//testMultiUserChangeListenerPanel.reset();
	    	testListAttachmentView.giveAccessToIhmScriptView();
	        familyAttachmentView.giveAccessToIhmScriptView();
	    	testParameterView.giveAccessToIhmParameterView();
	    	manualTestAttachmentView.giveAccessToIhmScriptView();
	    	automaticTestParameterView.giveAccessToIhmParameterView();
	    	automaticTestAttachmentView.giveAccessToIhmScriptView();
	    	projetName.setText(Language.getInstance().getText("Projet__") + DataModel.getCurrentProject().getNameFromModel() + ", " + Language.getInstance().getText("Utilisateurs")  +" : " + DataModel.getCurrentUser().getLoginFromModel() + " (V " + Api.getVersion() +")"); 
	    	testDynamicTree.givePopupMenuToTree();
	    }
	    
	    
	    void giveAccessToIhm() {
	    	 if (Api.isConnected()) {
	             if (!Permission.canDeleteTest()) {
	                 delTestOrTestList.setEnabled(false);
	             }
	             if (!Permission.canCreateTest()) {
	                 
	                 addTest.setEnabled(false);
	                 addList.setEnabled(false);
	                 addFamily.setEnabled(false);    
	             }
	             if (!Permission.canUpdateTest()) {
	                 renameTestButton.setEnabled(false);
	                 orderTest.setEnabled(false);
	                 //familyDescription.setEditable(false);
	                 pfamilyDescription.setEditable(false);
	                 pTestListDescription.setEditable(false);
	                 pManualDetailsDescription.setEditable(false);
	                 pAutomaticDetailsDescription.setEditable(false);
	                 testDynamicTree.setEnabled(false);
	                 pTestListDescription.setEditable(false);
	                 pManualDetailsDescription.setEditable(false);
	                 pAutomaticDetailsDescription.setEditable(false);
	                 //familyDescription.setEditable(false);
	                 pfamilyDescription.setEditable(false);
	             }
	             
	         }
	    }
	    
	    /********************************************************************************************************************************/
	    void reValidate(){
	    	validate();
	    	repaint();
	    }
	    
	    void removeTestWorkSpace(){
	    	workSpaceTest.removeAll();
	    }
	    
	    void setWorkSpace(int type){
	    	workSpaceTest.removeAll();
	    	if (type == DataConstants.FAMILY){
	    		workSpaceTest.add(familyWorkSpace);
	    	} else if (type == DataConstants.TESTLIST){
	    		workSpaceTest.add(listWorkSpace);
	    	} else if (type == DataConstants.MANUAL_TEST){
	    		workSpaceTest.add(manualTest, BorderLayout.CENTER);
	    	}else if (type == DataConstants.AUTOMATIC_TEST){
	    		workSpaceTest.add(automaticTest, BorderLayout.CENTER);
	    	}
	    }
	    
	    void setDescription(int type, String text){
	    	if (type == DataConstants.FAMILY){
	    		//familyDescription.setText(text);
	    		pfamilyDescription.setText(text);
	    	} else if (type == DataConstants.TESTLIST){
	    		pTestListDescription.setText(text);
	    	} else if (type == DataConstants.MANUAL_TEST){
	    		pManualDetailsDescription.setText(text);
	    	}else if (type == DataConstants.AUTOMATIC_TEST){
	    		pAutomaticDetailsDescription.setText(text);
	    	}
	    }
	    
	    void setTestInfo(int type, String name, String conceptor, String date){
	    	 if (type == DataConstants.MANUAL_TEST){
		    		if (name != null){
		    			manualTestNameLabel.setText(Language.getInstance().getText("Nom_du_test__") + name);
		    		}
		    		if (conceptor != null){
		    			manualTestConceptorLabel.setText(Language.getInstance().getText("Concepteur__") + conceptor);
		    		}
		    		if (date != null){
		    			manualTestDateLabel.setText(Language.getInstance().getText("Date_de_creation__") + date);
		    		}
		    	}else if (type == DataConstants.AUTOMATIC_TEST){
		    		if (name != null){
		    			automaticTestNameLabel.setText(Language.getInstance().getText("Nom_du_test__") + name);
		    		}
		    		if (conceptor != null){
		    			automaticTestConceptorLabel.setText(Language.getInstance().getText("Concepteur__") + conceptor);
		    		}
		    		if (date != null){
		    			automaticTestDateLabel.setText(Language.getInstance().getText("Concepteur__") + date);
		    		}
		    	}
	    	
	    }
	    
	    void TestExecutedInfo(int type, String execcuted) {
	    	 if (type == DataConstants.MANUAL_TEST){
		    		if (execcuted != null){
		    			manualTestExecutedLabel.setText(Language.getInstance().getText("Execute") +" : " + execcuted);
		    		}
		    		
		    	}else if (type == DataConstants.AUTOMATIC_TEST){
		    		if (execcuted != null){
		    			automaticTestExecutedLabel.setText(Language.getInstance().getText("Execute") +" : " + execcuted);
		    	}
	    }
	    }
}
