/*
* SalomeTMF is a Test Management Framework
* Copyright (C) 2005 France Telecom R&D
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
* @author Fayçal SOUGRATI, Vincent Pautret, Marche Mikael
*
* Contact: mikael.marche@rd.francetelecom.com
*/

package org.objectweb.salome_tmf.ihm.main;

import org.objectweb.salome_tmf.ihm.languages.Language;


public class changeListenerPanel extends javax.swing.JPanel {
    int i = 0;
    int u = 0;
    int d = 0;
    String _toolKit = Language.getInstance().getText("Etat_de_la_synchronisation");
    
    /** Creates new form changeListenerPanel */
    public changeListenerPanel(String toolKit) {
        this._toolKit = toolKit;
        initComponents();
    }
    public changeListenerPanel() {
        initComponents();
    }
    
    public String getToolTipText() {
        return _toolKit;
    }
    
    public void reset(){
        i = 0;
        u = 0;
        d = 0;
        insertWarning.setBackground(new java.awt.Color(0, 255, 0));
        updateWarning.setBackground(new java.awt.Color(0, 255, 0));
        deleteWarning.setBackground(new java.awt.Color(0, 255, 0));
        //insertWarning.repaint();
        //updateWarning.repaint();
        //deleteWarning.repaint();
    }
    public void addUInsert(){
        i ++;
		org.objectweb.salome_tmf.api.Util.log("[changeListenerPanel] _valeur_de_insert_:_" + i);
        if (i>=5 && i<10){
            insertWarning.setBackground(new java.awt.Color(255, 255, 0));
            //insertWarning.repaint();
        }else  if (i>=10 && i<15){
            insertWarning.setBackground(new java.awt.Color(255, 0, 0));
            //insertWarning.repaint();
        } if (i>=15 && i<20){
            insertWarning.setBackground(new java.awt.Color(153, 0, 0));
            //insertWarning.repaint();
        } if (i>=20){
            insertWarning.setBackground(new java.awt.Color(51, 51, 51));
            //insertWarning.repaint();
        }
    }
    public void addUpdate(){
        u ++;
        org.objectweb.salome_tmf.api.Util.log("[changeListenerPanel] valeur_de_update_:_" + u);
        if (u>=5 && u<10){
            updateWarning.setBackground(new java.awt.Color(255, 255, 0));
            //updateWarning.repaint();
        }else  if (u>=10 && u<15){
            updateWarning.setBackground(new java.awt.Color(255, 0, 0));
            //updateWarning.repaint();
        } if (u>=15 && u<20){
            updateWarning.setBackground(new java.awt.Color(153, 0, 0));
            //updateWarning.repaint();
        } if (u>=20){
            updateWarning.setBackground(new java.awt.Color(51, 51, 51));
            //updateWarning.repaint();
        }
    }
    public void addDelete(){
        d ++;
        org.objectweb.salome_tmf.api.Util.log("[changeListenerPanel] valeur_de_update_:_" + d);
        if (d>=5 && d<10){
            deleteWarning.setBackground(new java.awt.Color(255, 255, 0));
            //deleteWarning.repaint();
        }else  if (d>=10 && d<15){
            deleteWarning.setBackground(new java.awt.Color(255, 0, 0));
            //deleteWarning.repaint();
        } if (d>=15 && d<20){
            deleteWarning.setBackground(new java.awt.Color(153, 0, 0));
            //deleteWarning.repaint();
        } if (d>=20){
            deleteWarning.setBackground(new java.awt.Color(51, 51, 51));
            //deleteWarning.repaint();
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        insertWarning = new java.awt.TextField();
        updateWarning = new java.awt.TextField();
        deleteWarning = new java.awt.TextField();

        setLayout(new java.awt.GridLayout(1, 0, 5, 0));

        setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        setToolTipText(getToolTipText());
        setMaximumSize(new java.awt.Dimension(50, 10));
        setMinimumSize(new java.awt.Dimension(40, 10));
        setPreferredSize(new java.awt.Dimension(40, 10));
        insertWarning.setText("I");
        insertWarning.setBackground(new java.awt.Color(0, 255, 0));
        insertWarning.setEditable(false);
        insertWarning.setEnabled(false);
        insertWarning.setFont(new java.awt.Font("Dialog", 1, 12));
        add(insertWarning);

        updateWarning.setText("U");
        updateWarning.setBackground(new java.awt.Color(0, 255, 0));
        updateWarning.setEditable(false);
        updateWarning.setEnabled(false);
        updateWarning.setFont(new java.awt.Font("Dialog", 1, 12));
        add(updateWarning);

        deleteWarning.setText("D");
        deleteWarning.setBackground(new java.awt.Color(0, 255, 0));
        deleteWarning.setEditable(false);
        deleteWarning.setEnabled(false);
        deleteWarning.setFont(new java.awt.Font("Dialog", 1, 12));
        add(deleteWarning);

    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.TextField deleteWarning;
    private java.awt.TextField insertWarning;
    private java.awt.TextField updateWarning;
    // End of variables declaration//GEN-END:variables
    
}
