package org.objectweb.salome_tmf.plugins.core;

import java.util.Vector;

import org.objectweb.salome_tmf.data.Test;

public interface ReqManager {
	
	/**
	 * Returns the number of requirements for a category
	 * @param cat requirements category
	 * @return
	 */
	public int getNbReqForCat(int cat);
	
	/**
	 * Returns true if all requierements with category cat and priority pri are covered by tests 
	 * @param cat
	 * @param pri
	 * @return
	 */
	public boolean isAllReqCovered(int cat, int pri);
	
	/**
	 * Returns true if all requierements with category cat and priority pri are covered by tests
	 * and if all these tests are executed 
	 * @param cat
	 * @param pri
	 * @return
	 */
	public boolean isAllReqCoveredExecuted(int cat, int pri);
	
	/**
	 * Returns the list of tests linked with requirements with category cat 
	 * @param cat
	 * @return
	 */
	public Vector getAssociatedTestsForReqCat(int cat);
	
	/**
	 * Returns req plugin name
	 * @return
	 */
	public String getReqManagerName();
	
	/**
	 * Deletes requirements links with test 
	 * @param idTest
	 */
	public void deleteReqLinkWithTest(int idTest);
	
	/**
	 * Add a link between a requirement and a test
	 */
	public void addReqLinkWithTest(Test test, int idReq);
	
}
