package org.objectweb.salome_tmf.server;

import java.util.Properties;

import org.objectweb.salome_tmf.api.Util;

public class ServerConstants {
	
	final static public String SERVER_CONFIG_FILE_PATH = "server.properties";
	
	public static String getMaximumActiveTime() {
		String maximumActiveTime = "";
		Properties prop;
		
		String defaultTime = "" + Long.toString(1000 * 60 * 60 * 4); // 4 heures
		Util.log("[ServerConstants] default maximum active time : " + defaultTime);
		
		try {
			Util.log("[ServerConstants->getMaximumActiveTime] try to read "+ SERVER_CONFIG_FILE_PATH);
			prop =Util.getPropertiesFile(SERVER_CONFIG_FILE_PATH);
			maximumActiveTime = prop.getProperty("proxool.maximum-active-time");
			if(maximumActiveTime == null) {
				maximumActiveTime = defaultTime;
			}
		} catch (Exception e) {
			maximumActiveTime = defaultTime;
		}
		
		Util.log("[ServerConstants] maximum active time : " + maximumActiveTime);
		
		return maximumActiveTime;
	}
}
