package org.objectweb.salome_tmf.server;

import java.util.Enumeration;

public class TransactionThread extends Thread {

	private static long TIMER = 1000 * 60; // une minute
	
	private static long TIMEOUT =  1000 * 60 * 60 * 2; // 2 heures
	
	private boolean stopThread = false;

	@Override
	public void run() {
		boolean end = false;

		while( !end ) {
			try {
				Thread.sleep(TIMER);
				
				closeTimeoutConnection();

				synchronized(this) {
					Thread.yield();

					// lecture du boolean 
					end = this.stopThread;
				} 
			} catch( InterruptedException e ) {

			}
		}
		
		closeAllConnections();
	} 

	public synchronized void finish() {
		this.stopThread = true;
	}
	
	private void closeAllConnections() {
		Enumeration<TransactionClient> tc = ApiFilter.getTransactionClient().elements();
		
		while(tc.hasMoreElements()) {
			TransactionClient transactionClient = tc.nextElement();
			try {
				ApiFilter.rollback(transactionClient.getKey());
				ApiFilter.closeClientConnection(transactionClient.getKey());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	private void closeTimeoutConnection() {
		Enumeration<TransactionClient> tc = ApiFilter.getTransactionClient().elements();
		
		while(tc.hasMoreElements()) {
			TransactionClient transactionClient = tc.nextElement();
			
			if((System.currentTimeMillis() - transactionClient.getTime()) > TIMEOUT) {
				try {
					ApiFilter.rollback(transactionClient.getKey());
					ApiFilter.closeClientConnection(transactionClient.getKey());
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
}
