/*
* SalomeTMF is a Test Management Framework
* Copyright (C) 2005 France Telecom R&D
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
* @author Marche Mikael
*
* Contact: mikael.marche@rd.francetelecom.com
*/

package org.objectweb.salome_tmf.soap;


import javax.xml.rpc.ServiceException;

import org.objectweb.salome_tmf.api.IChangeDispatcher;
import org.objectweb.salome_tmf.api.ISafeThread;
import org.objectweb.salome_tmf.api.sql.IDataBase;
import org.objectweb.salome_tmf.api.sql.ISQLAction;
import org.objectweb.salome_tmf.api.sql.ISQLAttachment;
import org.objectweb.salome_tmf.api.sql.ISQLAutomaticTest;
import org.objectweb.salome_tmf.api.sql.ISQLCampaign;
import org.objectweb.salome_tmf.api.sql.ISQLConfig;
import org.objectweb.salome_tmf.api.sql.ISQLDataset;
import org.objectweb.salome_tmf.api.sql.ISQLEngine;
import org.objectweb.salome_tmf.api.sql.ISQLEnvironment;
import org.objectweb.salome_tmf.api.sql.ISQLExecution;
import org.objectweb.salome_tmf.api.sql.ISQLExecutionActionResult;
import org.objectweb.salome_tmf.api.sql.ISQLExecutionResult;
import org.objectweb.salome_tmf.api.sql.ISQLExecutionTestResult;
import org.objectweb.salome_tmf.api.sql.ISQLFamily;
import org.objectweb.salome_tmf.api.sql.ISQLFileAttachment;
import org.objectweb.salome_tmf.api.sql.ISQLGroup;
import org.objectweb.salome_tmf.api.sql.ISQLManualTest;
import org.objectweb.salome_tmf.api.sql.ISQLObjectFactory;
import org.objectweb.salome_tmf.api.sql.ISQLParameter;
import org.objectweb.salome_tmf.api.sql.ISQLPersonne;
import org.objectweb.salome_tmf.api.sql.ISQLProject;
import org.objectweb.salome_tmf.api.sql.ISQLSalomeLock;
import org.objectweb.salome_tmf.api.sql.ISQLScript;
import org.objectweb.salome_tmf.api.sql.ISQLSession;
import org.objectweb.salome_tmf.api.sql.ISQLTest;
import org.objectweb.salome_tmf.api.sql.ISQLTestList;
import org.objectweb.salome_tmf.api.sql.ISQLUrlAttachment;

public class SQLObjectFactory implements ISQLObjectFactory {
	
//	static SQLManualTest pISQLManualTest = null;
	static ISQLManualTest pISQLManualTest = null;
//	static SQLAction pISQLAction = null;
	static ISQLAction pISQLAction = null;
	static ISQLParameter pISQLParameter = null;
	static ISQLAttachment pISQLAttachment = null;
	static ISQLUrlAttachment pISQLUrlAttachment = null;
	static ISQLFileAttachment pISQLFileAttachment  = null;
	static ISQLTestList pISQLTestList = null;
	static ISQLAutomaticTest pISQLAutomaticTest = null;
	static ISQLCampaign pISQLCampaign = null;
	static ISQLScript pISQLScript = null;
	static ISQLPersonne pISQLPersonne = null;
	static ISQLFamily pISQLFamily = null;
	static ISQLTest pISQLTest = null;
	static ISQLProject pISQLProject = null;
	static ISQLEnvironment pISQLEnvironment = null;
	static ISQLExecution pISQLExecution = null;
	static ISQLExecutionResult pISQLExecutionResult = null;
	static ISQLExecutionTestResult pISQLExecutionTestResult = null;
	static ISQLExecutionActionResult pISQLExecutionActionResult = null;
	static ISQLDataset pISQLDataset = null;
//	static SQLEngine pSQLEngine= null;
	static ISQLEngine pISQLEngine= null;
//	static ChangeListener pChangeListener = null;
	static ISQLSession pISQLSession = null;
	protected static ISQLGroup pSQLGroup = null;
	static protected ISQLConfig pSQLConfig = null;
	static ISQLSalomeLock pSQLSalomeLock = null;
	
//	static int projectID = 0;
//	static int personneID = 0;
//	DataBase pDB;
	
	static String version = "3.0";
	
	
	
	public ISQLEngine getInstanceOfSQLEngine(String url, String username, String password, IChangeDispatcher pIChangeDispatcher, int pid, String driverJDBC, int locktype) throws Exception {
//		if (pSQLEngine == null){
//			pDB = new DataBase(driverJDBC);
//			pDB.open(url, username, password);
//			pSQLEngine = new SQLEngine();
//			SQLEngine.initSQLEngine(pDB, true, null, locktype);
//			autoUpdateDB();
//			pChangeListener = new ChangeListener(pid, pIChangeDispatcher);
//		} else {
//			pDB = new DataBase(driverJDBC);
//			pDB.open(url, username, password);
//			pSQLEngine.initDB(pDB);
//		}
//		return pSQLEngine;
		if (pISQLEngine == null){
			try {
				pISQLEngine =  new ISQLEngineServiceLocator().getSQLEngine();
			} catch (ServiceException e) {}
		}
		return pISQLEngine;
//		return null;
	}
	
	void autoUpdateDB() throws Exception {
//		getInstanceOfISQLConfig();
//		String salome_version = pSQLConfig.getSalomeConf("VERSION");
//		if (salome_version != null ){
//			//Float floatVersion = Float.valueOf("salome_version");
//			version = salome_version;
//		} else {
//			 pSQLConfig.insertSalomeConf("VERSION", version);
//			 //Update DataBase 2.3 -> 3.0
//			 PreparedStatement statement = pSQLEngine.getSQLCommonQuery("addAssignedField");
//			 pSQLEngine.runUpdateQuery(statement);
//		}
	}
	
	
	public String getSalomeVersion() {
		try {
			version = pSQLConfig.getSalomeConf("VERSION");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return version +"[SOAP]";
	}
	
	public ISQLEngine getCurrentSQLEngine() {
		return pISQLEngine;
//		return null;
	}
	
	public IDataBase getInstanceOfDataBase(String driver) throws Exception{
//		DataBase db =  new DataBase(driver);
//		return (IDataBase)db;
		return null;
	}
	
	public IDataBase getInstanceOfSalomeDataBase()throws Exception{		
//		return (IDataBase) pDB;
		return null;
	}
	
	public ISafeThread getChangeListener(String projet) {
//		pChangeListener.setProjet(projet);
//		return pChangeListener;
		return null;
	}
	
	public void changeListenerProject(String projet){
//		pChangeListener.setProjet(projet);
	}
	
	
	public ISQLAction getISQLAction() {
		return getInstanceOfISQLAction();
	}
	static public ISQLAction getInstanceOfISQLAction() {
		if (pISQLAction == null) {
			try {
				pISQLAction =  new ISQLActionServiceLocator().getSQLAction();
			} catch (ServiceException e) {}
		}
		return pISQLAction;
	}
	
	public ISQLAttachment getISQLAttachment() {
		return getInstanceOfISQLAttachment();
	}
	static ISQLAttachment getInstanceOfISQLAttachment() {
		if (pISQLAttachment == null){
			try {
				pISQLAttachment =  new ISQLAttachmentServiceLocator().getSQLAttachment();
			} catch (ServiceException e) {}
		}
		return pISQLAttachment;
	}
	
	public ISQLAutomaticTest getISQLAutomaticTest() {
		return getInstanceOfISQLAutomaticTest();
	}
	static ISQLAutomaticTest getInstanceOfISQLAutomaticTest() {
		if (pISQLAutomaticTest == null){
			try {
				pISQLAutomaticTest =  new ISQLAutomaticTestServiceLocator().getSQLAutomaticTest();
			} catch (ServiceException e) {}
		}
		return pISQLAutomaticTest;
	}
	
	public ISQLCampaign getISQLCampaign() {
		return getInstanceOfISQLCampaign();
	}
	static ISQLCampaign getInstanceOfISQLCampaign() {
		if (pISQLCampaign == null){
			try {
				pISQLCampaign =  new ISQLCampaignServiceLocator().getSQLCampaign();
			} catch (ServiceException e) {}
		}
		return pISQLCampaign;
	}
	
	public ISQLConfig getISQLConfig(){
		return getInstanceOfISQLConfig();
	}
	static  ISQLConfig getInstanceOfISQLConfig() {
		if (pSQLConfig == null){
			try {
				pSQLConfig =  new ISQLConfigServiceLocator().getSQLConfig();
			} catch (ServiceException e) {}
		}
		return pSQLConfig;
	}
	
	public ISQLDataset getISQLDataset(){
		return getInstanceOfISQLDataset();
	}
	static  ISQLDataset getInstanceOfISQLDataset() {
		if (pISQLDataset == null){
			try {
				pISQLDataset =  new ISQLDatasetServiceLocator().getSQLDataset();
			} catch (ServiceException e) {}
		}
		return pISQLDataset;
	}
	
	public ISQLEnvironment getISQLEnvironment() {
		return getInstanceOfISQLEnvironment();
	}
	static ISQLEnvironment getInstanceOfISQLEnvironment() {
		if (pISQLEnvironment == null){
			try {
				pISQLEnvironment =  new ISQLEnvironmentServiceLocator().getSQLEnvironment();
			} catch (ServiceException e) {}
		}
		return pISQLEnvironment;
	}
	
	public ISQLExecution getISQLExecution() {
		return getInstanceOfISQLExecution();
	}
	static ISQLExecution getInstanceOfISQLExecution() {
		if (pISQLExecution == null){
			try {
				pISQLExecution =  new ISQLExecutionServiceLocator().getSQLExecution();
			} catch (ServiceException e) {}
		}
		return pISQLExecution;
	}
	
	public ISQLExecutionActionResult getISQLExecutionActionResult() {
		return getInstanceOfISQLExecutionActionResult();
	}
	static  ISQLExecutionActionResult getInstanceOfISQLExecutionActionResult() {
		if (pISQLExecutionActionResult == null){
			try {
				pISQLExecutionActionResult =  new ISQLExecutionActionResultServiceLocator().getSQLExecutionActionResult();
			} catch (ServiceException e) {}
		}
		return pISQLExecutionActionResult;
	}
	
	
	public ISQLExecutionResult getISQLExecutionResult() {
		return getInstanceOfISQLExecutionResult();
	}
	static ISQLExecutionResult getInstanceOfISQLExecutionResult() {
		if (pISQLExecutionResult == null){
			try {
				pISQLExecutionResult =  new ISQLExecutionResultServiceLocator().getSQLExecutionResult();
			} catch (ServiceException e) {}
		}
		return pISQLExecutionResult;
	}
	
	public ISQLExecutionTestResult getISQLExecutionTestResult() {
		return getInstanceOfISQLExecutionTestResult();
	}
	static  ISQLExecutionTestResult getInstanceOfISQLExecutionTestResult() {
		if (pISQLExecutionTestResult == null){
			try {
				pISQLExecutionTestResult =  new ISQLExecutionTestResultServiceLocator().getSQLExecutionTestResult();
			} catch (ServiceException e) {}
		}
		return pISQLExecutionTestResult;
	}
	
	
	public ISQLFamily getISQLFamily() {
		return getInstanceOfISQLFamily();
	}
	static ISQLFamily getInstanceOfISQLFamily() {
		if (pISQLFamily == null){
			try {
				pISQLFamily =  new ISQLFamilyServiceLocator().getSQLFamily();
			} catch (ServiceException e) {}
		}
		return pISQLFamily;
	}
	
	public ISQLFileAttachment getISQLFileAttachment() {
		return getInstanceOfISQLFileAttachment();
	}
	static ISQLFileAttachment getInstanceOfISQLFileAttachment() {
		if (pISQLFileAttachment == null){
			try {
				pISQLFileAttachment =  new ISQLFileAttachmentServiceLocator().getSQLFileAttachment();
			} catch (ServiceException e) {}
		}
		return pISQLFileAttachment;
	}
	
	public ISQLGroup getISQLGroup(){
		return getInstanceOfISQLGroup();
	}
	static  ISQLGroup getInstanceOfISQLGroup() {
		if (pSQLGroup == null){
			try {
				pSQLGroup =  new ISQLGroupServiceLocator().getSQLGroup();
			} catch (ServiceException e) {}
		}
		return pSQLGroup;
	}
	
	public ISQLManualTest getISQLManualTest() {
		return getInstanceOfISQLManualTest();
	}
	static public ISQLManualTest getInstanceOfISQLManualTest() {
		if (pISQLManualTest == null){
			try {
				pISQLManualTest =  new ISQLManualTestServiceLocator().getSQLManualTest();
			} catch (ServiceException e) {}
		}
		return pISQLManualTest;
	}
	
	public ISQLParameter getISQLParameter() {
		return getInstanceOfISQLParameter();
	}
	static ISQLParameter getInstanceOfISQLParameter(){
		if (pISQLParameter == null){
			try {
				pISQLParameter =  new ISQLParameterServiceLocator().getSQLParameter();
			} catch (ServiceException e) {}
		}
		return pISQLParameter;
	}
	
	public ISQLPersonne getISQLPersonne() {
		return getInstanceOfISQLPersonne();
	}
	static ISQLPersonne getInstanceOfISQLPersonne() {
		if (pISQLPersonne == null){
			try {
				pISQLPersonne =  new ISQLPersonneServiceLocator().getSQLPersonne();
			} catch (ServiceException e) {}
		}
		return pISQLPersonne;
	}
	
	public ISQLProject getISQLProject() {
		return getInstanceOfISQLProject();
	}
	static ISQLProject getInstanceOfISQLProject() {
		if (pISQLProject == null){
			try {
				pISQLProject =  new ISQLProjectServiceLocator().getSQLProject();
			} catch (ServiceException e) {}
		}
		return pISQLProject;
	}
	
	public ISQLSalomeLock getISQLSalomeLock(){
		return getInstanceOfISQLSalomeLock();
	}
	static  ISQLSalomeLock getInstanceOfISQLSalomeLock() {
		if (pSQLSalomeLock == null){
			try {
				pSQLSalomeLock =  new ISQLSalomeLockServiceLocator().getSQLSalomeLock();
			} catch (ServiceException e) {}
		}
		return pSQLSalomeLock;
	}
	
	public ISQLScript getISQLScript() {
		return getInstanceOfISQLScript();
	}
	static ISQLScript getInstanceOfISQLScript() {
		if (pISQLScript == null){
			try {
				pISQLScript =  new ISQLScriptServiceLocator().getSQLScript();
			} catch (ServiceException e) {}
		}
		return pISQLScript;
	}
	
	public ISQLSession getISQLSession(){
		return getInstanceOfISQLSession();
	}
	static  ISQLSession getInstanceOfISQLSession() {
		if (pISQLSession == null){
			try {
				pISQLSession =  new ISQLSessionServiceLocator().getSQLSession();
			} catch (ServiceException e) {}
		}
		return pISQLSession;
	}
	
	public ISQLTest getISQLTest() {
		return getInstanceOfISQLTest();
	}
	static ISQLTest getInstanceOfISQLTest() {
		if (pISQLTest == null){
			try {
				pISQLTest =  new ISQLTestServiceLocator().getSQLTest();
			} catch (ServiceException e) {}
		}
		return pISQLTest;
	}
	
	public ISQLTestList getISQLTestList() {
		return getInstanceOfISQLTestList();
	}
	static ISQLTestList getInstanceOfISQLTestList() {
		if (pISQLTestList == null){
			try {
				pISQLTestList =  new ISQLTestListServiceLocator().getSQLTestList();
			} catch (ServiceException e) {}
		}
		return pISQLTestList;
	}
	
	public ISQLUrlAttachment getISQLUrlAttachment() {
		return getInstanceOfISQLUrlAttachment();
	}
	static ISQLUrlAttachment getInstanceOfISQLUrlAttachment() {
		if (pISQLUrlAttachment == null){
			try {
				pISQLUrlAttachment =  new ISQLUrlAttachmentServiceLocator().getSQLUrlAttachment();
			} catch (ServiceException e) {}
		}
		return pISQLUrlAttachment;
	}
	
	public void setConnexionInfo(int _projectID, int _personneID){
//		projectID = _projectID;
//		personneID = _personneID;
//		pSQLEngine.setConnexionInfo(projectID, personneID);
	}
	
	public int getProjectID(){
//		return projectID;
		return -1;
	}
	
	public int getPersonneID(){
//		return personneID;
		return -1;
	}
	
}
