/*
* SalomeTMF is a Test Management Framework
* Copyright (C) 2005 France Telecom R&D
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
* @author Fayçal SOUGRATI, Vincent Pautret, Marche Mikael
*
* Contact: mikael.marche@rd.francetelecom.com
*/

package org.objectweb.salome_tmf.tools.encrypt_prop;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.Properties;
import java.util.StringTokenizer;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import org.objectweb.salome_tmf.tools.languages.Language;

public class configDBTool extends javax.swing.JFrame {
    
    File propFile = null;
    Properties prop = new Properties();
    boolean keyFileExists = true;
    URL urlDir = null;
    static boolean calledInInstallProc = false;
    static String installDir = null;
    public static String locale = "en";
    final static String DEFAULT_WITH_ICAL = "false" ;
    final static String DEFAULT_DB_LOCK = "0";
    final static String DEFAULT_LOCK_ON_TEST_EXEC = "false" ;
    final static String DEFAULT_LOCK_EXECUTED_TEST = "true" ;
    final static String DEFAULT_SQLENGINE_SOAP = "false" ;
    
    
    /** Creates new form EncryptDBPropTool */
    public configDBTool() {
        initComponents();
        cancelButton.setText(Language.getInstance().getText("Annuler"));
        debugField.setText("false");
        ideDevField.setText("false");
        allowPluginsField.setText("true");
        netChangeTackField.setText("false");
        //availableLocalsField.setText("fr,en");
        //this.setLocation(100,150);
        this.setLocationRelativeTo(this.getParent()); 
        if (calledInInstallProc) {
            chooseFileButton.setEnabled(false);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        propsFilePanel = new javax.swing.JPanel();
        propFileLabel = new javax.swing.JLabel();
        propFileField = new javax.swing.JTextField();
        chooseFileButton = new javax.swing.JButton();
        jdbcDriverLabel = new javax.swing.JLabel();
        jdbcDriverField = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        hostField = new javax.swing.JTextField();
        jPanel8 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        dbNameField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        dbUserLabel = new javax.swing.JLabel();
        dbUserField = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        userPwdLabel = new javax.swing.JLabel();
        userPwdField = new javax.swing.JPasswordField();
        sqlEngineLabel = new javax.swing.JLabel();
        sqlEngineField = new javax.swing.JTextField();
        jPanel15 = new javax.swing.JPanel();
	
	    debugField = new javax.swing.JTextField();
	    debugLabel = new javax.swing.JLabel();
	    ideDevField = new javax.swing.JTextField();
	    ideDevLabel = new javax.swing.JLabel();
	    allowPluginsField = new javax.swing.JTextField();
	    allowPluginsLabel = new javax.swing.JLabel();
	    netChangeTackField = new javax.swing.JTextField();
	    netChangeTackLabel = new javax.swing.JLabel();
	    /*availableLocalsField = new javax.swing.JTextField();
	    availableLocalsLabel = new javax.swing.JLabel();*/
	    	
        jPanel9 = new javax.swing.JPanel();
	jPanel10 = new javax.swing.JPanel();
	jPanel11 = new javax.swing.JPanel();
	jPanel12 = new javax.swing.JPanel();
	jPanel13 = new javax.swing.JPanel();
	jPanel14 = new javax.swing.JPanel();
        buttonsPanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        encryptButton = new javax.swing.JButton();
        createDBButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();

        setTitle(Language.getInstance().getText("Outil_de_configuration_de_la_base_de_donnees"));
        setLocationRelativeTo(this);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        propsFilePanel.setLayout(new java.awt.GridLayout(12, 3, 3, 3));

        propsFilePanel.setMinimumSize(new java.awt.Dimension(750, 350));
        propsFilePanel.setPreferredSize(new java.awt.Dimension(750, 350));
        propFileLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        propFileLabel.setText(Language.getInstance().getText("Fichier_de_configuration_"));
        propsFilePanel.add(propFileLabel);

        propFileField.setEditable(false);
        propsFilePanel.add(propFileField);

        chooseFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/objectweb/salome_tmf/tools/encrypt_prop/images/openFile.gif")));
        chooseFileButton.setText(Language.getInstance().getText("Ouvrir_un_fichier"));
        chooseFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chooseFilePerformed(evt);
            }
        });

        propsFilePanel.add(chooseFileButton);

        jdbcDriverLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jdbcDriverLabel.setText(Language.getInstance().getText("Driver_JDBC_"));
        propsFilePanel.add(jdbcDriverLabel);

        jdbcDriverField.setText("com.mysql.jdbc.Driver");
        propsFilePanel.add(jdbcDriverField);

        jPanel1.setLayout(new java.awt.BorderLayout());

        //jLabel3.setText("com.mysql.jdbc.Driver");
        jPanel1.add(jLabel3, java.awt.BorderLayout.WEST);

        //jLabel1.setText(Language.getInstance().getText("Exemple_"));
        jPanel1.add(jLabel1, java.awt.BorderLayout.NORTH);

        jPanel1.add(jLabel6, java.awt.BorderLayout.SOUTH);

        propsFilePanel.add(jPanel1);
        
        sqlEngineLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        sqlEngineLabel.setText("SQL Engine :");
        propsFilePanel.add(sqlEngineLabel);

        sqlEngineField.setText("org.objectweb.salome_tmf.databaseSQL.SQLObjectFactory");
        propsFilePanel.add(sqlEngineField);

        propsFilePanel.add(jPanel15);

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText(Language.getInstance().getText("Serveur_de_la_base_de_donnees_"));
        propsFilePanel.add(jLabel7);

        propsFilePanel.add(hostField);

        jPanel8.setLayout(new java.awt.BorderLayout());

        jLabel8.setText(Language.getInstance().getText("Exemple__"));
        jPanel8.add(jLabel8, java.awt.BorderLayout.NORTH);

        jLabel9.setText("lat****.rd.francetelecom.fr");
        jPanel8.add(jLabel9, java.awt.BorderLayout.CENTER);

        propsFilePanel.add(jPanel8);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText(Language.getInstance().getText("Nom_de_la_base_de_donnees_"));
        propsFilePanel.add(jLabel2);

        propsFilePanel.add(dbNameField);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel2.add(jLabel4, java.awt.BorderLayout.CENTER);

        propsFilePanel.add(jPanel2);

        dbUserLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        dbUserLabel.setText(Language.getInstance().getText("Nom_de_l_utilisateur_de_la_base_:"));
        propsFilePanel.add(dbUserLabel);

        propsFilePanel.add(dbUserField);

        propsFilePanel.add(jPanel3);

        userPwdLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        userPwdLabel.setText(Language.getInstance().getText("Mot_de_passe_de_l_utilisateur"));
        propsFilePanel.add(userPwdLabel);

        propsFilePanel.add(userPwdField);

        propsFilePanel.add(jPanel9);
	// Debug
	debugLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        debugLabel.setText(Language.getInstance().getText("Mode_debug_booleen_"));
        propsFilePanel.add(debugLabel);

        propsFilePanel.add(debugField);

        propsFilePanel.add(jPanel10);
	
	// IDE Dev
	ideDevLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        ideDevLabel.setText(Language.getInstance().getText("IDE_Dev_booleen_"));
        propsFilePanel.add(ideDevLabel);

        propsFilePanel.add(ideDevField);

        propsFilePanel.add(jPanel11);
	
	// Allow plugins
	allowPluginsLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        allowPluginsLabel.setText(Language.getInstance().getText("Autoriser_les_plugins_booleen_"));
        propsFilePanel.add(allowPluginsLabel);

        propsFilePanel.add(allowPluginsField);

        propsFilePanel.add(jPanel12);
	
        // Network changements tracking
        netChangeTackLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        netChangeTackLabel.setText(Language.getInstance().getText("Net_tracking_booleen_"));
        propsFilePanel.add(netChangeTackLabel);

        propsFilePanel.add(netChangeTackField);

        propsFilePanel.add(jPanel13);
        
        // Network changements tracking
        /*availableLocalsLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        availableLocalsLabel.setText(Language.getInstance().getText("Available_locales_fr_en_"));
        propsFilePanel.add(availableLocalsLabel);

        propsFilePanel.add(availableLocalsField);*/

        propsFilePanel.add(jPanel14);

        getContentPane().add(propsFilePanel, java.awt.BorderLayout.CENTER);

        buttonsPanel.setLayout(new java.awt.BorderLayout());

        encryptButton.setFont(new java.awt.Font("MS Sans Serif", 1, 11));
        encryptButton.setForeground(new java.awt.Color(0, 153, 0));
        encryptButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/objectweb/salome_tmf/tools/encrypt_prop/images/encrypt.gif")));
        encryptButton.setText(Language.getInstance().getText("Sauvegarder_fichier"));
        encryptButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                encryptPerformed(evt);
            }
        });

        jPanel4.add(encryptButton);

        createDBButton.setFont(new java.awt.Font("MS Sans Serif", 1, 11));
        createDBButton.setForeground(new java.awt.Color(0, 0, 255));
        createDBButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/objectweb/salome_tmf/tools/encrypt_prop/images/db.gif")));
        createDBButton.setText(Language.getInstance().getText("Creer_la_base_de_donnees"));
        createDBButton.setPreferredSize(new java.awt.Dimension(240, 41));
        createDBButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createDBPerformed(evt);
            }
        });

        jPanel4.add(createDBButton);

        cancelButton.setFont(new java.awt.Font("MS Sans Serif", 0, 10));
        cancelButton.setForeground(new java.awt.Color(255, 0, 0));
        cancelButton.setText(Language.getInstance().getText("Annuler"));
        cancelButton.setMinimumSize(new java.awt.Dimension(121, 41));
        cancelButton.setPreferredSize(new java.awt.Dimension(121, 41));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelPerformed(evt);
            }
        });

        jPanel4.add(cancelButton);

        buttonsPanel.add(jPanel4, java.awt.BorderLayout.CENTER);

        getContentPane().add(buttonsPanel, java.awt.BorderLayout.SOUTH);

        getContentPane().add(jPanel5, java.awt.BorderLayout.NORTH);

        getContentPane().add(jPanel6, java.awt.BorderLayout.EAST);

        getContentPane().add(jPanel7, java.awt.BorderLayout.WEST);

        pack();
    }//GEN-END:initComponents

    private void createDBPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createDBPerformed
        // TODO add your handling code here:
        createDBForm dbForm = new createDBForm(this);
        //dbForm.setHostName(hostField.getText()); 
        dbForm.setHostName("localhost");
        String driverJDBC = jdbcDriverField.getText();
        String sqlEngine = sqlEngineField.getText();
        String dbName = dbNameField.getText();
        String salomeUsr = dbUserField.getText();
        String clairPwd = new String(userPwdField.getPassword());
        //String salomeUsrPwd = new String(userPwdField.getPassword());
        
        if (jdbcDriverField.equals("")) {
            JOptionPane.showMessageDialog(this,
                    Language.getInstance().getText("Vous_devez_saisir_le_nom_du_driver_JDBC_"),
                    Language.getInstance().getText("Erreur"),
                    JOptionPane.ERROR_MESSAGE);
        } else {
            if (dbName.equals("")) {
                JOptionPane.showMessageDialog(this,
                    Language.getInstance().getText("Vous_devez_saisir_le_nom_de_la_base_de_donnees"),
                    Language.getInstance().getText("Erreur"),
                    JOptionPane.ERROR_MESSAGE);
            } else {
                if (salomeUsr.equals("")) {
                    JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Vous_devez_saisir_le_nom_de_l_utilisateur_de_Salome_TMF"),
                        Language.getInstance().getText("Erreur"),
                        JOptionPane.ERROR_MESSAGE);
                } else {
                    if (propFileField.getText().equals("")) {
                        JOptionPane.showMessageDialog(this,
                            Language.getInstance().getText("Vous_devez_ouvrir_et_creer_un_nouveau_fichier_properties_en_saisissant_les_") +
                            Language.getInstance().getText("champs_puis__cliquer_sur_le_bouton_Sauvegarder_fichier_avant_de_creer_\n") +
                            Language.getInstance().getText("la_base_de_donnees"),
                            Language.getInstance().getText("Erreur"),
                            JOptionPane.ERROR_MESSAGE);
                    } else {
                        dbForm.setJDBCdriver(driverJDBC);
                        dbForm.setDBName(dbName);
                        dbForm.setSalomeUser(salomeUsr);
                        dbForm.setSalomeUserPwd(clairPwd);
                        dbForm.show();
                    }
                }
            }
        }
        
    }//GEN-LAST:event_createDBPerformed

    private void encryptPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_encryptPerformed
        prop.setProperty("DriverJDBC",jdbcDriverField.getText());
        prop.setProperty("SQLEngine",sqlEngineField.getText());
        prop.setProperty("URL","jdbc:mysql://" + hostField.getText() + "/" + dbNameField.getText());
        prop.setProperty("User",dbUserField.getText());
        String clearKey = new String(userPwdField.getPassword());
        // New variables
        prop.setProperty("Debug",debugField.getText());
        prop.setProperty("IDE_Dev",ideDevField.getText());
        prop.setProperty("AllowPlugins",allowPluginsField.getText());
        prop.setProperty("NetChangeTrack",netChangeTackField.getText());
        //prop.setProperty("LocalesList",availableLocalsField.getText());
        //prop.setProperty("Locale",locale);
        
        // TODO add your handling code here:
        // Cas ou le fichier properties existe
        if (calledInInstallProc) {
            try {
                URL urlInstall = new File(installDir + java.io.File.separator + "cfg").toURL();
                MD5paswd.writekey(urlInstall.getPath());
                MD5paswd.readkey(urlInstall);
                String cryptedKey = MD5paswd.encrypString(clearKey);
                prop.setProperty("Password",cryptedKey);
            } catch (Exception e1) {
                e1.printStackTrace();
                JOptionPane.showMessageDialog(this,
                Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_de_lecture_de_la_cle_"),
                Language.getInstance().getText("Erreur"),
                JOptionPane.ERROR_MESSAGE);
            }
            try {
            	prop.setProperty("WithICAL",DEFAULT_WITH_ICAL);
            	prop.setProperty("DBLOCK",DEFAULT_DB_LOCK);
            	prop.setProperty("LockOnTestExec",DEFAULT_LOCK_ON_TEST_EXEC);
            	prop.setProperty("LockExecutedTest",DEFAULT_LOCK_EXECUTED_TEST);
            	prop.setProperty("SQLEngineSOAP",DEFAULT_SQLENGINE_SOAP);
                propFile = new File(installDir + java.io.File.separator + "cfg" + java.io.File.separator + "DB_Connexion.properties");
                OutputStream os = new DataOutputStream(new FileOutputStream(propFile));
                prop.store(os,"");

            } catch (Exception e2) {
                e2.printStackTrace();
                JOptionPane.showMessageDialog(this,
                Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_d_ecriture_sur_le_fichier_"),
                Language.getInstance().getText("Erreur"),
                JOptionPane.ERROR_MESSAGE);
            }
            JOptionPane.showMessageDialog(this,
                Language.getInstance().getText("Les_fichiers_de_configuration_de_la_base_et_de_la_cle_ont_ete_sauvegardes_dans_")
            		+ installDir + "/cfg/ !",
                Language.getInstance().getText("Info"),
                JOptionPane.INFORMATION_MESSAGE);
            propFileField.setText(propFile.getAbsolutePath());
            chooseFileButton.setEnabled(true);
        } else {
            if (!propFileField.getText().equals("")) {
                // Cas ou la cle de cryptage existe
                if (keyFileExists) {
                    try {
                        MD5paswd.readkey(urlDir);
                    } catch (Exception e1) {
                        e1.printStackTrace();
                        JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_de_lecture_de_la_cle_"),
                        Language.getInstance().getText("Erreur"),
                        JOptionPane.ERROR_MESSAGE);
                    }
                }
                // Cas ou cette cle n'existe pas
                else {
                    try {
                        MD5paswd.writekey(urlDir.getPath());
                        keyFileExists = true;
                        MD5paswd.readkey(urlDir);
                    } catch (Exception e1) {
                        e1.printStackTrace();
                        JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_d_ecriture_de_la_cle_"),
                        Language.getInstance().getText("Erreur"),
                        JOptionPane.ERROR_MESSAGE);
                    }

                }

                String cryptedKey = MD5paswd.encrypString(clearKey);
                prop.setProperty("Password",cryptedKey);

                try {
                    OutputStream os = new DataOutputStream(new FileOutputStream(propFile));
                    prop.store(os,"");
                    JOptionPane.showMessageDialog(this,
                    Language.getInstance().getText("Le_fichier_a_bien_ete_sauvegarde_"),
                    Language.getInstance().getText("Info"),
                    JOptionPane.INFORMATION_MESSAGE);
                } catch (Exception e2) {
                    e2.printStackTrace();
                    JOptionPane.showMessageDialog(this,
                    Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_d_ecriture_du_fichier"),
                    Language.getInstance().getText("Erreur"),
                    JOptionPane.ERROR_MESSAGE);
                }
            }
            // Cas ou le fichier properties n'existe pas
            else {
                JOptionPane.showMessageDialog(this,
                Language.getInstance().getText("Vous_devez_choisir_un_repertoire_ou_le_DB_Connexion_properties_") +
                Language.getInstance().getText("_et_key_txt_seront_sauves"),
                Language.getInstance().getText("Info"),
                JOptionPane.INFORMATION_MESSAGE);

                JFileChooser fileChooser = new JFileChooser();
                fileChooser.setApproveButtonText(Language.getInstance().getText("Valider"));
                fileChooser.setCurrentDirectory(new File("."));
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int returnVal = fileChooser.showOpenDialog(configDBTool.this);
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    try {
                        urlDir = fileChooser.getSelectedFile().toURL();
                        MD5paswd.writekey(urlDir.getPath());
                        keyFileExists = true;
                        MD5paswd.readkey(urlDir);
                        String cryptedKey = MD5paswd.encrypString(clearKey);
                        prop.setProperty("Password",cryptedKey);
                    } catch (Exception e1) {
                        e1.printStackTrace();
                        JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_de_lecture_de_la_cle"),
                        Language.getInstance().getText("Erreur"),
                        JOptionPane.ERROR_MESSAGE);
                    }
                    try {
                    	prop.setProperty("WithICAL",DEFAULT_WITH_ICAL);
                    	prop.setProperty("DBLOCK",DEFAULT_DB_LOCK);
                    	prop.setProperty("LockOnTestExec",DEFAULT_LOCK_ON_TEST_EXEC);
                    	prop.setProperty("LockExecutedTest",DEFAULT_LOCK_EXECUTED_TEST);
                    	prop.setProperty("SQLEngineSOAP",DEFAULT_SQLENGINE_SOAP);
                        propFile = new File(fileChooser.getSelectedFile().getPath() + java.io.File.separator + "DB_Connexion.properties");
                        OutputStream os = new DataOutputStream(new FileOutputStream(propFile));
                        prop.store(os,"");

                    } catch (Exception e2) {
                        e2.printStackTrace();
                        JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_d_ecriture_de_la_cle"),
                        Language.getInstance().getText("Erreur"),
                        JOptionPane.ERROR_MESSAGE);
                    }
                    JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Le_fichier_de_configuration_de_la_base_et_la_cle_ont_bien_ete_sauvegardes_"),
                        Language.getInstance().getText("Info"),
                        JOptionPane.INFORMATION_MESSAGE);
                    propFileField.setText(propFile.getAbsolutePath());
                }
            }
        }
    }//GEN-LAST:event_encryptPerformed

    private void cancelPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelPerformed
        // TODO add your handling code here:
        this.dispose();
    }//GEN-LAST:event_cancelPerformed

    private void chooseFilePerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chooseFilePerformed
        // TODO add your handling code here:
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setApproveButtonText(Language.getInstance().getText("Valider"));
        fileChooser.setCurrentDirectory(new File("."));
        FileFilter[] fileFilterTab = fileChooser.getChoosableFileFilters();
        for (int i = 0; i < fileFilterTab.length; i++) {
                fileChooser.removeChoosableFileFilter(fileFilterTab[i]);
        }
        fileChooser.addChoosableFileFilter(new PropsFileFilter("Properties file [*.properties]",".properties"));
        int returnVal = fileChooser.showOpenDialog(configDBTool.this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
                propFile = fileChooser.getSelectedFile();	
                propFileField.setText(propFile.getAbsolutePath());
                URL urlFile = null;
                
                try {
                    urlFile = propFile.toURL();
                    InputStream in = urlFile.openStream();
                    prop.load(in);
                    in.close();
                } catch (Exception e1) {
                    e1.printStackTrace();
                    JOptionPane.showMessageDialog(this,
                                                  Language.getInstance().getText("Problemes_rencontres_suite_a_la_tentative_de_lecture_du_fichier"),
                                                  Language.getInstance().getText("Erreur"),
                                                  JOptionPane.ERROR_MESSAGE);
                }
                
                jdbcDriverField.setText(prop.getProperty("DriverJDBC"));
                String dbURL = prop.getProperty("URL");
                StringTokenizer st = new StringTokenizer(dbURL, "/", false);
                int length = st.countTokens();
                String[] blocks = new String[length];
                int i = 0;
                for (; st.hasMoreTokens();) {
                    blocks[i] = st.nextToken().trim();
                    i++;
                }
                dbNameField.setText(blocks[length-1]);
                hostField.setText(blocks[length-2]);    
                dbUserField.setText(prop.getProperty("User"));
                String cryptedPwd = prop.getProperty("Password");
                
                //New varaiables
                debugField.setText(prop.getProperty("Debug"));
                ideDevField.setText(prop.getProperty("IDE_Dev"));
                allowPluginsField.setText(prop.getProperty("AllowPlugins"));
                netChangeTackField.setText(prop.getProperty("NetChangeTrack"));
                
                //availableLocalsField.setText(prop.getProperty("LocalesList"));
                
                String urlFileTxt = urlFile.toString();
                try {
                    urlDir = new URL(urlFileTxt.substring(0,urlFileTxt.lastIndexOf("/")));
                    MD5paswd.readkey(urlDir);
                    String pwd = MD5paswd.decryptString(cryptedPwd);
                    userPwdField.setText(pwd);
                } catch (Exception e3) {
                    e3.printStackTrace();
                    JOptionPane.showMessageDialog(this,
                                                  Language.getInstance().getText("Le_fichier_key_txt_n_existe_pas_") +
                                                  Language.getInstance().getText("Le_mot_de_passe_ne_peut_etre_decrypte_mais_vous_pouvez_le_changer_") +
                                                  Language.getInstance().getText("Le_fichier_key_txt_sera_cree"),
                                                  Language.getInstance().getText("Avertissement___"),
                                                  JOptionPane.WARNING_MESSAGE);
                    keyFileExists = false;
                    userPwdField.setText("");
                }
                
        } 
    }//GEN-LAST:event_chooseFilePerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        if (args.length == 2) {
            calledInInstallProc = true;
            installDir = args[0];
            if (args[1].equals("fra")) {
            	locale = "fr";
            } else if (args[1].equals("eng")) {
            	locale = "en";
            }
        } 
        new configDBTool().show();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonsPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton chooseFileButton;
    private javax.swing.JButton createDBButton;
    private javax.swing.JTextField dbNameField;
    private javax.swing.JTextField dbUserField;
    private javax.swing.JLabel dbUserLabel;
    private javax.swing.JButton encryptButton;
    private javax.swing.JTextField hostField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JTextField jdbcDriverField;
    private javax.swing.JLabel jdbcDriverLabel;
    private javax.swing.JTextField propFileField;
    private javax.swing.JLabel propFileLabel;
    private javax.swing.JPanel propsFilePanel;
    private javax.swing.JPasswordField userPwdField;
    private javax.swing.JLabel userPwdLabel;
    private javax.swing.JLabel sqlEngineLabel;
    private javax.swing.JTextField sqlEngineField;
    
    private javax.swing.JTextField debugField;
    private javax.swing.JLabel debugLabel;
    private javax.swing.JTextField ideDevField;
    private javax.swing.JLabel ideDevLabel;
    private javax.swing.JTextField allowPluginsField;
    private javax.swing.JLabel allowPluginsLabel;
    private javax.swing.JTextField netChangeTackField;
    private javax.swing.JLabel netChangeTackLabel;
    /*private javax.swing.JTextField availableLocalsField;
    private javax.swing.JLabel availableLocalsLabel;*/
    // End of variables declaration//GEN-END:variables
    
}
