/*
* SalomeTMF is a Test Management Framework
* Copyright (C) 2005 France Telecom R&D
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
* @author Fayçal SOUGRATI, Vincent Pautret, Marche Mikael
*
* Contact: mikael.marche@rd.francetelecom.com
*/

package org.objectweb.salome_tmf.tools.encrypt_prop;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.StringTokenizer;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import org.objectweb.salome_tmf.tools.languages.Language;

public class createDBForm extends JDialog {
    
    File scriptFile = null;
    String jdbcDriver = null;
    String dbName = null;
    String salomeUser = null;
    String salomeUserPwd = null;
    javax.swing.JFrame parent = null;
    
    /** Creates new form createDBForm */
    public createDBForm(javax.swing.JFrame parent) {
    	super(parent,true);
    	this.parent = parent;
    	initComponents();
        //this.setLocation(150,150);
        this.setLocationRelativeTo(this.getParent()); 
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel5 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        buttonsPanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        createDBButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        propsFilePanel = new javax.swing.JPanel();
        propFileLabel = new javax.swing.JLabel();
        scriptFileField = new javax.swing.JTextField();
        chooseFileButton = new javax.swing.JButton();
        jdbcDriverLabel = new javax.swing.JLabel();
        dbHostField = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        rootField = new javax.swing.JTextField();
        jPanel8 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        pwdField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();

        setTitle(Language.getInstance().getText("Parametres_de_creation_d_une_base_de_donnees_Salome_TMF"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        getContentPane().add(jPanel5, java.awt.BorderLayout.NORTH);

        getContentPane().add(jPanel7, java.awt.BorderLayout.WEST);

        getContentPane().add(jPanel6, java.awt.BorderLayout.EAST);

        buttonsPanel.setLayout(new java.awt.BorderLayout());

        createDBButton.setFont(new java.awt.Font("MS Sans Serif", 1, 11));
        createDBButton.setForeground(new java.awt.Color(0, 0, 255));
        createDBButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/objectweb/salome_tmf/tools/encrypt_prop/images/db.gif")));
        createDBButton.setText(Language.getInstance().getText("Creer_base_de_donnees"));
        createDBButton.setPreferredSize(new java.awt.Dimension(240, 41));
        createDBButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createDBPerformed(evt);
            }
        });

        jPanel4.add(createDBButton);

        cancelButton.setFont(new java.awt.Font("MS Sans Serif", 0, 10));
        cancelButton.setForeground(new java.awt.Color(255, 0, 0));
        cancelButton.setText(Language.getInstance().getText("Annuler"));
        cancelButton.setMinimumSize(new java.awt.Dimension(121, 41));
        cancelButton.setPreferredSize(new java.awt.Dimension(121, 41));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelPerformed(evt);
            }
        });

        jPanel4.add(cancelButton);

        buttonsPanel.add(jPanel4, java.awt.BorderLayout.CENTER);

        getContentPane().add(buttonsPanel, java.awt.BorderLayout.SOUTH);

        propsFilePanel.setLayout(new java.awt.GridLayout(5, 3, 3, 3));

        propsFilePanel.setMinimumSize(new java.awt.Dimension(400, 300));
        propsFilePanel.setPreferredSize(new java.awt.Dimension(700, 200));
        propFileLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        propFileLabel.setText(Language.getInstance().getText("Script_pour_la_creation_de_la_base_"));
        propsFilePanel.add(propFileLabel);

        scriptFileField.setEditable(false);
        propsFilePanel.add(scriptFileField);

        chooseFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/objectweb/salome_tmf/tools/encrypt_prop/images/openFile.gif")));
        chooseFileButton.setText(Language.getInstance().getText("Ouvrir_un_fichier"));
        chooseFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openScriptPerformed(evt);
            }
        });

        propsFilePanel.add(chooseFileButton);

        jdbcDriverLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jdbcDriverLabel.setText(Language.getInstance().getText("Serveur_de_la_base_de_donnees_"));
        propsFilePanel.add(jdbcDriverLabel);

        propsFilePanel.add(dbHostField);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jLabel3.setText("lat****.rd.francetelecom.fr");
        jPanel1.add(jLabel3, java.awt.BorderLayout.WEST);

        jLabel1.setText(Language.getInstance().getText("Exemple_"));
        jPanel1.add(jLabel1, java.awt.BorderLayout.NORTH);

        jPanel1.add(jLabel6, java.awt.BorderLayout.SOUTH);

        propsFilePanel.add(jPanel1);

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText(Language.getInstance().getText("root_MySQL"));
        propsFilePanel.add(jLabel7);

        rootField.setText("root");
        rootField.setToolTipText("");
        propsFilePanel.add(rootField);

        jPanel8.setLayout(new java.awt.BorderLayout());

        jPanel8.add(jLabel9, java.awt.BorderLayout.CENTER);

        propsFilePanel.add(jPanel8);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText(Language.getInstance().getText("Mot_de_passe_root_"));
        propsFilePanel.add(jLabel2);

        propsFilePanel.add(pwdField);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel2.add(jLabel4, java.awt.BorderLayout.CENTER);

        propsFilePanel.add(jPanel2);

        propsFilePanel.add(jLabel8);

        propsFilePanel.add(jPanel3);

        getContentPane().add(propsFilePanel, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void cancelPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelPerformed
        // TODO add your handling code here:
        this.dispose();
    }//GEN-LAST:event_cancelPerformed

    private void createDBPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createDBPerformed
        String host = dbHostField.getText();
        String root = rootField.getText();
        String pwd = pwdField.getText();
        // TODO add your handling code here:
        if (scriptFile == null) {
            JOptionPane.showMessageDialog(this,
                    Language.getInstance().getText("Vous_devez_choisir_un_fichier_contenant_le_script_de_creation_de_la_base_de_donnees_"),
                    Language.getInstance().getText("Erreur"),
                    JOptionPane.ERROR_MESSAGE);
        } else {
            if (host == null) {
                JOptionPane.showMessageDialog(this,
                    Language.getInstance().getText("Vous_devez_saisir_le_nom_du_serveur_de_la_base_de_donnees_MySQL_"),
                    Language.getInstance().getText("Erreur"),
                    JOptionPane.ERROR_MESSAGE);
            } else {
                if (root == null) {
                    JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Vous_devez_saisir_le_nom_du_root_MySQL_"),
                        Language.getInstance().getText("Erreur"),
                        JOptionPane.ERROR_MESSAGE);
                } else {
                    try {
                        Class.forName(jdbcDriver).newInstance();
                        Connection cnt = openDB(host,"mysql",root,pwd);
                        Statement stmt = cnt.createStatement();
                        // CREATE SALOME DATABASE
                        stmt.execute("CREATE DATABASE " + dbName + ";");
                        // ALLOWS USER5 SALOME
                        stmt = cnt.createStatement();
                        stmt.execute("GRANT SELECT,INSERT,UPDATE,DELETE,INDEX, ALTER,CREATE,DROP, "+
                                    "LOCK TABLES, CREATE TEMPORARY TABLES,REFERENCES " +
                                    "ON " + dbName + ".* TO " + salomeUser + "@'%'" +
                                    "IDENTIFIED BY '" + salomeUserPwd + "';");   
                        stmt.execute("GRANT SELECT,INSERT,UPDATE,DELETE,INDEX, ALTER,CREATE,DROP, "+
                                    "LOCK TABLES, CREATE TEMPORARY TABLES,REFERENCES " +
                                    "ON " + dbName + ".* TO " + salomeUser + "@'localhost'" +
                                    "IDENTIFIED BY '" + salomeUserPwd + "';");   
                        stmt.execute("FLUSH PRIVILEGES;");  
                        //cnt = openDB("localhost", dbName, salomeUser, salomeUserPwd);
                        cnt = openDB(host, dbName, root, pwd);
                        // CREATE TABLE
                        String table_script = loadScript();
                        StringTokenizer st = new StringTokenizer(table_script,";");
                        while (st.hasMoreTokens()) {
                            stmt = cnt.createStatement();
                            stmt.execute(st.nextToken()); 
                        }
                        
                        // Setting the default language
                        
                        updateLocale(cnt,configDBTool.locale);
                        
                        JOptionPane.showMessageDialog(this,
                            Language.getInstance().getText("La_base_de_donnees_") + " " + dbName + " " + Language.getInstance().getText("_a_ete_creee_avec_succes"),
                            Language.getInstance().getText("Info"),
                            JOptionPane.INFORMATION_MESSAGE);
                        cnt.close();
                        this.dispose();
                        parent.dispose();

                    }catch (SQLException ex) {
                        ex.printStackTrace();
                        JOptionPane.showMessageDialog(this,
                            Language.getInstance().getText("Echec_de_creation_de_la_base_")+ dbName +" " +ex.getMessage(),
                            Language.getInstance().getText("Erreur"),
                            JOptionPane.ERROR_MESSAGE);
                        
                    }catch (Exception e) {
                        e.printStackTrace();
                        JOptionPane.showMessageDialog(this,
                            Language.getInstance().getText("Echec_de_creation_de_la_base_")+ dbName +" " +e.getMessage(),
                            Language.getInstance().getText("Erreur"),
                            JOptionPane.ERROR_MESSAGE);
                    }
                }
            }
        }
    }//GEN-LAST:event_createDBPerformed
    
    private void updateLocale(Connection cnt, String locale) {
    	String updateLocaleStmt = 	"UPDATE CONFIG " +
		"SET VALEUR = '" + locale + "',  id_projet = '0', id_personne = '0' " +
		"WHERE binary CLE = 'Locale' AND id_projet = '0' AND id_personne = '0'";
    	
    	try {
    		Statement stmt = cnt.createStatement();
    		stmt.execute(updateLocaleStmt);
    	} catch (Exception e) {
    		//Util.log("[createDBForm] Problem when updating Locale");
    		e.printStackTrace();
    	}
    }
    
    Connection openDB(String host, String db, String user, String password) throws SQLException{
        try {
                String url = "jdbc:mysql://"+host+"/"+db;
                System.out.println(Language.getInstance().getText("Tentative_d_ouverture_de_l_url_")+ url);
		Connection cnt = DriverManager.getConnection(url,user, password);
                return cnt;
	} catch (SQLException ex) {
                JOptionPane.showMessageDialog(this,
                        Language.getInstance().getText("Echec_de_la_tentative_d_ouverture_de_la_base_en_root_")+ex.getMessage(),
                        Language.getInstance().getText("Erreur"),
                        JOptionPane.ERROR_MESSAGE);
		throw ex;
        }
    }
    
    String loadScript() throws Exception{
        String sql="";
        try {
            String buf;
            BufferedReader br = new BufferedReader(new FileReader(scriptFile));
            while ((buf = br.readLine()) != null) {  
                sql += buf;
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this,
                    Language.getInstance().getText("Echec_de_la_lecture_du_script_de_la_base_de_donnees__") +e.getMessage(),
                    Language.getInstance().getText("Erreur"),
                    JOptionPane.ERROR_MESSAGE);
            throw e;
        }
        return sql;
    }
    
    private void openScriptPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openScriptPerformed
        // TODO add your handling code here:
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setApproveButtonText(Language.getInstance().getText("Valider"));
        if (configDBTool.calledInInstallProc) {
            String pathToScripts = configDBTool.installDir + java.io.File.separator + "bdd_model";
            fileChooser.setCurrentDirectory(new File(pathToScripts));
        } else {
            fileChooser.setCurrentDirectory(new File("."));
        }
        fileChooser.addChoosableFileFilter(new PropsFileFilter("SQL File [*.sql]",".sql"));
        int returnVal = fileChooser.showOpenDialog(createDBForm.this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
                scriptFile = fileChooser.getSelectedFile();	
                scriptFileField.setText(scriptFile.getAbsolutePath());
        }
    }//GEN-LAST:event_openScriptPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    void setHostName(String host) {
        dbHostField.setText(host);
    }
    
    void setJDBCdriver(String driver) {
        jdbcDriver = driver;
    }
    
    void setDBName(String db) {
        dbName = db;
    }
    
    void setSalomeUser(String user) {
        salomeUser = user;
    }
    
    void setSalomeUserPwd(String pwd) {
        salomeUserPwd = pwd;
    }
    
    
    /**
     * @param args the command line arguments
     */
    /*
    public static void main(String args[]) {
        new createDBForm().show();
    }*/
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonsPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton chooseFileButton;
    private javax.swing.JButton createDBButton;
    private javax.swing.JTextField dbHostField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JLabel jdbcDriverLabel;
    private javax.swing.JLabel propFileLabel;
    private javax.swing.JPanel propsFilePanel;
    private javax.swing.JTextField pwdField;
    private javax.swing.JTextField rootField;
    private javax.swing.JTextField scriptFileField;
    // End of variables declaration//GEN-END:variables
    
}
