package salomeTMF_plug.requirements.ihm;

import java.awt.Cursor;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Observer;
import java.util.Vector;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.objectweb.salome_tmf.ihm.languages.Language;
import org.objectweb.salome_tmf.ihm.main.SalomeTMF;
import org.objectweb.salome_tmf.ihm.main.SalomeTMFContext;
import org.objectweb.salome_tmf.ihm.main.SalomeTMFPanels;

import salomeTMF_plug.requirements.data.IReqFilter;

public class InfoFiltrePanel extends JPanel implements ActionListener{
	
	JComboBox catBox;
	Vector itemCat;
	
	JComboBox complexeBox;
	Vector itemComplex;
	
	JComboBox stateBox;
	Vector itemState;
	
	int catSelected = -1;
	int complexSelected = -1;
	int stateSelected = -1;
	
	IReqFilter m_ReqFilter;
	FilterReqTreeModel m_FilterReqTreeModel;
	Observer pObserver = null;
	
	InfoFiltrePanel(FilterReqTreeModel _FilterReqTreeModel,  Observer _pObserver){
		super();
		m_FilterReqTreeModel = _FilterReqTreeModel;
		if (m_FilterReqTreeModel != null) {
			m_ReqFilter = m_FilterReqTreeModel.getFilter();
		}
		pObserver = _pObserver;
		initCompnent();
	}
	void initCompnent(){
		setLayout(new GridLayout(2, 3));
		itemCat = new Vector();
		itemCat.add(Language.getInstance().getText("Tout"));
		itemCat.add(Language.getInstance().getText("Cat_Fonctionnel"));
		itemCat.add(Language.getInstance().getText("Cat_Interoperabilite"));
		itemCat.add(Language.getInstance().getText("Cat_Charge"));
		itemCat.add(Language.getInstance().getText("Cat_Performance"));
		itemCat.add(Language.getInstance().getText("Cat_Disponibilite"));
		itemCat.add(Language.getInstance().getText("Cat_Securite"));
		itemCat.add(Language.getInstance().getText("Cat_Exploitabilite"));
		itemCat.add(Language.getInstance().getText("Cat_Autre"));

		itemState = new Vector();
		itemState.add(Language.getInstance().getText("Tout"));
		itemState.add(Language.getInstance().getText("State_A_Analyser"));
		itemState.add(Language.getInstance().getText("State_Analysee"));
		itemState.add(Language.getInstance().getText("State_Approuvee"));
		itemState.add(Language.getInstance().getText("State_Verifiee"));
		itemState.add(Language.getInstance().getText("State_Finalisee"));
		itemState.add(Language.getInstance().getText("State_Reportee"));
		itemState.add(Language.getInstance().getText("State_Abandonnee"));
		
		itemComplex = new Vector();
		itemComplex.add(Language.getInstance().getText("Tout"));
		itemComplex.add(Language.getInstance().getText("Com_C0"));
		itemComplex.add(Language.getInstance().getText("Com_C1"));
		itemComplex.add(Language.getInstance().getText("Com_C2"));
		itemComplex.add(Language.getInstance().getText("Com_C3"));
		
		JLabel labelCat = new JLabel(Language.getInstance().getText("Categorie") + " :");
		catBox = new JComboBox(itemCat);
		catBox.setEditable(false);
		catBox.addActionListener(this);
		
		JLabel labelComplexe = new JLabel(Language.getInstance().getText("Complexite")+ " :");
		complexeBox = new JComboBox(itemComplex);
		complexeBox.setEditable(false);
		complexeBox.addActionListener(this);
		
		JLabel labelState = new JLabel(Language.getInstance().getText("Etat")+ " :");
		stateBox = new JComboBox(itemState);
		stateBox.setEditable(false);
		stateBox.addActionListener(this);
		
		add(labelCat);
		add(labelComplexe);
		add(labelState);
		add(catBox);
		add(complexeBox);
		add(stateBox);
		//setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.BLACK),"Filtre"));
		
	}
	
	public void actionPerformed(ActionEvent e){
		if (e.getSource().equals(stateBox)){
			//stateBoxPerformed(e);
			stateSelected = stateBox.getSelectedIndex() - 1;
		} else if (e.getSource().equals(complexeBox)){
			//complexeBoxPerformed(e);
			complexSelected = complexeBox.getSelectedIndex() - 1;
		} else if (e.getSource().equals(catBox)){
			//catBoxPerformed(e);
			catSelected = catBox.getSelectedIndex() - 1;
		} 
		applyFilter();
	}

	void applyFilter(){
		if (m_ReqFilter != null){
			SalomeTMFContext.getInstance().getSalomeFrame().setCursor(new Cursor(Cursor.WAIT_CURSOR));
			m_ReqFilter.setInfoFiltre(catSelected, complexSelected, stateSelected);
			m_FilterReqTreeModel.setFiltered(true);
			if (pObserver != null){
				pObserver.update(null, new ReqEvent(ReqEvent.FILTRE_REQ_CHANGE,null));
			}
			SalomeTMFContext.getInstance().getSalomeFrame().setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		
	}
	
	void reInit(boolean filter){
		catSelected = -1;
		catBox.setSelectedIndex(0);
		complexSelected = -1;
		complexeBox.setSelectedIndex(0);
		stateSelected = -1;
		stateBox.setSelectedIndex(0);
		if (filter){
			m_ReqFilter.reInit();
		}
	}
	
	public int getCatSelected() {
		return catSelected;
	}
	public int getComplexSelected() {
		return complexSelected;
	}
	public int getStateSelected() {
		return stateSelected;
	}
	
}
