/*
* SalomeTMF is a Test Management Framework
* Copyright (C) 2005 France Telecom R&D
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
* @author Marche Mikael
*
* Contact: mikael.marche@rd.francetelecom.com
*/

package salomeTMF_plug.requirements.sqlWrapper;

import java.util.Hashtable;

import org.objectweb.salome_tmf.api.data.DataWrapper;
import org.objectweb.salome_tmf.ihm.languages.Language;

public class ReqWrapper extends DataWrapper {
	int parent_id;
	int type;
	int project_id;
	
	//From 1.2
	String version = "1";
	int priority = 100;
	
	//FROM 1.3
	int cat = 0;
	int complexe = 100;
	String origine = "Marketing";
	int state = 0;
	String verif = "";
	String reference ="";
	
	static Hashtable catMap;
	static Hashtable stateMap;
	static Hashtable complexMap;
	static {
		catMap = new Hashtable();
		catMap.put(new Integer(0), Language.getInstance().getText("Cat_Fonctionnel"));
		catMap.put(new Integer(1), Language.getInstance().getText("Cat_Interoperabilite"));
		catMap.put(new Integer(2), Language.getInstance().getText("Cat_Charge"));
		catMap.put(new Integer(3), Language.getInstance().getText("Cat_Performance"));
		catMap.put(new Integer(4), Language.getInstance().getText("Cat_Disponibilite"));
		catMap.put(new Integer(5), Language.getInstance().getText("Cat_Securite"));
		catMap.put(new Integer(6), Language.getInstance().getText("Cat_Exploitabilite"));
		catMap.put(new Integer(7), Language.getInstance().getText("Cat_Autre"));

		stateMap = new Hashtable(); 
		stateMap.put(new Integer(0),Language.getInstance().getText("State_A_Analyser"));
		stateMap.put(new Integer(1),Language.getInstance().getText("State_Analysee"));
		stateMap.put(new Integer(2),Language.getInstance().getText("State_Approuvee"));
		stateMap.put(new Integer(3),Language.getInstance().getText("State_Verifiee"));
		stateMap.put(new Integer(4),Language.getInstance().getText("State_Finalisee"));
		stateMap.put(new Integer(5),Language.getInstance().getText("State_Reportee"));
		stateMap.put(new Integer(6),Language.getInstance().getText("State_Abandonnee"));

		complexMap = new Hashtable();
		complexMap.put(new Integer(1000),Language.getInstance().getText("Com_C0"));
		complexMap.put(new Integer(100),Language.getInstance().getText("Com_C1"));
		complexMap.put(new Integer(10),Language.getInstance().getText("Com_C2"));
		complexMap.put(new Integer(1),Language.getInstance().getText("Com_C3"));
	}
	
	static public String getComplexString(int i){
		return (String) complexMap.get(new Integer(i));
	}
	
	static public String getCatString(int i){
		return (String) catMap.get(new Integer(i));
	}
	
	static public String getStateString(int i){
		return (String) stateMap.get(new Integer(i));
	}
	
	public int getParent_id() {
		return parent_id;
	}
	public void setParent_id(int parent_id) {
		this.parent_id = parent_id;
	}
	public int getProject_id() {
		return project_id;
	}
	public void setProject_id(int project_id) {
		this.project_id = project_id;
	}
	public int getType() {
		return type;
	}
	public void setType(int type) {
		this.type = type;
	}
	
	
	//FROM 1.2
	public int getPriority() {
		return priority;
	}
	public void setPriority(int priority) {
		this.priority = priority;
	}
	public String getVersion() {
		return version;
	}
	public void setVersion(String version) {
		this.version = version;
	}
	
	public String getReference() {
		return reference;
	}
	public void setReference(String reference) {
		this.reference = reference;
	}
	
	//From 1.3
	public int getCat() {
		return cat;
	}
	public void setCat(int cat) {
		this.cat = cat;
	}
	public int getComplexe() {
		return complexe;
	}
	public void setComplexe(int complexe) {
		this.complexe = complexe;
	}
	public String getOrigine() {
		return origine;
	}
	public void setOrigine(String origine) {
		this.origine = origine;
	}
	public int getState() {
		return state;
	}
	public void setState(int state) {
		this.state = state;
	}
	public String getVerif() {
		return verif;
	}
	public void setVerif(String verif) {
		this.verif = verif;
	}
	
	public boolean equals(Object o){
		if (o instanceof ReqWrapper ) {
			ReqWrapper other = (ReqWrapper)o;
			return (getIdBDD() == other.getIdBDD());
		} else {
			return false;
		}
	}
	
	public int hashCode(){
		if (getIdBDD() > 0 ){
			return getIdBDD();
		}
		return super.hashCode();
	}
	
}
